#<profile4xi profile = "12" />
# =================================================================================================
#<program4xi program = "opu2kernel4xi.py">
#<abstract4xi abstract = "OPU kernel management"/>
#<refer4xi reference = "kernel4xi.py"/>
#<verify4xi verification = "10" target = "opu2kernel4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API  
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'OPU2Kernel4Xi',                       # ACK 5.7.1  p157    

            'add2kernel4opu',                      # ACK               

            'execute2kernel4opu',                  # ACK 5.8    p169                                             
            'execute2task4opu',                    # ACK 5.8    p172   
            'execute2nativekernel4opu',            # ACK 5.8    p174     
            
            'create2kernel4opu',                   # ACK 5.7.1  p157   
            'create2kernelsinprogram4opu',         # ACK 5.7.1  p158  
                       
            'delete2kernel4opu',                   # ACK

            'fetch2kernel4opu',                    # ACK 
            
            'get2kernelinfo4opu',                  # ACK 5.7.3  p162  
            'get2kernelworkgroupinfo4opu',         # ACK 5.7.3  p164  
            'get2kernelarginfo4opu',               # ACK 5.7.3  p166                                  
            
            'release2kernel4opu',                  # ACK 5.7.1  p159                                         
            'retain2kernel4opu',                   # ACK 5.7.1  p159   
 
            'set2kernel4opu',                      # ACK 
            'set2kernelcallback4opu',              # ACK 
            'set2kernelarg4opu',                   # ACK 5.7.2  p160 
                                          
            'trace2kernel4opu'                     # ACK 

          ] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   
from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi

# -------------------------------------------------------------------------------------------------
# Buffer                           
# -------------------------------------------------------------------------------------------------
from opu2buffer4xi import get2bufferinfo4opu

# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from opu2commandqueue4xi import OPU2CommandQueue4Xi
from opu2commandqueue4xi import create2commandqueue4opu 
from opu2commandqueue4xi import flush2commandqueue4opu
from opu2commandqueue4xi import finish2commandqueue4opu
from opu2commandqueue4xi import get2commandqueueinfo4opu
from opu2commandqueue4xi import release2commandqueue4opu
from opu2commandqueue4xi import retain2commandqueue4opu
from opu2commandqueue4xi import set2commandqueue4opu
from opu2commandqueue4xi import trace2commandqueue4opu

# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from opu2context4xi import OPU2Context4Xi 
from opu2context4xi import create2context4opu
from opu2context4xi import get2context4opu
from opu2context4xi import release2context4opu
from opu2context4xi import retain2context4opu
from opu2context4xi import set2context4opu


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from opu2device4xi import OPU4Xi
from opu2device4xi import init2opu4xi 
from opu2device4xi import set2opu4xi
from opu2device4xi import get2opu4xi

# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from opu2event4xi import OPU2Event4Xi
from opu2event4xi import create2event4opu
from opu2event4xi import get2eventinfo4opu
from opu2event4xi import release2event4opu
from opu2event4xi import retain2event4opu
from opu2event4xi import set2eventcallback4opu 
from opu2event4xi import set2event4opu
from opu2event4xi import trace2event4opu
from opu2event4xi import wait2event4opu


# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platformids4xi  import get2platformids4xi
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Program module                           
# -------------------------------------------------------------------------------------------------
from opu2program4xi import OPU2Program4Xi
from opu2program4xi import add2programwithsource4opu
from opu2program4xi import add2programwithbinary4opu
from opu2program4xi import build2program4opu
from opu2program4xi import compile2program4opu
from opu2program4xi import create2programwithsource4opu
from opu2program4xi import create2programwithbinary4opu
from opu2program4xi import delete2programwithsource4opu
from opu2program4xi import delete2programwithbinary4opu
from opu2program4xi import get2programinfo4opu
# from opu2program4xi import get2programbuildinfo4opu
from opu2program4xi import link2program4opu
from opu2program4xi import release2program4opu
from opu2program4xi import retain2program4opu
from opu2program4xi import set2programcallback4opu 
from opu2program4xi import set2programwithsource4opu
from opu2program4xi import set2programwithbinary4opu
from opu2program4xi import trace2program4opu
# from opu2program4xi import unload2compiler4opu

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from arena4xi import Arena4Xi
from cpu_corecount4xi import cpu_corecount4xi
from dummyprocess4xi import DummyProcess4Xi
from print4xi import print4xi
from pipe4xi import Pipe4Xi
from process4xi import Process4Xi
from queue4xi import Queue4Xi  
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                         
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global opu2kernel4xi                                                    # Kernel of OPU
global opu2build4xi                                                     # Build of OPU
global opu2compile4xi                                                   # Compile of OPU
global opu2trace4xi                                                     # TRACE

global fetch2code4opu                                                   # Fetched code

global import2use4opu                                                   # Imports of target function for Process4Xi

global kb2fetch4opu                                                     # Knowledgebase for fetching
global kb2kernel4opu                                                    # Knowledgebase for kernel   

global folder2lib4opu                                                   # Folder of OPU library

global profile2fetch                                                       # Profile knowledgebase for fetching
global keys2profile4opu

global target2function4opu                                              # Target function for Process4Xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
temp2opu = 'opu'
key2dir = temp2opu[0]                                                                                               # MORE COMPLICATED WAY DUE TO AUTOMATIC SOFTWARE GENERATION
folder2lib4opu = VersionKB4Xi[key2dir] 

profile2fetch = {}                                                                                                  # PROFILES FOR FETCHING
profile2fetch ['.py']  = 'ACK'                                                                                    
profile2fetch ['.pyc'] = 'ACK'                                                                                    
profile2fetch ['.cpp'] = 'ACK'                                                                                   
profile2fetch ['.exe'] = 'ACK'       
keys2profile4opu = profile2fetch.keys()

kb2fetch4opu = {}                                                                                                   # PROGRAMS TO BE FETCHED - ALWAYS DEFINE BOTH SOURCE AND BINARY PAIRS                               
kb2fetch4opu[1] = folder2lib4opu + 'opu2sampler4xi5test.py'                                                         # Python code
kb2fetch4opu[2] = folder2lib4opu + '__pycache__//opu2sampler4xi.cpython-33.pyc'   
kb2fetch4opu[3] = folder2lib4opu + 'opu2dummy4xi5test.cpp'                                                          # C++ code
kb2fetch4opu[4] = folder2lib4opu + "bin//opu2dummy4xi5test.exe"                                                     # C++ binary

# kb2fetch4opu[1]  = folder2lib4opu + 'opu2sampler4xi5test.py'                                                      
# kb2fetch4opu[2]  = folder2lib4opu + '__pycache__//opu2sampler4xi.cpython-33.pyc'                                  
# kb2fetch4opu[3]  = folder2lib4opu + 'opu2image4xi5test.py'
# kb2fetch4opu[4]  = folder2lib4opu + '__pycache__//opu2image4xi.cpython-33.pyc'
# kb2fetch4opu[5]  = folder2lib4opu + 'opu3image4xi5test.py'
# kb2fetch4opu[6]  = folder2lib4opu + '__pycache__//opu3image4xi.cpython-33.pyc'
# kb2fetch4opu[7]  = folder2lib4opu + 'opu2commandqueue4xi5test.py'
# kb2fetch4opu[8]  = folder2lib4opu + '__pycache__//opu2commandqueue4xi.cpython-33.pyc'
# kb2fetch4opu[9]  = folder2lib4opu + 'opu2event4xi5test.py'
# kb2fetch4opu[10] = folder2lib4opu + '__pycache__//opu2event4xi.cpython-33.pyc'
# kb2fetch4opu[10]  = folder2lib4opu + 'OPU2kernel4xi5test.py'
# kb2fetch4opu[11] = folder2lib4opu + '__pycache__//opu2program.cpython-33.pyc'

fetch2code4opu = {}                                                                                                 # reception arena in memory for code

kb2kernel4opu = {}
kb2kernel4opu ['.py'] = {}
kb2kernel4opu ['.py'] ['TAG']            = "<function4xi function ="                                                
#</function4xi>                                                                                                     # added for parsing!
kb2kernel4opu ['.py'] ['VALUE']          = "opu2sampler4xi5test" 
kb2kernel4opu ['.py'] ['ATTRIBUTE']      = 'usage = "' 

kb2kernel4opu ['.cpp'] = {}
kb2kernel4opu ['.cpp'] ['TAG']            = "<function4xi function ="                                               
#</function4xi>                                                                                                     # added for parsing!
kb2kernel4opu ['.cpp'] ['VALUE']          = "opu2dummy4xi5test" 
kb2kernel4opu ['.cpp'] ['ATTRIBUTE']      = 'usage = "kernel'                                                       

#"/>

# -------------------------------------------------------------------------------------------------
# Command queue module of OPU imports for target function                           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2commandqueue4opu" usage = " importing target function for Process4Xi">
def importcreate2commandqueue4opu():
   global target2function4opu
   from opu2commandqueue4xi import create2commandqueue4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importflush2commandqueue4opu" usage = " importing target function for Process4Xi">
def importflush2commandqueue4opu():
   global target2function4opu
   from opu2commandqueue4xi import flush2commandqueue4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importfinish2commandqueue4opu" usage = " importing target function for Process4Xi">
def importfinish2commandqueue4opu():
   global target2function4opu
   from opu2commandqueue4xi import finish2commandqueue4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importget2commandqueueinfo4opu" usage = " importing target function for Process4Xi">
def importget2commandqueueinfo4opu():
   global target2function4opu
   from opu2commandqueue4xi import get2commandqueueinfo4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importrelease2commandqueue4opu" usage = " importing target function for Process4Xi">
def importrelease2commandqueue4opu():
   global target2function4opu
   from opu2commandqueue4xi import release2commandqueue4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importretain2commandqueue4opu" usage = " importing target function for Process4Xi">
def importretain2commandqueue4opu():
   global target2function4opu
   from opu2commandqueue4xi import retain2commandqueue4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importset2commandqueue4opu" usage = " importing target function for Process4Xi">
def importset2commandqueue4opu():
   global target2function4opu
   from opu2commandqueue4xi import set2commandqueue4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importtrace2commandqueue4opu" usage = " importing target function for Process4Xi">
def importtrace2commandqueue4opu():
   global target2function4opu
   from opu2commandqueue4xi import trace2commandqueue4opu as target2function4opu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Context module of OPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2context4opu" usage = " importing target function for Process4Xi">
def importcreate2context4opu():
   global target2function4opu
   from opu2context4xi import create2context4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importget2context4opu" usage = " importing target function for Process4Xi">
def importget2context4opu():
   global target2function4opu
   from opu2context4xi import get2context4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importrelease2context4opu" usage = " importing target function for Process4Xi">
def importrelease2context4opu():
   global target2function4opu
   from opu2context4xi import release2context4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importretain2context4opu" usage = " importing target function for Process4Xi">
def importretain2context4opu():
   global target2function4opu
   from opu2context4xi import retain2context4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importset2context4opu" usage = " importing target function for Process4Xi">
def importset2context4opu():
   global target2function4opu
   from opu2context4xi import set2context4opu as target2function4opu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# Device module of OPU imports for target function                           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importinit2opu4xi" usage = " importing target function for Process4Xi">
def importinit2opu4xi():
   global target2function4opu
   from opu2device4xi import init2opu4xi as target2function4opu 
#</function4xi>
 
#<function4xi function = "importset2opu4xi" usage = " importing target function for Process4Xi">
def importset2opu4xi():
   global target2function4opu
   from opu2device4xi import set2opu4xi   as target2function4opu
#</function4xi>
 
#<function4xi function = "importget2opu4xi" usage = " importing target function for Process4Xi">
def importget2opu4xi():
   global target2function4opu
   from opu2device4xi import get2opu4xi   as target2function4opu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Event module of OPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2event4opu" usage = " importing target function for Process4Xi">
def importcreate2event4opu():
   global target2function4opu
   from opu2event4xi import create2event4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importget2eventinfo4opu" usage = " importing target function for Process4Xi">
def importget2eventinfo4opu():
   global target2function4opu
   from opu2event4xi import get2eventinfo4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importrelease2event4opu" usage = " importing target function for Process4Xi">
def importrelease2event4opu():
   global target2function4opu
   from opu2event4xi import release2event4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importretain2event4opu" usage = " importing target function for Process4Xi">
def importretain2event4opu():
   global target2function4opu
   from opu2event4xi import retain2event4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importset2eventcallback4opu" usage = " importing target function for Process4Xi">
def importset2eventcallback4opu():
   global target2function4opu
   from opu2event4xi import set2eventcallback4opu as target2function4opu 
#</function4xi>
 
#<function4xi function = "importset2event4opu" usage = " importing target function for Process4Xi">
def importset2event4opu():
   global target2function4opu
   from opu2event4xi import set2event4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importtrace2event4opu" usage = " importing target function for Process4Xi">
def importtrace2event4opu():
   global target2function4opu
   from opu2event4xi import trace2event4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importwait2event4opu" usage = " importing target function for Process4Xi">
def importwait2event4opu():
   global target2function4opu
   from opu2event4xi import wait2event4opu as target2function4opu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# 2D Image module of OPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2image4opu" usage = " importing target function for Process4Xi">
def importcreate2image4opu():
   global target2function4opu
   from opu2image4xi import create2image4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importget2imageinfo4opu" usage = " importing target function for Process4Xi">
def importget2imageinfo4opu():
   global target2function4opu
   from opu2image4xi import get2imageinfo4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importget2supportedimageformats4opu" usage = " importing target function for Process4Xi">
def importget2supportedimageformats4opu():
   global target2function4opu
   from opu2image4xi import get2supportedimageformats4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copyimage4opu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copyimage4opu():
   global target2function4opu
   from opu2image4xi import manoeuvre2copyimage4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copyimagetobuffer4opu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copyimagetobuffer4opu():
   global target2function4opu
   from opu2image4xi import manoeuvre2copyimagetobuffer4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copybuffertoimage4opu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copybuffertoimage4opu():
   global target2function4opu
   from opu2image4xi import manoeuvre2copybuffertoimage4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2readimage4opu" usage = " importing target function for Process4Xi">
def importmanoeuvre2readimage4opu():
   global target2function4opu
   from opu2image4xi import manoeuvre2readimage4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2writeimage4opu" usage = " importing target function for Process4Xi">
def importmanoeuvre2writeimage4opu():
   global target2function4opu
   from opu2image4xi import manoeuvre2writeimage4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2mapimage4opu" usage = " importing target function for Process4Xi">
def importmanoeuvre2mapimage4opu():
   global target2function4opu
   from opu2image4xi import manoeuvre2mapimage4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importcopy2image4opu" usage = " importing target function for Process4Xi">
def importcopy2image4opu():
   global target2function4opu
   from opu2image4xi import copy2image4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importcopy2imagetobuffer4opu" usage = " importing target function for Process4Xi">
def importcopy2imagetobuffer4opu():
   global target2function4opu
   from opu2image4xi import copy2imagetobuffer4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importcopy2buffertoimage4opu" usage = " importing target function for Process4Xi">
def importcopy2buffertoimage4opu():
   global target2function4opu
   from opu2image4xi import copy2buffertoimage4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importread2image4opu" usage = " importing target function for Process4Xi">
def importread2image4opu():
   global target2function4opu
   from opu2image4xi import read2image4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importmap2image4opu" usage = " importing target function for Process4Xi">
def importmap2image4opu():
   global target2function4opu
   from opu2image4xi import map2image4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importrelease2image4opu" usage = " importing target function for Process4Xi">
def importrelease2image4opu():
   global target2function4opu
   from opu2image4xi import release2image4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importretain2image4opu" usage = " importing target function for Process4Xi">
def importretain2image4opu():
   global target2function4opu
   from opu2image4xi import retain2image4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importset2imagecallback4opu" usage = " importing target function for Process4Xi">
def importset2imagecallback4opu():
   global target2function4opu
   from opu2image4xi import set2imagecallback4opu as target2function4opu 
#</function4xi>
 
#<function4xi function = "importset2image4opu" usage = " importing target function for Process4Xi">
def importset2image4opu():
   global target2function4opu
   from opu2image4xi import set2image4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importtrace2image4opu" usage = " importing target function for Process4Xi">
def importtrace2image4opu():
   global target2function4opu
   from opu2image4xi import trace2image4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importwait2image4opu" usage = " importing target function for Process4Xi">
def importwait2image4opu():
   global target2function4opu
   from opu2image4xi import wait2image4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importwrite2image4opu" usage = " importing target function for Process4Xi">
def importwrite2image4opu():
   global target2function4opu
   from opu2image4xi import write2image4opu as target2function4opu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# 3D Image module of OPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate3image4opu" usage = " importing target function for Process4Xi">
def importcreate3image4opu():
   global target2function4opu
   from opu3image4xi import create3image4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importget3imageinfo4opu" usage = " importing target function for Process4Xi">
def importget3imageinfo4opu():
   global target2function4opu
   from opu3image4xi import get3imageinfo4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importget3supportedimageformats4opu" usage = " importing target function for Process4Xi">
def importget3supportedimageformats4opu():
   global target2function4opu
   from opu3image4xi import get3supportedimageformats4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copyimage4opu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copyimage4opu():
   global target2function4opu
   from opu3image4xi import manoeuvre3copyimage4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copyimagetobuffer4opu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copyimagetobuffer4opu():
   global target2function4opu
   from opu3image4xi import manoeuvre3copyimagetobuffer4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copybuffertoimage4opu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copybuffertoimage4opu():
   global target2function4opu
   from opu3image4xi import manoeuvre3copybuffertoimage4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3readimage4opu" usage = " importing target function for Process4Xi">
def importmanoeuvre3readimage4opu():
   global target2function4opu
   from opu3image4xi import manoeuvre3readimage4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3writeimage4opu" usage = " importing target function for Process4Xi">
def importmanoeuvre3writeimage4opu():
   global target2function4opu
   from opu3image4xi import manoeuvre3writeimage4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3mapimage4opu" usage = " importing target function for Process4Xi">
def importmanoeuvre3mapimage4opu():
   global target2function4opu
   from opu3image4xi import manoeuvre3mapimage4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importcopy3image4opu" usage = " importing target function for Process4Xi">
def importcopy3image4opu():
   global target2function4opu
   from opu3image4xi import copy3image4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importcopy3imagetobuffer4opu" usage = " importing target function for Process4Xi">
def importcopy3imagetobuffer4opu():
   global target2function4opu
   from opu3image4xi import copy3imagetobuffer4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importcopy3buffertoimage4opu" usage = " importing target function for Process4Xi">
def importcopy3buffertoimage4opu():
   global target2function4opu
   from opu3image4xi import copy3buffertoimage4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importread3image4opu" usage = " importing target function for Process4Xi">
def importread3image4opu():
   global target2function4opu
   from opu3image4xi import read3image4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importmap3image4opu" usage = " importing target function for Process4Xi">
def importmap3image4opu():
   global target2function4opu
   from opu3image4xi import map3image4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importrelease3image4opu" usage = " importing target function for Process4Xi">
def importrelease3image4opu():
   global target2function4opu
   from opu3image4xi import release3image4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importretain3image4opu" usage = " importing target function for Process4Xi">
def importretain3image4opu():
   global target2function4opu
   from opu3image4xi import retain3image4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importset3imagecallback4opu" usage = " importing target function for Process4Xi">
def importset3imagecallback4opu():
   global target2function4opu
   from opu3image4xi import set3imagecallback4opu as target2function4opu 
#</function4xi>
 
#<function4xi function = "importset3image4opu" usage = " importing target function for Process4Xi">
def importset3image4opu():
   global target2function4opu
   from opu3image4xi import set3image4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importtrace3image4opu" usage = " importing target function for Process4Xi">
def importtrace3image4opu():
   global target2function4opu
   from opu3image4xi import trace3image4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importwait3image4opu" usage = " importing target function for Process4Xi">
def importwait3image4opu():
   global target2function4opu
   from opu3image4xi import wait3image4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importwrite3image4opu" usage = " importing target function for Process4Xi">
def importwrite3image4opu():
   global target2function4opu
   from opu3image4xi import write3image4opu as target2function4opu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Sampler module of OPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2sampler4opu" usage = " importing target function for Process4Xi">
def importcreate2sampler4opu():
   global target2function4opu
   from opu2sampler4xi import create2sampler4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importget2samplerinfo4opu" usage = " importing target function for Process4Xi">
def importget2samplerinfo4opu():
   global target2function4opu
   from opu2sampler4xi import get2samplerinfo4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importrelease2sampler4opu" usage = " importing target function for Process4Xi">
def importrelease2sampler4opu():
   global target2function4opu
   from opu2sampler4xi import release2sampler4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importretain2sampler4opu" usage = " importing target function for Process4Xi">
def importretain2sampler4opu():
   global target2function4opu
   from opu2sampler4xi import retain2sampler4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importset2samplercallback4opu" usage = " importing target function for Process4Xi">
def importset2samplercallback4opu():
   global target2function4opu
   from opu2sampler4xi import set2samplercallback4opu as target2function4opu 
#</function4xi>
 
#<function4xi function = "importset2sampler4opu" usage = " importing target function for Process4Xi">
def importset2sampler4opu():
   global target2function4opu
   from opu2sampler4xi import set2sampler4opu as target2function4opu
#</function4xi>
 
#<function4xi function = "importtrace2sampler4opu" usage = " importing target function for Process4Xi">
def importtrace2sampler4opu():
   global target2function4opu
   from opu2sampler4xi import trace2sampler4opu as target2function4opu
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
# Program module of OPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2programwithsource4opu" usage = " importing target function for Process4Xi">
def importcreate2programwithsource4opu():
   global target2function4opu
   from opu2kernel4xi import create2programwithsource4opu as target2function4opu
#</function4xi> 

#<function4xi function = "importcreate2programwithbinary4opu" usage = " importing target function for Process4Xi">
def importcreate2programwithbinary4opu():
   global target2function4opu
   from opu2kernel4xi import create2programwithbinary4opu as target2function4opu
#</function4xi> 

#<function4xi function = "importadd2programwithsource4opu" usage = " importing target function for Process4Xi">
def importadd2programwithsource4opu():
   global target2function4opu
   from opu2kernel4xi import add2programwithsource4opu as target2function4opu
#</function4xi> 

#<function4xi function = "importadd2programwithbinary4opu" usage = " importing target function for Process4Xi">
def importadd2programwithbinary4opu():
   global target2function4opu
   from opu2kernel4xi import add2programwithbinary4opu as target2function4opu
#</function4xi>

#<function4xi function = "importbuild2program4opu" usage = " importing target function for Process4Xi">
def importbuild2program4opu():
   global target2function4opu
   from opu2kernel4xi import build2program4opu as target2function4opu
#</function4xi>

#<function4xi function = "importbuild2program4opu" usage = " importing target function for Process4Xi">
def importbuild2program4opu():
   global target2function4opu
   from opu2kernel4xi import build2program4opu as target2function4opu
#</function4xi>

#<function4xi function = "importcompile2program4opuX" usage = " importing target function for Process4Xi">
def importcompile2program4opu():
   global target2function4opu
   from opu2kernel4xi import compile2program4opu as target2function4opu
#</function4xi>

#<function4xi function = "importdelete2programwithsource4opuX" usage = " importing target function for Process4Xi">
def importdelete2programwithsource4opu():
   global target2function4opu
   from opu2kernel4xi import delete2programwithsource4opu as target2function4opu
#</function4xi>    

#<function4xi function = "importdelete2programwithbinary4opuX" usage = " importing target function for Process4Xi">
def importdelete2programwithbinary4opu():
   global target2function4opu
   from opu2kernel4xi import delete2programwithbinary4opu as target2function4opu
#</function4xi>    

#<function4xi function = "importget2programinfo4opuX" usage = " importing target function for Process4Xi">
def importget2programinfo4opu():
   global target2function4opu
   from opu2kernel4xi import get2programinfo4opu as target2function4opu
#</function4xi>    

#<function4xi function = "importlink2program4opuX" usage = " importing target function for Process4Xi">
def importlink2program4opu():
   global target2function4opu
   from opu2kernel4xi import link2program4opu as target2function4opu
#</function4xi>    

#<function4xi function = "importrelease2program4opuX" usage = " importing target function for Process4Xi">
def importrelease2program4opu():
   global target2function4opu
   from opu2kernel4xi import release2program4opu as target2function4opu
#</function4xi>    

#<function4xi function = "importretain2program4opuX" usage = " importing target function for Process4Xi">
def importretain2program4opu():
   global target2function4opu
   from opu2kernel4xi import retain2program4opu as target2function4opu
#</function4xi>    

#<function4xi function = "importset2programcallback4opuX" usage = " importing target function for Process4Xi">
def importset2programcallback4opu():
   global target2function4opu
   from opu2kernel4xi import set2programcallback4opu as target2function4opu
#</function4xi>    

#<function4xi function = "importset2programwithsource4opuX" usage = " importing target function for Process4Xi">
def importset2programwithsource4opu():
   global target2function4opu
   from opu2kernel4xi import set2programwithsource4opu as target2function4opu
#</function4xi>    

#<function4xi function = "importset2programwithbinary4opuX" usage = " importing target function for Process4Xi">
def importset2programwithbinary4opu():
   global target2function4opu
   from opu2kernel4xi import set2programwithbinary4opu as target2function4opu
#</function4xi>    

#<function4xi function = "importtrace2program4opuX" usage = " importing target function for Process4Xi">
def importtrace2program4opu():
   global target2function4opu
   from opu2kernel4xi import trace2program4opu as target2function4opu
#</function4xi>    

# -------------------------------------------------------------------------------------------------
# Test modules of OPU imports for target function                             
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importopu2commandqueue4xi5test" usage = " importing target function for Process4Xi">
def importopu2commandqueue4xi5test():
   global target2function4opu
   from opu2commandqueue4xi5test import opu2commandqueue4xi5test as target2function4opu
#</function4xi> 

#<function4xi function = "importopu2event4xi5test" usage = " importing target function for Process4Xi">
def importopu2event4xi5test():
   global target2function4opu
   from opu2event4xi5test import opu2event4xi5test as target2function4opu
#</function4xi>
 
#<function4xi function = "importopu2image4xi5test" usage = " importing target function for Process4Xi">
def importopu2image4xi5test():
   global target2function4opu
   from opu2image4xi5test import opu2image4xi5test as target2function4opu
#</function4xi>
 
#<function4xi function = "importopu3image4xi5test" usage = " importing target function for Process4Xi">
def importopu3image4xi5test():
   global target2function4opu
   from opu3image4xi5test import opu3image4xi5test as target2function4opu
#</function4xi>
 
#<function4xi function = "importopu2sampler4xi5test" usage = " importing target function for Process4Xi">
def importopu2sampler4xi5test():
   global target2function4opu
   from opu2sampler4xi5test import opu2sampler4xi5test as target2function4opu
#</function4xi>
 
#<function4xi function = "importOPU2kernel4xi5test" usage = " importing target function for Process4Xi">
def importopu2kernel4xi5test():
   global target2function4opu
   from opu2kernel4xi5test import opu2kernel4xi5test as target2function4opu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# Error handler of OPU imports for target function                             
# -------------------------------------------------------------------------------------------------
#<function4xi function = "handle2error4opu" usage = " Error handling for importing target function for Process4Xi">
def handle2error4opu():
   global import2use4opu
   print ("HANDLE2ERROR4OPU OF OPU2KERNEL4XI.PY: *** FAILED TO IMPORT TARGET FUNCTION ***")
   keys2import4opu = import2use4opu.keys()
   for key2import4opu in keys2import4opu:
       print(key2import4opu,import2use4opu[key2import4opu]) 
#</function4xi> 


import2use4opu = {}
# -------------------------------------------------------------------------------------------------
# Command queue module of OPU imports for target function                           
# -------------------------------------------------------------------------------------------------
import2use4opu["create2commandqueue4opu"] = importcreate2commandqueue4opu        
import2use4opu["flush2commandqueue4opu"] = importflush2commandqueue4opu 
import2use4opu["finish2commandqueue4opu"] = importfinish2commandqueue4opu 
import2use4opu["get2commandqueueinfo4opu"] = importget2commandqueueinfo4opu 
import2use4opu["release2commandqueue4opu"] = importrelease2commandqueue4opu 
import2use4opu["retain2commandqueue4opu"] = importretain2commandqueue4opu 
import2use4opu["set2commandqueue4opu"] = importset2commandqueue4opu 
import2use4opu["trace2commandqueue4opu"] = importtrace2commandqueue4opu 

# -------------------------------------------------------------------------------------------------
# Context module of OPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4opu["create2context4opu"] = importcreate2context4opu 
import2use4opu["get2context4opu"] = importget2context4opu 
import2use4opu["release2context4opu"] = importrelease2context4opu 
import2use4opu["retain2context4opu"] = importretain2context4opu 
import2use4opu["set2context4opu"] = importset2context4opu 

# -------------------------------------------------------------------------------------------------
# Device module of OPU imports for target function                           
# -------------------------------------------------------------------------------------------------
import2use4opu["init2opu4xi"] = importinit2opu4xi 
import2use4opu["set2opu4xi"] = importset2opu4xi 
import2use4opu["get2opu4xi"] = importget2opu4xi 

# -------------------------------------------------------------------------------------------------
# Event module of OPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4opu["create2event4opu"] = importcreate2event4opu 
import2use4opu["get2eventinfo4opu"] = importget2eventinfo4opu 
import2use4opu["release2event4opu"] = importrelease2event4opu 
import2use4opu["retain2event4opu"] = importretain2event4opu 
import2use4opu["set2eventcallback4opu"] = importset2eventcallback4opu 
import2use4opu["set2event4opu"] = importset2event4opu 
import2use4opu["trace2event4opu"] = importtrace2event4opu 
import2use4opu["wait2event4opu"] = importwait2event4opu 

# -------------------------------------------------------------------------------------------------
# 2D Image module of OPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4opu["create2image4opu"] = importcreate2image4opu 
import2use4opu["get2imageinfo4opu"] = importget2imageinfo4opu 
import2use4opu["get2supportedimageformats4opu"] = importget2supportedimageformats4opu 
import2use4opu["manoeuvre2copyimage4opu"] = importmanoeuvre2copyimage4opu 
import2use4opu["manoeuvre2copyimagetobuffer4opu"] = importmanoeuvre2copyimagetobuffer4opu 
import2use4opu["manoeuvre2copybuffertoimage4opu"] = importmanoeuvre2copybuffertoimage4opu 
import2use4opu["manoeuvre2readimage4opu"] = importmanoeuvre2readimage4opu 
import2use4opu["manoeuvre2writeimage4opu"] = importmanoeuvre2writeimage4opu 
import2use4opu["manoeuvre2mapimage4opu"] = importmanoeuvre2mapimage4opu 
import2use4opu["copy2image4opu"] = importcopy2image4opu 
import2use4opu["copy2imagetobuffer4opu"] = importcopy2imagetobuffer4opu 
import2use4opu["copy2buffertoimage4opu"] = importcopy2buffertoimage4opu 
import2use4opu["read2image4opu"] = importread2image4opu 
import2use4opu["map2image4opu"] = importmap2image4opu 
import2use4opu["release2image4opu"] = importrelease2image4opu 
import2use4opu["retain2image4opu"] = importretain2image4opu 
import2use4opu["set2imagecallback4opu"] = importset2imagecallback4opu 
import2use4opu["set2image4opu"] = importset2image4opu 
import2use4opu["trace2image4opu"] = importtrace2image4opu 
import2use4opu["wait2image4opu"] = importwait2image4opu 
import2use4opu["write2image4opu"] = importwrite2image4opu 

# -------------------------------------------------------------------------------------------------
# 3D Image module of OPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4opu["create3image4opu"] = importcreate3image4opu 
import2use4opu["get3imageinfo4opu"] = importget3imageinfo4opu 
import2use4opu["get3supportedimageformats4opu"] = importget3supportedimageformats4opu 
import2use4opu["manoeuvre3copyimage4opu"] = importmanoeuvre3copyimage4opu 
import2use4opu["manoeuvre3copyimagetobuffer4opu"] = importmanoeuvre3copyimagetobuffer4opu 
import2use4opu["manoeuvre3copybuffertoimage4opu"] = importmanoeuvre3copybuffertoimage4opu 
import2use4opu["manoeuvre3readimage4opu"] = importmanoeuvre3readimage4opu 
import2use4opu["manoeuvre3writeimage4opu"] = importmanoeuvre3writeimage4opu 
import2use4opu["manoeuvre3mapimage4opu"] = importmanoeuvre3mapimage4opu 
import2use4opu["copy3image4opu"] = importcopy3image4opu 
import2use4opu["copy3imagetobuffer4opu"] = importcopy3imagetobuffer4opu 
import2use4opu["copy3buffertoimage4opu"] = importcopy3buffertoimage4opu 
import2use4opu["read3image4opu"] = importread3image4opu 
import2use4opu["map3image4opu"] = importmap3image4opu 
import2use4opu["release3image4opu"] = importrelease3image4opu 
import2use4opu["retain3image4opu"] = importretain3image4opu 
import2use4opu["set3imagecallback4opu"] = importset3imagecallback4opu 
import2use4opu["set3image4opu"] = importset3image4opu 
import2use4opu["trace3image4opu"] = importtrace3image4opu 
import2use4opu["wait3image4opu"] = importwait3image4opu 
import2use4opu["write3image4opu"] = importwrite3image4opu 

# -------------------------------------------------------------------------------------------------
# Sampler module of OPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4opu["create2sampler4opu"] = importcreate2sampler4opu 
import2use4opu["get2samplerinfo4opu"] = importget2samplerinfo4opu 
import2use4opu["release2sampler4opu"] = importrelease2sampler4opu 
import2use4opu["retain2sampler4opu"] = importretain2sampler4opu 
import2use4opu["set2samplercallback4opu"] = importset2samplercallback4opu 
import2use4opu["set2sampler4opu"] = importset2sampler4opu 
import2use4opu["trace2sampler4opu"] = importtrace2sampler4opu 

# -------------------------------------------------------------------------------------------------
# Program module of OPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4opu["trace2program4opu"] = importtrace2program4opu
import2use4opu["set2programwithbinary4opu"] = importset2programwithbinary4opu
import2use4opu["set2programwithsource4opu"] = importset2programwithsource4opu
import2use4opu["set2programcallback4opu"] = importset2programcallback4opu
import2use4opu["retain2program4opu"] = importretain2program4opu
import2use4opu["release2program4opu"] = importrelease2program4opu
import2use4opu["link2program4opu"] = importlink2program4opu
import2use4opu["get2programinfo4opu"] = importget2programinfo4opu
import2use4opu["delete2programwithbinary4opu"] = importdelete2programwithbinary4opu
import2use4opu["delete2programwithsource4opu"] = importdelete2programwithsource4opu
import2use4opu["compile2program4opu"] = importcompile2program4opu
import2use4opu["build2program4opu"] = importbuild2program4opu
import2use4opu["build2program4opu"] = importbuild2program4opu
import2use4opu["add2programwithbinary4opu"] = importadd2programwithbinary4opu
import2use4opu["add2programwithsource4opu"] = importadd2programwithsource4opu
import2use4opu["create2programwithbinary4opu"] = importcreate2programwithbinary4opu
import2use4opu["create2programwithsource4opu"] = importcreate2programwithsource4opu



# -------------------------------------------------------------------------------------------------
# Test modules of OPU imports for target function                             
# -------------------------------------------------------------------------------------------------
import2use4opu["opu2commandqueue4xi5test"] = importopu2commandqueue4xi5test 
import2use4opu["opu2event4xi5test"] = importopu2event4xi5test 
import2use4opu["opu2image4xi5test"] = importopu2image4xi5test 
import2use4opu["opu3image4xi5test"] = importopu3image4xi5test 
import2use4opu["opu2sampler4xi5test"] = importopu2sampler4xi5test 
import2use4opu["opu2kernel4xi5test"] = importopu2kernel4xi5test 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2kernel4opu" usage = "
#
#   print('=' *33)          
#   print('(Step 15A/25) OF OPU2KERNEL4XI5TEST - TRYING TO TRACE OPU: ', time4xi())      
#   print('=' *33)      
#   trace2opu = None
#   try:
#       trace2opu = trace2kernel4opu() 
#       print('(Step 15B/25) OF OPU2KERNEL4XI5TEST - TRACE2OPU: ', trace2opu)  
#       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4opu-failed {}; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2kernel4opu', 'METHOD': 'trace2kernel4opu'} 
#   except:
#       print('(Step 15Z1/25) OF OPU2KERNEL4XI5TEST *** FAILED TO TRACE OPU: ', trace2opu) 
#      
#">

# -------------------------------------------------------------------------------------------------   
def trace2kernel4opu(task4trace2opu=None):  

    '''
    creates callback to opu2kernel4xi
    '''
    
    global opu2trace4xi
    global folder2lib4opu    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "trace2kernel4opu" 
    method2print = "trace2kernel4opu"

    message2print = "{(Step 1A/33) started" + "; trace2kernel4opu-started: " + str(trace2kernel4opu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                               
    # 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2opu-to-trace2kernel4opu: " + str(task4trace2opu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    opu2trace4xi = {}                                                                                               # INITIALIZES TO EMPTY DICTIONARY
      
    if task4trace2opu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY OPUIZED CALLBACK !
        # -----------------------------------------------------------------------------------------    
        task4trace2opu = {}                                                                                            
            
        task4trace2opu['CLASS']   = "trace2kernel4opu"                                                              # OPUIZE ZPU TRACE!
        task4trace2opu['METHOD']  = "trace2kernel4opu" 
        task4trace2opu['MESSAGE'] = "{(Step 2Z0/33) failed" + "; trace2kernel4opu-failed " + str(opu2trace4xi)  + "; time: " + time4xi() + "}"               
  
        
        message2print = "{(Step 2A/33) set" + "; task4trace2opu-set-by-trace2kernel4opu to: " + str(task4trace2opu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
    
        code2ack = code2ack + '2A-'            


    # -----------------------------------------------------------------------------------------
    # PARAMETER GIVEN BY OPUIZED CALLBACK !
    # -----------------------------------------------------------------------------------------          
    message2print = "{(Step 3A/33) try" + "; task4trace2opu-try-by-trace2kernel4opu: " + str(task4trace2opu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)    
    # 

    try:
        opu2trace4xi ['CLASS']  = task4trace2opu['CLASS']                                                           # OPUIZE OPU TRACE!
        opu2trace4xi ['METHOD']  = task4trace2opu['METHOD']
        opu2trace4xi ['MESSAGE'] = task4trace2opu['MESSAGE']
        
        message2print = "{(Step 3B/33) set" + "; opu2trace4xi-set-by-trace2kernel4opu to: " + str(opu2trace4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 

        code2ack = code2ack + '3B-'         
    except:
        message2print = "{(Step 3Z1/33) failed" + "; opu-trace-failed-by-trace2kernel4opu: " + str(task4trace2opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z1-' 
        
    try:
        # =================================
        # SIMULATE OPU TRACE
        # =================================
        class2print   = task4trace2opu['CLASS']                                                                     # OPUIZE OPU TRACE!
        method2print  = task4trace2opu['METHOD']
        
        message2print = task4trace2opu['MESSAGE']
        print4xi(class2print, method2print, message2print)                                                          # OPUIZED TRACE FOR OPENCL CALLBACK!
        # 
        
        
        code2ack = code2ack + '3C-'         
    except:
        class2print = "trace2kernel4opu"                                                                            # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2kernel4opu"   
        message2print = "{(Step 3Z2/33) failed" + "; simulation-of-opu-trace-failed-by-trace2kernel4opu: " + str(task4trace2opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z2-' 
        
    try:
        # =================================
        # NORMAL TRACE
        # =================================                     
        class2print = "trace2kernel4opu"                                                                            # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2kernel4opu"                
        message2print = "{(Step 3D/33) performed" + "; opu-trace-performed-by-trace2kernel4opu: " + str(task4trace2opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack = code2ack + '3D-' 
    except:
        message2print = "{(Step 3Z3/33) failed" + "; opu-trace-failed-by-trace2kernel4opu: " + str(task4trace2opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z3-' 

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; opu2trace4xi-returning-by-trace2kernel4opu: " + str(opu2trace4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    
    return opu2trace4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2kernel4opu" usage = "
#
#   response4execute2kernel = execute2kernel4opu()
#      
#">

# -------------------------------------------------------------------------------------------------   
def execute2kernel4opu(task4execute2opu=None):  

    '''
    executes kernel to OPU 
    '''
    global folder2lib4opu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2kernel4opu" 
    method2print = "execute2kernel4opu"

    message2print = "{(Step 1A/33) started" + "; execute2kernel4opu-started: " + str(execute2kernel4opu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
  
          
    message2print = "{(Step 1B/33) passed" + "; task4execute2opu-to-execute2kernel4opu: " + str(task4execute2opu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                            # 
    # 
    status4execute2opu = 'CL_SUCCESS'
    
    code2ack  = ' '
    code2nack = ' '    
    
                                                                                                                  #       
    if task4execute2opu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN - BUILD THEM
        # -----------------------------------------------------------------------------------------    
        task4execute2opu = {}                                                                                            

        message2print = "{(Step 2A/33) set" + "; task4execute2opu-set-by-execute2kernel4opu to: " + str(task4execute2opu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
    
        code2ack = code2ack + '2A-'            


    # -----------------------------------------------------------------------------------------
    # 
    # -----------------------------------------------------------------------------------------          
    status4execute2opu = 'CL_SUCCESS'
    message2print = "{(Step 3A/33) set" + "; status4execute2opu-set-by-execute2kernel4opu to: " + str(status4execute2opu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
    

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; status4execute2opu-returning-by-execute2kernel4opu: " + str(status4execute2opu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    
    return status4execute2opu
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernelcallback4opu" usage = "
#
#   print('(Step 14A/700) OF OPU2KERNEL4XI5TEST - TRYING TO SET PROGRAM CALLBACK OF OPU ', time4xi())  
#   try:                               
#       response4setcallback2program = set2kernelcallback4opu()                                                                                                 
#       print('(Step 14B/700) OF OPU2KERNEL4XI5TEST - SET PROGRAM CALLBACK OF OPU TO: ', response4setcallback2program)   
#       # 
#   except:
#       print('(Step 14Z1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO SET PROGRAM CALLBACK OF OPU ', time4xi())  
# 
#">

# ------------------------------------------------------------------------------------------------- 
 
def set2kernelcallback4opu(task4set2kernelcallback=None):

    '''
    registers callback function to opu2kernel4xi
    '''
    global opu2kernel4xi
    global folder2lib4opu  
        
    class2print = "set2kernelcallback4opu" 
    method2print = "set2kernelcallback4opu"
    
    message2print = "{(Step 2A/70) started" + "; set2kernelcallback4opu-started: " + str(set2kernelcallback4opu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # set2kernelcallback4opu-started
    
    try:
    
        opu2kernel4xi ['CALLBACK'] = trace2kernel4opu
        
        
        message2print = "{(Step 2C/70) returning" + "; callback-of-opu2kernel4xi-returning-by-set2kernelcallback4opu: " + str(opu2kernel4xi ['CALLBACK']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print) 
        # 
        
        return opu2kernel4xi ['CALLBACK']      
        
    except:
        message2print = "{(Step 2Z1/70) failed" + "; callback2program-failed-by-set2kernelcallback4opu: " + str(callback2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         

        message2print = "{(Step 2Z2/70) returning" + "; trace2kernel4opu-returning-by-set2kernelcallback4opu: " + str(trace2kernel4opu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)      
            
        return trace2kernel4opu
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2task4opu" usage = "
#
#   try:                               
#       response4execute2task = execute2task4opu(task4execute2task)
#       print('(Step 99B/700) OF OPU2KERNEL4XI5TEST - BUILT PROGRAM OF OPU DEVICE ', time4xi())
#   except:
#       print('(Step 99Z1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO EXECUTE PROGRAM OF OPU DEVICE ', time4xi())  
#                 
#">

# -------------------------------------------------------------------------------------------------   
def execute2task4opu(task4execute2opu=None):

    '''
    executes  program to OPU 
    '''
    global opu2execute4xi
    global folder2lib4opu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2task4opu"
    method2print = "execute2task4opu" 

    message2print = "{(Step 1A/33) started" + "; execute2task4opu-started: " + str(execute2task4opu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # execute2task4opu-started
    
    
    message2print = "{(Step 1B/33) passed" + "; task4execute2opu-to-execute2task4opu: " + str(task4execute2opu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
             
    code2ack  = ' '
    code2nack = ' '

    message2print = "{(Step 1A/70) try" + "; execute-try-by-execute2task4opu: None"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    try:             
        if task4execute2opu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - EXECUTE TASK TO OPU! 
            # -----------------------------------------------------------------------------------------    
            task4execute2opu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4execute2opu-initialized-by-execute2task4opu: " + str(task4execute2opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # 
            
            # ---------------------------------------------------------------------------------------------
            # (1) KERNEL REQUIRED                         
            # ---------------------------------------------------------------------------------------------    
            program2opu = {}
            message2print = "{(Step 1A/70) trying" + "; program2opu-trying-by-create2kernel4opu: " + str(program2opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                program2opu = create2kernel4opu()                                                                     
                
                message2print = "{(Step 1B/70) got" + "; program2opu-got-by-create2kernel4opu: " + str(program2opu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                #                 
                code2ack  = code2ack + '1B-'         
            except:
                message2print = "{(Step 1Z/70) failed" + "; program2opu-failed-by-create2kernel4opu: " + str(program2opu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '1Z-'
                
            task4execute2opu ['PROGRAM'] = program2opu
            
            # ---------------------------------------------------------------------------------------------
            # (2) OPTIONS - REQUIRED                         
            # --------------------------------------------------------------------------------------------- 
            task4execute2task  ['OPTIONS'] = {}
          
            
            # ---------------------------------------------------------------------------------------------
            # (3) CALLBACK - REQUIRED                         
            # --------------------------------------------------------------------------------------------- 
            function2callback4opu = trace2kernel4opu                                                               # CALLBACK FUNCTION FOR OPU
            
            message2print = "{(Step 3A/70) initialized" + "; function2callback4opu-created-by-execute2task4opu: " + str(function2callback4opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # 
            
            code2ack  = code2ack + '3A-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "execute2task4opu"                                                            # MODULE OF OPUIZED OPENCL MODULE
            args2callback['METHOD']  = "execute2task4opu"                                                            # FUNCTION OF OPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 3Z1/33) failed" + "; execute2task4opu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR OPUIZED OPENCL TO RETURN    

            message2print = "{(Step 3B/70) initialized" + "; args2callback-created-by-execute2task4opu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # 

            code2ack  = code2ack + '3B-'
            
           
            task4execute2opu['DATA2CALLBACK'] = args2callback                                                       # USER DATA PASSED TO OPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4execute2opu['FUNCTION2CALLBACK'] = function2callback4opu                                           # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '3C-'

            
            # ---------------------------------------------------------------------------------------------
            # (4) USERDATA - REQUIRED                         
            # ---------------------------------------------------------------------------------------------
            task4execute2opu['USERDATA'] = None 
            
            message2print = "{(Step 4A/70) initialized" + "; task4execute2opu-created-by-execute2task4opu: " + str(task4execute2opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            #
        else:
            pass                                                                  
    except:
        message2print = "{(Step 1Z1/70) yielded" + "; task4execute2opu-yielded-by-execute2task4opu: " + str(task4execute2opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '1Z1-'  
                                                                                                 
    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4execute2opu.keys()        
    message2print = "{(Step 9/70) using" + "; keys2task-using-by-execute2task4opu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # 
  
    # ---------------------------------------------------------------------------------------------
    # (Step 10A/70) - CREATE EXECUTE FOR OPU ! 
    # ---------------------------------------------------------------------------------------------    
    opu2execute4xi = {}                                                                                                                                                                               
    message2print = "{(Step 10A/70) initialized" + "; opu2execute4xi-initialized-by-execute2task4opu to: " + str(opu2execute4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}
    
    message2print = "{(Step 11A0/70) try" + "; program-try-by-execute2task4opu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 11A/70) - PROGRAM - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        opu2execute4xi['PROGRAM'] = task4execute2opu['PROGRAM']
        
        message2print = "{(Step 11A1/70) initialized" + "; program-created-by-execute2task4opu: " + str(opu2execute4xi['PROGRAM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '11A1-'
    except: 
        message2print = "{(Step 11Z1/70) yielded" + "; program-opu2execute4xi-yielded-by-execute2task4opu: " + str(opu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '11Z1-' 
           
    message2print = "{(Step 12A0/70) try" + "; options-try-by-execute2task4opu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 12A/70) - OPTIONS - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        opu2execute4xi['OPTIONS'] = task4execute2opu['OPTIONS']
        
        message2print = "{(Step 12A1/70) initialized" + "; options-created-by-execute2task4opu: " + str(opu2execute4xi['OPTIONS'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '12A1-'
    except: 
        message2print = "{(Step 12Z1/70) yielded" + "; options-opu2execute4xi-yielded-by-execute2task4opu: " + str(opu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '12Z1-' 
        
    message2print = "{(Step 13A0/70) try" + "; callback-try-by-execute2task4opu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 13A/70) - CALLBACK - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        opu2execute4xi['CALLBACK'] = task4execute2opu['CALLBACK']
        
        message2print = "{(Step 13A1/70) initialized" + "; callback-created-by-execute2task4opu: " + str(opu2execute4xi['CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '13A1-'
    except: 
        message2print = "{(Step 13Z1/70) yielded" + "; callback-opu2execute4xi-yielded-by-execute2task4opu: " + str(opu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '13Z1-' 
        
    message2print = "{(Step 14A0/70) try" + "; userdata-try-by-execute2task4opu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 14A/70) - USERDATA - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        opu2execute4xi['USERDATA'] = task4execute2opu['USERDATA']
        
        message2print = "{(Step 14A1/70) initialized" + "; userdata-created-by-execute2task4opu: " + str(opu2execute4xi['USERDATA'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '14A1-'
    except: 
        message2print = "{(Step 14Z1/70) yielded" + "; userdata-opu2execute4xi-yielded-by-execute2task4opu: " + str(opu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '14Z1-'
                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    opu2execute4xi ['ACK2RETURN']  = code2ack
    opu2execute4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; opu2execute4xi-returning-by-execute2task4opu: " + str(opu2execute4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 
    
    return opu2execute4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2kernel4opu" usage = "
#     
#   print('(Step 2A1/700) OF OPU2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR OPU ', time4xi())       
#   try:
#       response4create2kernel = create2kernel4opu()
#   except:
#       print('(Step 2Z1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR OPU *** ', time4xi())
#          
#">

# -------------------------------------------------------------------------------------------------   
def create2kernel4opu(task4kernel2opu=None):

    '''
    creates kernel for OPU
    '''
    global opu2kernel4xi                                                                                            # Kernel of OPU    
    global folder2lib4opu  
    global kb2kernel4opu                                                                                            # Knowledgebase for kernel      
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2kernel4opu" 
    method2print = "create2kernel4opu"

    message2print = "{(Step 1A/70) started" + "; create2kernel4opu-started: " + str(create2kernel4opu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function create2kernel4opu at 0x0000000003AAD8C8> 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernel2opu-to-create2kernel4opu: " + str(task4kernel2opu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    #1: None
    #2: 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    opu2kernel4xi = {}                                                                                              # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4kernel2opu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - BUILD TASK TO OPU! 
            # -----------------------------------------------------------------------------------------    
            
            task4kernel2opu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4kernel2opu-created-by-create2kernel4opu: " + str(task4kernel2opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {}
            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACKS - EXTRA                 
            # ---------------------------------------------------------------------------------------------
                        
            function2callback4opu = trace2kernel4opu                                                                # CALLBACK FUNCTION FOR OPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4opu-created-by-create2kernel4opu: " + str(function2callback4opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2kernel4opu at 0x0000000003AAD6C8> 
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2kernel4opu"                                                          # MODULE OF OPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2kernel4opu"                                                          # FUNCTION OF OPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2kernel4opu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR OPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2kernel4opu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4opu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4opu',
            #  'METHOD': 'create2kernel4opu'}; time: 03:33:11 12/06/11 Pacific Standard Time}

            code2ack  = code2ack + '1E-'
              
            task4kernel2opu['DATA2CALLBACK'] = args2callback                                                        # USER DATA PASSED TO OPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4kernel2opu['FUNCTION2CALLBACK'] = function2callback4opu                                            # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4kernel2opu-created-by-create2kernel4opu: " + str(task4kernel2opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2kernel4opu at 0x0000000003AAD6C8>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4opu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4opu',
            #  'METHOD': 'create2kernel4opu'}}; time: 03:33:11 12/06/11 Pacific Standard Time}


            
            # ---------------------------------------------------------------------------------------------
            # (2) PLATFORM - EXTRA                      
            # ---------------------------------------------------------------------------------------------             
            platform2xi = {}
            message2print = "{(Step 2A/70) initialized" + "; platform2xi-created-by-create2kernel4opu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            try:
                platform2xi = get2platformids4xi()                                                                  # PLATFORM IS COMMON TO ALL DEVICES I.E TO DEVICE XI
                message2print = "{(Step 2B/70) got" + "; platform2xi-got-by-create2kernel4opu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 03:33:11 12/06/11 Pacific Standard Time}
                 
                code2ack  = code2ack + '2B-'
            except:
                message2print = "{(Step 2Z/70) failed" + "; platform2xi-failed-by-create2kernel4opu: " + str(failed)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                
                code2nack  = code2nack + '2Z-'
                 
            task4kernel2opu['PLATFORM'] = platform2xi                                                               # PLATFORM OF SYSTEM 
              
            
            # ---------------------------------------------------------------------------------------------
            # (3) CONTEXT - EXTRA                   
            # ---------------------------------------------------------------------------------------------    
            context2opu = {}
            message2print = "{(Step 3A/70) trying" + "; context2opu-trying-by-create2kernel4opu: " + str(context2opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                context2opu = get2context4opu()                                                                     # NO PARAMETERS - THE SYSTEM CREATES CONTEXT IF REQUIRED  
                
                message2print = "{(Step 3B/70) got" + "; context2opu-got-by-create2kernel4opu: " + str(context2opu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': ...
                
                code2ack  = code2ack + '3B-'         
            except:
                message2print = "{(Step 3Z/70) failed" + "; context2opu-failed-by-create2kernel4opu: " + str(context2opu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '3Z-'
                
            task4kernel2opu ['CONTEXT'] = context2opu           
            
            # ---------------------------------------------------------------------------------------------
            # (4) DEVICE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------    
            device2opu = {}
            
            message2print = "{(Step 4A/70) trying" + "; device2opu-trying-by-create2kernel4opu: " + str(device2opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                device2opu = get2opu4xi()                                                                           # THE SYSTEM CREATES DEVICE INFO, IF NECESSARY    
                
                message2print = "{(Step 4B/70) got" + "; device2opu-got-by-create2kernel4opu: " + str(device2opu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
                
                code2ack  = code2ack + '4B-'  
            except:
                message2print = "{(Step 4Z/70) failed" + "; device2opu-failed-by-create2kernel4opu: " + str(device2opu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '4Z-'
                
            task4kernel2opu ['DEVICE'] = device2opu
            
                   
            # ---------------------------------------------------------------------------------------------
            # (5) ERROR CODE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------         
            task4kernel2opu ['CODE2ERROR'] = 0             
            code2ack  = code2ack + '5B-'              

            # ---------------------------------------------------------------------------------------------
            # (6) QUEUE - EXTRA                          
            # ---------------------------------------------------------------------------------------------         
            queue2opu = None
            
            message2print = "{(Step 6A/70) trying" + "; queue2opu-trying-by-create2kernel4opu: " + str(queue2opu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2opu = Queue4Xi()                                                                              # THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 6B/70) got" + "; queue2opu-got-by-create2kernel4opu: " + str(queue2opu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # <queue4xi.Queue4Xi object at 0x0000000003C63DD8>
                
                code2ack  = code2ack + '6B-'  
            except:
                message2print = "{(Step 6Z/70) failed" + "; queue2opu-failed-by-create2kernel4opu: " + str(queue2opu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '6Z-'
                
            task4kernel2opu ['QUEUE'] = queue2opu

            
            # ---------------------------------------------------------------------------------------------
            # (7) PIPE - EXTRA                              
            # ---------------------------------------------------------------------------------------------         
            pipe2opu = None
           
            message2print = "{(Step 7A/70) trying" + "; pipe2opu-trying-by-create2kernel4opu: " + str(pipe2opu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2opu = Pipe4Xi()                                                                                # THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 7B/70) got" + "; pipe2opu-got-by-create2kernel4opu: " + str(pipe2opu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # (<read-write PipeConnection, handle 384>, <read-write PipeConnection, handle 388>)
                
                code2ack  = code2ack + '7B-'  
            except:
                message2print = "{(Step 7Z/70) failed" + "; pipe2opu-failed-by-create2kernel4opu: " + str(pipe2opu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '7Z-'
                
            task4kernel2opu ['PIPE'] = pipe2opu 
            
            # ---------------------------------------------------------------------------------------------
            # (8) COMMAND QUEUE INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            commandqueueinfo2opu = {}
           
            message2print = "{(Step 8A/70) trying" + "; commandqueueinfo2opu-trying-by-create2kernel4opu: " + str(commandqueueinfo2opu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
                        
            try:
                commandqueueinfo2opu = get2commandqueueinfo4opu()                                                   # SYSTEM CREATES COMMAND QUEUE, IF NECESSARY   
                message2print = "{(Step 8B/70) got" + "; commandqueueinfo2opu-got-by-create2kernel4opu: " + str(commandqueueinfo2opu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                
                code2ack  = code2ack + '8B-'  
            except:
                message2print = "{(Step 8Z/70) failed" + "; commandqueueinfo2opu-failed-by-create2kernel4opu: " + str(commandqueueinfo2opu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '8Z-'
        
            task4kernel2opu ['COMMANDQUEUE'] = commandqueueinfo2opu
            
            
            
            # ---------------------------------------------------------------------------------------------
            # (9) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            bufferinfo2opu = {}
           
            message2print = "{(Step 9A/70) trying" + "; bufferinfo2opu-trying-by-create2kernel4opu: " + str(bufferinfo2opu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                bufferinfo2opu = get2bufferinfo4opu()                                                               # SYSTEM CREATES BUFFER FOR OPU, IF NECESSARY
                message2print = "{(Step 9B/70) got" + "; bufferinfo2opu-got-by-create2kernel4opu: " + str(bufferinfo2opu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                
                code2ack  = code2ack + '9B-' 
            except:
                message2print = "{(Step 9Z/70) failed" + "; bufferinfo2opu-failed-by-create2kernel4opu: " + str(bufferinfo2opu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '9Z-'
        
            task4kernel2opu ['BUFFER'] = bufferinfo2opu 
            
            # ---------------------------------------------------------------------------------------------
            # (10) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            eventinfo2opu = {}
           
            message2print = "{(Step 10A/70) trying" + "; eventinfo2opu-trying-by-create2kernel4opu: " + str(eventinfo2opu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                eventinfo2opu = get2eventinfo4opu()                                                                 # SYSTEM CREATES EVENT IF NECESSAY   
                message2print = "{(Step 10B/70) got" + "; eventinfo2opu-got-by-create2kernel4opu: " + str(eventinfo2opu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'DATA2CALLBACK': ... 
                
                code2ack  = code2ack + '10B-' 
            except:
                message2print = "{(Step 10Z/70) failed" + "; eventinfo2opu-failed-by-create2kernel4opu: " + str(eventinfo2opu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '10Z-'
        
            task4kernel2opu ['EVENT'] = eventinfo2opu             

            
            task4kernel2opu ['CODE4PY']       = {}                                                                  
            task4kernel2opu ['CODE4CPP']      = {}                                                                  
            task4kernel2opu ['CODE4C']        = {} 
            task4kernel2opu ['CODE4CL']       = {} 
                       
            task4kernel2opu ['CODE4PYC']      = {}                                                                  
            task4kernel2opu ['CODE4BIN']      = {}
 
            task4kernel2opu ['DIRECTORY4PY']  = {}                                                                  
            task4kernel2opu ['DIRECTORY4CPP'] = {}
            task4kernel2opu ['DIRECTORY4C']   = {}
            task4kernel2opu ['DIRECTORY4CL']  = {}
                                                                                                       
            task4kernel2opu ['DIRECTORY4PYC'] = {}                                                                  
            task4kernel2opu ['DIRECTORY4BIN'] = {}                                                                  
                                               
            # ---------------------------------------------------------------------------------------------
            # (12A0) DIRECTORY4PY - PYTHON                 
            # ---------------------------------------------------------------------------------------------             
            dir2py4opu = folder2lib4opu                                                                                                                                                            
            message2print = "{(Step 12A0/70) set" + "; dir2py4opu-set-by-create2kernel4opu to: " + str(dir2py4opu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4opu 
            code2ack  = code2ack + '12A0-' 
        
            task4kernel2opu ['DIRECTORY4PY'] = dir2py4opu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A0) CODE4PY - PYTHON         
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A0/70) using" + "; DirectoryWalker-using-by-create2kernel4opu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2py4opu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B0/70) examining" + "; directory-examining-by-create2kernel4opu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C0/70) examining" + "; file-examining-by-create2kernel4opu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4opu + opu2sampler4xi5test.py; opu2dummy4xi5test.cpp 
                    
                    message2print = "{(Step 14D0/70) calling" + "; fetch2kernel4opu-calling-by-create2kernel4opu: " + str(fetch2kernel4opu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4opu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E0/70) passing" + "; file2walk-passing-to-fetch2kernel4opu-by-create2kernel4opu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #folder2lib4opu + opu2sampler4xi5test.py; opu2dummy4xi5test.cpp 
                    
                    fetch2kernel4opu(file2walk)                                                                     # FETCHES KERNEL FILES INTO FETCH2CODE4OPU DICTIONARY 
                    
                    message2print = "{(Step 14E0/70) performed" + "; fetch2kernel4opu-performed-by-create2kernel4opu: " + str(fetch2kernel4opu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4opu at 0x0000000003AADB48>
                    
                    # message2print = "{(Step 14F0/70) got" + "; fetch2code4opu-got-by-create2kernel4opu: " + str(fetch2code4opu) + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)                                      
                    # ...  {1: '...profile = "11" />\n', 2: '# --
            
            
                     
            keys2explore4opu = fetch2code4opu.keys()
            message2print = "{(Step 14G0/70) using" + "; keys2explore4opu-using-by-create2kernel4opu: " + str(keys2explore4opu) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)             
            # folder2lib4opu + opu2sampler4xi5test.py; opu2dummy4xi5test.cpp
            
            for key2explore4opu in keys2explore4opu:
                name2program4opu=os.path.splitext(key2explore4opu)                                                  # opu2sampler4xi5test + py
                key2extension4opu = name2program4opu[1]                                                              
                if key2extension4opu == '.py':                          
                    task4kernel2opu ['CODE4PY'] [key2explore4opu] = fetch2code4opu[key2explore4opu]                 # Python code(s)      

            # ---------------------------------------------------------------------------------------------
            # (14H0) SIZE4PY - PYTHON SOURCE            
            # ---------------------------------------------------------------------------------------------                                                
            size2py4opu  = {}
            keys2py4opu = fetch2code4opu.keys()                                                                     # opu2sampler4xi5test.py
            for key2py4opu in keys2py4opu:
                name2program4opu=os.path.splitext(key2py4opu)                                                       # opu2sampler4xi5test + py
                key2extension4opu = name2program4opu[1]                                                             # py   
                if key2extension4opu == '.py':                          
                    size2py4opu[key2py4opu] = len(fetch2code4opu[key2py4opu])                                       # length of saved py code 

            task4kernel2opu ['SIZE4PY'] = size2py4opu
                               
            message2print = "{(Step 14H0/70) set" + "; size2py4opu-set-by-create2kernel4opu to: " + str(size2py4opu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # {folder2lib4opu + opu2sampler4xi5test.py': 1337}
            code2ack  = code2ack + '14H1-' 
            

            # ---------------------------------------------------------------------------------------------
            # (12A1) C, C++, CL SOURCE                   
            # ---------------------------------------------------------------------------------------------             
            dir2c4opu = folder2lib4opu                                                                                                                                                            
            message2print = "{(Step 12A1/70) set" + "; dir2c4opu-set-by-create2kernel4opu to: " + str(dir2c4opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # folder2lib4opu 
            code2ack  = code2ack + '12A1-' 
        
            task4kernel2opu ['DIRECTORY4CPP']  = dir2c4opu
            task4kernel2opu ['DIRECTORY4C']    = dir2c4opu
            task4kernel2opu ['DIRECTORY4CLPP'] = dir2c4opu
            task4kernel2opu ['CODE4CPP'] = {} 
            task4kernel2opu ['CODE4C']   = {} 
            task4kernel2opu ['CODE4CL']  = {}            
            
            # ---------------------------------------------------------------------------------------------
            # (14A1) C, C++, CL SOURCE   
            # ---------------------------------------------------------------------------------------------             
            keys2c4opu = fetch2code4opu.keys()
            for key2c4opu in keys2c4opu:
                name2c4opu=os.path.splitext(key2c4opu)                                                  
                key2extension4opu = name2c4opu[1]                                                             # C++, C, CL 
                if key2extension4opu == '.cpp':                          
                    task4kernel2opu ['CODE4CPP'] [key2c4opu] = fetch2code4opu[key2c4opu]                     
                    message2print = "{(Step 14G1/70) set" + "; key2c4opu-set-by-create2kernel4opu to: " + str(key2c4opu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4opu + opu2dummy4xi5test.cpp
                if key2extension4opu == '.c':                          
                    task4kernel2opu ['CODE4C'] [key2c4opu] = fetch2code4opu[key2c4opu]                     
                    message2print = "{(Step 14G2/70) set" + "; key2c4opu-set-by-create2kernel4opu to: " + str(key2c4opu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4opu +
                if key2extension4opu == '.cl':                          
                    task4kernel2opu ['CODE4CL'] [key2c4opu] = fetch2code4opu[key2c4opu]                     
                    message2print = "{(Step 14G3/70) set" + "; key2c4opu-set-by-create2kernel4opu to: " + str(key2c4opu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4opu + 
                                                                
            # ----------------------------------------------------------------------------------------------
            # (14H1) SIZE4C - C C++ CL SOURCE HAS THE SAME FOLDER AS FOR PYTHON SOURCE - ALREADY FETCHED           
            # ----------------------------------------------------------------------------------------------                                                
            size2c4opu  = {}
            keys2c4opu = fetch2code4opu.keys()                                                                # 
            for key2c4opu in keys2c4opu:
                name2program4opu=os.path.splitext(key2c4opu)                                                  # 
                key2extension4opu = name2program4opu[1]                                                       #    
                if key2extension4opu == '.cpp':                          
                    size2c4opu[key2c4opu] = len(fetch2code4opu[key2c4opu])                                    # length of saved C++ code
                    task4kernel2opu ['SIZE4CPP'] = size2c4opu 
                if key2extension4opu == '.c':                          
                    size2c4opu[key2c4opu] = len(fetch2code4opu[key2c4opu])                                    # length of saved C code
                    task4kernel2opu ['SIZE4C'] = size2c4opu
                if key2extension4opu == '.cl':                          
                    size2c4opu[key2c4opu] = len(fetch2code4opu[key2c4opu])                                    # length of saved CL code
                    task4kernel2opu ['SIZE4CL'] = size2c4opu 
                                       
            
                               
            message2print = "{(Step 14H1/70) set" + "; size2c4opu-set-by-create2kernel4opu to: " + str(size2c4opu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # folder2lib4opu + opu2dummy4xi5test.cpp': 331}
            code2ack  = code2ack + '14H1-' 
            
                                                  
            # ---------------------------------------------------------------------------------------------
            # (12B2) DIRECTORY FOR PYTHON CACHE - REQUIRED                      
            # ---------------------------------------------------------------------------------------------             
            dir2pycache4opu = folder2lib4opu + '__pycache__//'                                                                                                                                                           
            message2print = "{(Step 12B2/70) set" + "; dir2pycache4opu-set-by-create2kernel4opu to: " + str(dir2pycache4opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4opu + '__pycache__//'
            code2ack  = code2ack + '12B2-' 
        
            task4kernel2opu ['DIRECTORY4PYC'] = dir2pycache4opu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A2) CODE4PYC - REQUIRED              
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A2/70) using" + "; DirectoryWalker-using-by-create2kernel4opu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2pycache4opu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B2/70) examining" + "; directory-examining-by-create2kernel4opu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C2/70) examining" + "; file-examining-by-create2kernel4opu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4opu + __pycache__//opu2sampler4xi5test.cpython-33.pyc
                    
                    message2print = "{(Step 14D2/70) calling" + "; fetch2kernel4opu-calling-by-create2kernel4opu: " + str(fetch2kernel4opu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4opu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E2/70) passing" + "; file2walk-passing-to-fetch2kernel4opu-by-create2kernel4opu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #folder2lib4opu + __pycache__//opu2sampler4xi5test.cpython-33.pyc
                    
                    fetch2kernel4opu(file2walk)                                                                     # fetches kernel files into fetch2code4opu dictionary 
                    
                    message2print = "{(Step 14F2/70) performed" + "; fetch2kernel4opu-performed-by-create2kernel4opu: " + str(fetch2kernel4opu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4opu at 0x0000000003AADB48>
                    
                    # message2print = "{(Step 14G2/70) got" + "; fetch2code4opu-got-by-create2kernel4opu: " + str(fetch2code4opu) + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)                                      
                    # 
            
            task4kernel2opu ['CODE4PYC'] = {}
            keys2pyc4opu = fetch2code4opu.keys()
            for key2pyc4opu in keys2pyc4opu:
                name2program4opu=os.path.splitext(key2pyc4opu)                                                      # opu2sampler4xi5test.cpython-33.pyc
                key2extension4opu = name2program4opu[1]                                                             # pyc 
   
                if key2extension4opu == '.pyc':                          
                    task4kernel2opu ['CODE4PYC'] [key2pyc4opu] = fetch2code4opu[key2pyc4opu]                        # binary code(s)
                    message2print = "{(Step 14H2/70) set" + "; key2pyc4opu-set-by-create2kernel4opu to: " + str(key2pyc4opu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    #    
                                     
            size2pyc4opu  = {}

            for key2pyc4opu in keys2pyc4opu:
                name2program4opu=os.path.splitext(key2pyc4opu)                                                      # opu2sampler4xi5test.cpython-32 + pyc
                key2extension4opu = name2program4opu[1]                                                             # pyc 
                if key2extension4opu == '.pyc':                          
                    size2pyc4opu[key2pyc4opu] = len(fetch2code4opu[key2pyc4opu])                                    # length of saved binary code
                    message2print = "{(Step 14I2/70) set" + "; key2pyc4opu-set-by-create2kernel4opu to: " + str(key2pyc4opu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # 
                                              
            # ---------------------------------------------------------------------------------------------
            # (14I2) SIZE4PYC - REQUIRED              
            # ---------------------------------------------------------------------------------------------          
            task4kernel2opu ['SIZE4PYC'] = size2pyc4opu
                               
            message2print = "{(Step 14J2/70) set" + "; size2pyc4opu-set-by-create2kernel4opu to: " + str(size2pyc4opu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 
            code2ack  = code2ack + '14J2-' 

                                               
            # ---------------------------------------------------------------------------------------------
            # (12A3) DIRECTORY FOR C++, C, CL BIN - REQUIRED                    
            # ---------------------------------------------------------------------------------------------             
            dir2bin4opu = folder2lib4opu + 'bin//'                                                                                                                                                           
            message2print = "{(Step 12A3/70) set" + "; dir2bin4opu-set-by-create2kernel4opu to: " + str(dir2bin4opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4opu + 'bin//'
            code2ack  = code2ack + '12A3-' 
        
            task4kernel2opu ['DIRECTORY4BIN'] = dir2bin4opu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A3) CODE4BIN FOR C++, C, CL - REQUIRED              
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A3/70) using" + "; DirectoryWalker-using-by-create2kernel4opu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2bin4opu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B3/70) examining" + "; directory-examining-by-create2kernel4opu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C3/70) examining" + "; file-examining-by-create2kernel4opu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4opu + bin//opu2dummy4xi5test.exe
                    
                    message2print = "{(Step 14D3/70) calling" + "; fetch2kernel4opu-calling-by-create2kernel4opu: " + str(fetch2kernel4opu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4opu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E3/70) passing" + "; file2walk-passing-to-fetch2kernel4opu-by-create2kernel4opu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4opu + bin//opu2dummy4xi5test.exe
                    
                    fetch2kernel4opu(file2walk)                                                                     # fetches kernel files into fetch2code4opu dictionary 
                    
                    message2print = "{(Step 14E3/70) performed" + "; fetch2kernel4opu-performed-by-create2kernel4opu: " + str(fetch2kernel4opu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4opu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14F3/70) got" + "; fetch2code4opu-got-by-create2kernel4opu: " + str(fetch2code4opu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # 

            task4kernel2opu ['CODE4BIN'] = {}
            
            keys2bin4opu = fetch2code4opu.keys()
            message2print = "{(Step 14G3/70) using" + "; keys2bin4opu-using-by-create2kernel4opu: " + str(keys2bin4opu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # [folder2lib4opu + 'opu2dummy4xi5test.cpp', 'opu2sampler4xi5test.py']
            
            for key2bin4opu in keys2bin4opu:
                name2program4opu=os.path.splitext(key2bin4opu)                                                      # opu2dummy4xi5test.exe
                key2extension4opu = name2program4opu[1]                                                             # bin 
   
                if key2extension4opu == '.exe':                          
                    task4kernel2opu ['CODE4BIN'] [key2bin4opu] = fetch2code4opu[key2bin4opu]                        # binary code(s)   
                                        
            size2bin4opu  = {}
            keys2bin4opu = fetch2code4opu.keys()                                                                    # opu2dummy4xi5test.exe
            for key2bin4opu in keys2bin4opu:
                name2program4opu=os.path.splitext(key2bin4opu)                                                      # opu2sampler4xi5test.cpython-32 + bin
                key2extension4opu = name2program4opu[1]                                                             # bin 
                if key2extension4opu == '.exe':                          
                    size2bin4opu[key2bin4opu] = len(fetch2code4opu[key2bin4opu])                                    # length of saved binary code
                        
            # ---------------------------------------------------------------------------------------------
            # (14H3) SIZE4BIN - REQUIRED              
            # ---------------------------------------------------------------------------------------------          
            task4kernel2opu ['SIZE4BIN'] = size2bin4opu
                               
            message2print = "{(Step 14H3/70) set" + "; size2bin4opu-set-by-create2kernel4opu to: " + str(size2bin4opu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # {}
            code2ack  = code2ack + '14H3-' 

            # ---------------------------------------------------------------------------------------------
            # (14J) COUNT4PY, COUNT4C,COUNT4PYC,COUNT4BIN                
            # ---------------------------------------------------------------------------------------------             
            task4kernel2opu ['COUNT4PY']     = 0
            task4kernel2opu ['COUNT4CPP']    = 0
            task4kernel2opu ['COUNT4C']      = 0
            task4kernel2opu ['COUNT4CL']     = 0
            task4kernel2opu ['COUNT4PYC']    = 0
            task4kernel2opu ['COUNT4BIN']    = 0

            keys2code4opu = fetch2code4opu.keys()
            message2print = "{(Step 14J/70) using" + "; keys2code4opu-using-by-create2kernel4opu: " + str(keys2code4opu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # [folder2lib4opu + 'opu2dummy4xi5test.cpp', folder2lib4opu + 'opu2sampler4xi5test.py']

            
            for key2code4opu in keys2code4opu:
                name2program4opu=os.path.splitext(key2code4opu)                                                    
                key2extension4opu = name2program4opu[1]                                                             
                if key2extension4opu == '.py':                          
                    task4kernel2opu ['COUNT4PY']     = task4kernel2opu ['COUNT4PY']  + 1 
                if key2extension4opu == '.cpp':                          
                    task4kernel2opu ['COUNT4CPP']    = task4kernel2opu ['COUNT4CPP'] + 1                                            
                if key2extension4opu == '.c':                          
                    task4kernel2opu ['COUNT4C']      = task4kernel2opu ['COUNT4C']   + 1              
                if key2extension4opu == '.cl':                          
                    task4kernel2opu ['COUNT4CL']     = task4kernel2opu ['COUNT4CL']  + 1                                  
                if key2extension4opu == '.pyc':                          
                    task4kernel2opu ['COUNT4PYC']    = task4kernel2opu ['COUNT4PYC'] + 1                            
                if key2extension4opu == '.exe':                          
                    task4kernel2opu ['COUNT4BIN']    = task4kernel2opu ['COUNT4BIN'] + 1                                                                                 
            
            message2print = "{(Step 14K/70) set" + "; count4py-set-by-create2kernel4opu to: " + str(task4kernel2opu ['COUNT4PY'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 1
            
            message2print = "{(Step 14L/70) set" + "; count4cpp-set-by-create2kernel4opu to: " + str(task4kernel2opu ['COUNT4CPP'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 1
            message2print = "{(Step 14M/70) set" + "; count4c-set-by-create2kernel4opu to: " + str(task4kernel2opu ['COUNT4C'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0 
            message2print = "{(Step 14N/70) set" + "; count4cl-set-by-create2kernel4opu to: " + str(task4kernel2opu ['COUNT4CL'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0                         
            
            message2print = "{(Step 14M/70) set" + "; count4pyc-set-by-create2kernel4opu to: " + str(task4kernel2opu ['COUNT4PYC'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0
            
            message2print = "{(Step 14N/70) set" + "; count4bin-set-by-create2kernel4opu to: " + str(task4kernel2opu ['COUNT4BIN'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0                                                
            code2ack  = code2ack + '14N-'
            
            # ---------------------------------------------------------------------------------------------
            # (15) LANGUAGE - EXTRA                             
            # ---------------------------------------------------------------------------------------------             
            task4kernel2opu ['LANGUAGE'] = {}
            
            for key2code4opu in keys2code4opu:
                name2program4opu=os.path.splitext(key2code4opu)                                                     
                key2extension4opu = name2program4opu[1]                                                             
                if key2extension4opu == '.py':                          
                    task4kernel2opu ['LANGUAGE'] ['PY']  = "Python"  
                if key2extension4opu == '.cpp':                          
                    task4kernel2opu ['LANGUAGE'] ['CPP'] = "C++"
                if key2extension4opu == '.c':                          
                    task4kernel2opu ['LANGUAGE'] ['C']   = "C"  
                if key2extension4opu == '.cl':                          
                    task4kernel2opu ['LANGUAGE'] ['CL']  = "CL"                                     
                    
            message2print = "{(Step 15B/70) set" + "; language2task4opu-set-by-create2kernel4opu to: " + str(task4kernel2opu ['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '15B-' 
                      
            # ---------------------------------------------------------------------------------------------
            # (16) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            count2reference2opu  = 1
           
            message2print = "{(Step 16B/70) set" + "; count2reference2opu-set-by-create2kernel4opu to: " + str(count2reference2opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1 
            code2ack  = code2ack + '16B-' 
        
            task4kernel2opu ['COUNT2REFERENCE'] = count2reference2opu                                 
                                    
            # ---------------------------------------------------------------------------------------------
            # (17) PROGRAM - REQUIRED                           
            # ---------------------------------------------------------------------------------------------             
            task4kernel2opu ['PROGRAM'] = None
            message2print = "{(Step 17A/70) try" + "; program2opu-try-by-create2kernel4opu: " + str(task4kernel2opu ['PROGRAM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #             
            try:
                task4kernel2opu ['PROGRAM'] = create2programwithsource4opu()
                keys2program = task4kernel2opu ['PROGRAM'].keys()
                
                message2print = "{(Step 17B/70) set" + "; program-set-by-create2kernel4opu to: " + str(keys2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # ['CODE2ERROR' ... 
                #  'COUNT2REFERENCE', 'NACK2RETURN', 'CONTEXT', 'COMMANDQUEUE', 'DEVICE', ... 'PIPE']

                code2ack  = code2ack + '17B-'
            except:
                message2print = "{(Step 17Z1/70) failed" + "; task4kernel2opu-failed-by-create2kernel4opu: " + str(task4kernel2opu ['PROGRAM']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '17Z-'
                                    
            # ---------------------------------------------------------------------------------------------
            # (18) FUNCTION - REQUIRED                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2opu ['FUNCTION'] = {}
            message2print = "{(Step 18A0/70) set" + "; function4opu-set-by-create2kernel4opu to: " + str(task4kernel2opu ['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
             
            task4kernel2opu ['FUNCTION'] ['.py'] = {}
            message2print = "{(Step 18A1/70) set" + "; pythonfunction4opu-set-by-create2kernel4opu to: " + str(task4kernel2opu ['FUNCTION'] ['.py'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
                        
            tag2search4opu  = kb2kernel4opu ['.py'] ['TAG']
            message2print = "{(Step 18A2/70) using" + "; tag2search4opu-using-by-create2kernel4opu: " + str(tag2search4opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # ... function =
            
            value2search4opu    = kb2kernel4opu ['.py'] ['VALUE']
            message2print = "{(Step 18A3/70) using" + "; value2search4opu-using-by-create2kernel4opu: " + str(value2search4opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # opu2sampler4xi5test
            
            attribute2search4opu= kb2kernel4opu ['.py'] ['ATTRIBUTE'] 
            message2print = "{(Step 18A4/70) using" + "; attribute2search4opu-using-by-create2kernel4opu: " + str(attribute2search4opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage =
            try:
                keys2code4opu = task4kernel2opu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4opu in keys2code4opu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4opu = task4kernel2opu ['PROGRAM'] ['CODE4SOURCE'] [key2code4opu]
                    keys2line4opu = code2examine4opu.keys()
                    for key2line4opu in keys2line4opu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4opu = task4kernel2opu ['PROGRAM'] ['CODE4SOURCE'] [key2code4opu] [key2line4opu]
                        # message2print = "{(Step 18A5/70) examining" + "; line2examine4opu-examining-by-create2kernel4opu: " + str(line2examine4opu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        #                             
                        
                        index2pattern = str.find(line2examine4opu,tag2search4opu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 18B/70) examining" + "; line2function4opu-examining-by-create2kernel4opu: " + str(line2examine4opu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # ... function = "set2trace4sampler" ... # <... opu2sampler4xi5test" usage = "
                             
                            index2function = str.find(line2examine4opu,value2search4opu)
                            if index2function == -1:
                                message2print = "{(Step 18C/70) skipped" + "; line2function4opu-skipped-by-create2kernel4opu: " + str(line2examine4opu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # <... set2trace4sampler" ... # ...function = "opu2sampler4xi5test" usage = " ...function = "main" usage = "
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                index2usage = str.find(line2examine4opu,attribute2search4opu)             # ...function = "opu2sampler4xi5test" usage = "
                                if index2usage  == -1:                                                
                                    # ------------------------------------------------------------------------------
                                    # NOT OK KERNEL FUNCTION TAG LINE - USAGE ATTRIBUTE MISSING
                                    # ------------------------------------------------------------------------------
                                    message2print = "{(Step 18D/70) warning" + "; line2function4opu-warning-by-create2kernel4opu: " + str(line2examine4opu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # 
                                    
                                else:
                                    # ------------------------------------------------------------------------------
                                    # OK KERNEL FUNCTION TAG LINE
                                    # ------------------------------------------------------------------------------    
                                    message2print = "{(Step 18E/70) accepted" + "; line2examine4opu-accepted-by-create2kernel4opu: " + str(line2examine4opu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # ...function = "opu2sampler4xi5test" usage = "
                                    # 0123456789012345678901234567890123456789012345678901234
                                    
                                    key2pythonfunction4opu = line2examine4opu[index2function:index2usage-2]
                                    
                                    task4kernel2opu ['FUNCTION'] ['.py'] [key2pythonfunction4opu] = {}                                  

                                    message2print = "{(Step 18F/70) used" + "; key2pythonfunction4opu-used-by-create2kernel4opu: " + str(key2pythonfunction4opu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # opu2sampler4xi5test
                                    
                                    code2ack  = code2ack + '18F-'
                            # -------------------------------------------------------------------------------------
                            # 
                            # -------------------------------------------------------------------------------------                                        
                             
            except:
                message2print = "{(Step 18Z1/70) failed" + "; task4kernel2opu-failed-by-create2kernel4opu: " + str(task4kernel2opu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '18Z-'            
                                    
            # ---------------------------------------------------------------------------------------------
            # (19) FUNCTION - KERNEL FUNCTIONS FROM FECTHED C++ FILE(S) - NOT FROM PROGRAM OBJECT                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2opu ['FUNCTION'] ['.cpp'] = {}            
            message2print = "{(Step 19A0F/70) set" + "; cplusfunction4opu-set-by-create2kernel4opu to: " + str(task4kernel2opu ['FUNCTION'] ['.cpp'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}   
            
            tag2search4opu      = kb2kernel4opu ['.cpp'] ['TAG']
            message2print = "{(Step 19A2/70) using" + "; tag2search4opu-using-by-create2kernel4opu: " + str(tag2search4opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <...            
            attribute2search4opu= kb2kernel4opu ['.cpp'] ['ATTRIBUTE'] 
            message2print = "{(Step 19A4/70) using" + "; attribute2search4opu-using-by-create2kernel4opu: " + str(attribute2search4opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage = kernel
            

            try:
                keys2code4opu = task4kernel2opu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4opu in keys2code4opu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4opu = task4kernel2opu ['PROGRAM'] ['CODE4SOURCE'] [key2code4opu]
                    message2print = "{(Step 19A5/70) using" + "; key2code4opu-using-by-create2kernel4opu: " + str(key2code4opu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # opu2dummy4xi5test.cpp
                       
                    keys2line4opu = code2examine4opu.keys()
                    # message2print = "{(Step 19A6/70) using" + "; keys2line4opu-using-by-create2kernel4opu: " + str(keys2line4opu)  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print) 
                    # 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ...                    
                    for key2line4opu in keys2line4opu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4opu = task4kernel2opu ['PROGRAM'] ['CODE4SOURCE'] [key2code4opu] [key2line4opu]
                        # message2print = "{(Step 19A7/70) examining" + "; line2examine4opu-examining-by-create2kernel4opu: " + str(line2examine4opu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        # /*<... nbody_kern" usage = "kernel example 1"*/                        
                        
                        index2pattern = str.find(line2examine4opu,tag2search4opu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG 
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 19B1/70) examining" + "; line2function4opu-examining-by-create2kernel4opu: " + str(line2examine4opu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # ... function = "OCLError" usage = "error code checking"*/
                            # ... function = "nbody_kern" usage = "kernel example 1"*/
                            
                            message2print = "{(Step 19B2/70) using" + "; attribute2search4opu-using-by-create2kernel4opu: " + str(attribute2search4opu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            #                                                         
                            index2usage = str.find(line2examine4opu,attribute2search4opu)
                            if index2usage == -1:
                                # ----------------------------------------------------------------------------------
                                # NON KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------                            
                                message2print = "{(Step 19C/70) skipped" + "; line2function4opu-skipped-by-create2kernel4opu: " + str(line2examine4opu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # ... function = "OCLError" usage = "error code checking"*/
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                message2print = "{(Step 19E/70) accepted" + "; line2examine4opu-accepted-by-create2kernel4opu: " + str(line2examine4opu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # ... function = "nbody_kern" usage = "kernel example 1"*/; 
                                # ... function = "nbody2_kern" usage = "kernel example 2"*/ 
                                # 012345678901234567890123456789012345678901234567890
                                 
                                key2kernelfunction4opu = line2examine4opu[27:index2usage-2]  
                                task4kernel2opu ['FUNCTION'] ['.cpp'] [key2kernelfunction4opu] =  {}                                       

                                message2print = "{(Step 19F/70) used" + "; key2kernelfunction4opu-used-by-create2kernel4opu: " + str(key2kernelfunction4opu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # nbody_kern; nbody2_kern 
                                    
                                code2ack  = code2ack + '19F-'
                                    
                                    
            except:
                message2print = "{(Step 19Z1/70) failed" + "; task4kernel2opu-failed-by-create2kernel4opu: " + str(task4kernel2opu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #   
                #             
                code2nack  = code2nack + '19Z-'           
                                                      
            # ---------------------------------------------------------------------------------------------
            # EOF CREATING TASK4KERNEL2OPU                  
            # ---------------------------------------------------------------------------------------------                                                                                                                                                          
        else:
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4kernel2opu-yielded-by-create2kernel4opu: " + str(task4kernel2opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '1Z1-' 

    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4kernel2opu.keys()        
    message2print = "{(Step 19A/70) using" + "; keys2task-using-by-create2kernel4opu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    #1 this program created:
    # ['BUFFER'  ... 'LANGUAGE', 'PIPE', 
    #  'PLATFORM', 'PROGRAM', 'QUEUE' ....']
    #2 caller passed:
    # ['FUNCTION', 'PROGRAM']
    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - CREATE PROGRAM OBJECT FOR OPU - BUILD REQUIRED ONES IF USER HAS FORGOTTEN ! 
    # ---------------------------------------------------------------------------------------------    
    opu2kernel4xi = {}                                                                                             # CREATE INITIALIZES DICTIONARY!                                                                                                                                                                               
    message2print = "{(Step 20A/70) initialized" + "; opu2kernel4xi-initialized-by-create2kernel4opu to: " + str(opu2kernel4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}
    
    if (('DATA2CALLBACK' not in keys2task) or ('FUNCTION2CALLBACK' not in keys2task)):
        try:            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACKS - REQUIRED                
            # ---------------------------------------------------------------------------------------------
                     
            function2callback4opu = trace2kernel4opu                                                                # CALLBACK FUNCTION FOR OPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4opu-created-by-create2kernel4opu: " + str(function2callback4opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2kernel4opu at 0x0000000003AAD6C8> 
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2kernel4opu"                                                          # MODULE OF OPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2kernel4opu"                                                          # FUNCTION OF OPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2kernel4opu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR OPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2kernel4opu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4opu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4opu',
            #  'METHOD': 'create2kernel4opu'}; time: 03:33:11 12/06/11 Pacific Standard Time}

            code2ack  = code2ack + '1E-'
              
            task4kernel2opu['DATA2CALLBACK'] = args2callback                                                        # USER DATA PASSED TO OPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4kernel2opu['FUNCTION2CALLBACK'] = function2callback4opu                                            # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4kernel2opu-created-by-create2kernel4opu: " + str(task4kernel2opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2kernel4opu at 0x0000000003AAD6C8>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4opu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4opu',
            #  'METHOD': 'create2kernel4opu'}}; time: 03:33:11 12/06/11 Pacific Standard Time}
        except: 
            message2print = "{(Step 1Z2/70) yielded" + "; callbacks-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z2-'     
                
    if 'DATA2CALLBACK' in keys2task:
        message2print = "{(Step 21A0/70) try" + "; data2callback-try-by-create2kernel4opu: {}" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 21A/70) - DATA2CALLBACK - REQUIRED 
            # -----------------------------------------------------------------------------------------               
            opu2kernel4xi['DATA2CALLBACK'] = task4kernel2opu['DATA2CALLBACK']
            
            message2print = "{(Step 21A1/70) initialized" + "; data2callback-created-by-create2kernel4opu: " + str(opu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4opu-failed ; time: 04:42:53 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4opu',
            #  'METHOD': 'create2kernel4opu'}
    
            code2ack  = code2ack + '21A1-'
        except: 
            message2print = "{(Step 21Z1/70) yielded" + "; data2callback-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '21Z1-'
    
    if 'FUNCTION2CALLBACK' in keys2task:    
        message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-create2kernel4opu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22B/70) - FUNCTION2CALLBACK - REQUIRED
            # -----------------------------------------------------------------------------------------               
            opu2kernel4xi['FUNCTION2CALLBACK'] = task4kernel2opu['FUNCTION2CALLBACK']
            
            message2print = "{(Step 22B1/70) initialized" + "; function2callback-created-by-create2kernel4opu: " + str(opu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <function trace2kernel4opu at 0x000000000422F6C8>
            
            code2ack  = code2ack + '22B1-'
        except: 
            message2print = "{(Step 22Z2/70) yielded" + "; function2callback-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '22Z2-' 
        
        message2print = "{(Step 22C0/70) try" + "; platform-try-by-create2kernel4opu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        #

        
    if 'PLATFORM' in keys2task:         
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22C/70) - PLATFORM - EXTRA
            # -----------------------------------------------------------------------------------------               
            opu2kernel4xi['PLATFORM'] = task4kernel2opu['PLATFORM']
            
            message2print = "{(Step 22C1/70) initialized" + "; platform-created-by-create2kernel4opu: " + str(opu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
    
    
            code2ack  = code2ack + '22C1-'
        except: 
            message2print = "{(Step 22Z3/70) yielded" + "; platform-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '22Z3-' 
            
    
    if 'CONTEXT' in keys2task:        
        message2print = "{(Step 23A/70) try" + "; context2opu-try-by-create2kernel4opu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 23/70) - CONTEXT  - EXTRA
            # -----------------------------------------------------------------------------------------               
            opu2kernel4xi['CONTEXT'] = task4kernel2opu['CONTEXT']
            
            message2print = "{(Step 23B/70) initialized" + "; context-created-by-create2kernel4opu: " + str(opu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...      
            
            code2ack  = code2ack + '23B-'
        except: 
            message2print = "{(Step 23Z1/70) yielded" + "; context-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
        
            code2nack  = code2nack + '23Z1-' 
    
    if 'DEVICE' in keys2task:        
        message2print = "{(Step 24A/70) try" + "; device-try-by-create2kernel4opu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 24/70) - DEVICE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            opu2kernel4xi['DEVICE'] = task4kernel2opu['DEVICE']
            
            message2print = "{(Step 24B/70) initialized" + "; device-created-by-create2kernel4opu: " + str(opu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
            
            code2ack  = code2ack + '24B-'
        except: 
            message2print = "{(Step 24Z1/70) yielded" + "; device-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '24Z1-'
    
    if 'CODE2ERROR' in keys2task:                     
        message2print = "{(Step 25A/70) try" + "; code2error-try-by-create2kernel4opu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 25/70) - ERROR CODE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            opu2kernel4xi['CODE2ERROR'] = task4kernel2opu['CODE2ERROR']
            
            message2print = "{(Step 25B/70) initialized" + "; code2error-created-by-create2kernel4opu: " + str(opu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            
            code2ack  = code2ack + '25B-'
        except: 
            message2print = "{(Step 25Z1/70) yielded" + "; code2error-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '25Z1-'
                            
    if 'QUEUE' not in keys2task: 
        try:
            # ---------------------------------------------------------------------------------------------
            # (6) QUEUE - REQUIRED                          
            # ---------------------------------------------------------------------------------------------         
            queue2opu = None
            
            message2print = "{(Step 6A/70) trying" + "; queue2opu-trying-by-create2kernel4opu: " + str(queue2opu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2opu = Queue4Xi()                                                                              # THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 6B/70) got" + "; queue2opu-got-by-create2kernel4opu: " + str(queue2opu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # <queue4xi.Queue4Xi object at 0x0000000003C63DD8>
                
                code2ack  = code2ack + '6B-'  
            except:
                message2print = "{(Step 6Z/70) failed" + "; queue2opu-failed-by-create2kernel4opu: " + str(queue2opu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '6Z-'
                
            task4kernel2opu ['QUEUE'] = queue2opu
        except:
            message2print = "{(Step 26Z1/70) yielded" + "; queue-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '26Z1-'             

    if 'QUEUE' in keys2task:          
        message2print = "{(Step 26A/70) try" + "; queue-try-by-create2kernel4opu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 26/70) - QUEUE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            opu2kernel4xi['QUEUE'] = task4kernel2opu['QUEUE']
            
            message2print = "{(Step 26B/70) initialized" + "; queue-created-by-create2kernel4opu: " + str(opu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <queue4xi.Queue4Xi object at 0x0000000003E72828> 
            
            code2ack  = code2ack + '26B-'
        except: 
            message2print = "{(Step 26Z2/70) yielded" + "; queue-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '26Z2-' 
              
    if 'PIPE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (7) PIPE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------         
            pipe2opu = None
           
            message2print = "{(Step 7A/70) trying" + "; pipe2opu-trying-by-create2kernel4opu: " + str(pipe2opu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2opu = Pipe4Xi()                                                                                # THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 7B/70) got" + "; pipe2opu-got-by-create2kernel4opu: " + str(pipe2opu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # (<read-write PipeConnection, handle 384>, <read-write PipeConnection, handle 388>)
                
                code2ack  = code2ack + '7B-'  
            except:
                message2print = "{(Step 7Z/70) failed" + "; pipe2opu-failed-by-create2kernel4opu: " + str(pipe2opu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '7Z-'
                
            task4kernel2opu ['PIPE'] = pipe2opu 
        except: 
            message2print = "{(Step 27Z1/70) yielded" + "; pipe-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '27Z1-'
                                 
    if 'PIPE' in keys2task:                                
        message2print = "{(Step 27A/70) try" + "; pipe-try-by-create2kernel4opu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 27/70) - PIPE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            opu2kernel4xi['PIPE'] = task4kernel2opu['PIPE']
            
            message2print = "{(Step 27B/70) initialized" + "; pipe-created-by-create2kernel4opu: " + str(opu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # (<read-write PipeConnection, handle 388>, <read-write PipeConnection, handle 392>)
            
            code2ack  = code2ack + '27B-'
        except: 
            message2print = "{(Step 27Z2/70) yielded" + "; pipe-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '27Z2-' 

    if 'COMMANDQUEUE' in keys2task:
        message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-create2kernel4opu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (28) COMMAND QUEUE - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            opu2kernel4xi['COMMANDQUEUE']  = task4kernel2opu['COMMANDQUEUE']  
     
            message2print = "{(Step 28B/70) initialized" + "; commandqueue-created-by-create2kernel4opu: " + str(opu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                    
            code2ack  = code2ack + '28B-'
        except: 
            message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
                  
            code2nack  = code2nack + '28Z1-'    
    
    if 'BUFFER' in keys2task:
        message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-create2kernel4opu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (29) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            opu2kernel4xi['BUFFER']  = task4kernel2opu['BUFFER']  
     
            message2print = "{(Step 29B/70) initialized" + "; bufferinfo-created-by-create2kernel4opu: " + str(opu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
            
            
            code2ack  = code2ack + '29B-'
        except: 
            message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '29Z1-'            
    
    if 'EVENT' in keys2task:
        message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-create2kernel4opu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (30) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            opu2kernel4xi['EVENT']  = task4kernel2opu['EVENT']  
     
            message2print = "{(Step 30B/70) initialized" + "; eventinfo-created-by-create2kernel4opu: " + str(opu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'DATA2CALLBACK' ... 
            
            code2ack  = code2ack + '30B-'
        except: 
            message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '30Z1-'
                        
    
    if 'COUNT4PY' in keys2task:               
        message2print = "{(Step 31A1/70) try" + "; count2py4opu-try-by-create2kernel4opu: " + str(task4kernel2opu['COUNT4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4PY - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['COUNT4PY']  = task4kernel2opu['COUNT4PY']  
    
            message2print = "{(Step 31A2/70) initialized" + "; count2py4opu-created-by-create2kernel4opu: " + str(opu2kernel4xi['COUNT4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31A2-'
        except: 
            message2print = "{(Step 31Z1/70) yielded" + "; count2py4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z1-'     
    
    if 'COUNT4CPP' in keys2task:               
        message2print = "{(Step 31B1/70) try" + "; count2cpp4opu-try-by-create2kernel4opu: " + str(task4kernel2opu['COUNT4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4CPP - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['COUNT4CPP']  = task4kernel2opu['COUNT4CPP']  
    
            message2print = "{(Step 31B2/70) initialized" + "; count2cpp4opu-created-by-create2kernel4opu: " + str(opu2kernel4xi['COUNT4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31B2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2cpp4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
            
    
    if 'COUNT4C' in keys2task:               
        message2print = "{(Step 31C1/70) try" + "; count2c4opu-try-by-create2kernel4opu: " + str(task4kernel2opu['COUNT4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4C - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['COUNT4C']  = task4kernel2opu['COUNT4C']  
    
            message2print = "{(Step 31C2/70) initialized" + "; count2c4opu-created-by-create2kernel4opu: " + str(opu2kernel4xi['COUNT4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31C2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2c4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
    
    if 'COUNT4CL' in keys2task:               
        message2print = "{(Step 31D1/70) try" + "; count2cl4opu-try-by-create2kernel4opu: " + str(task4kernel2opu['COUNT4CL'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4CL - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['COUNT4CL']  = task4kernel2opu['COUNT4CL']  
    
            message2print = "{(Step 31D2/70) initialized" + "; count2cl4opu-created-by-create2kernel4opu: " + str(opu2kernel4xi['COUNT4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31D2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2cl4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
                
    if 'COUNT4PYC' in keys2task:               
        message2print = "{(Step 31E1/70) try" + "; count4pyc-try-by-create2kernel4opu: " + str(task4kernel2opu['COUNT4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4PYC - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['COUNT4PYC']  = task4kernel2opu['COUNT4PYC']  
    
            message2print = "{(Step 31E2/70) initialized" + "; count4pyc-created-by-create2kernel4opu: " + str(opu2kernel4xi['COUNT4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '31E2-'
        except: 
            message2print = "{(Step 31Z4/70) yielded" + "; count4pyc-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z4-'     
    
    if 'COUNT4BIN' in keys2task:               
        message2print = "{(Step 31F1/70) try" + "; count4bin-try-by-create2kernel4opu: " + str(task4kernel2opu['COUNT4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0 
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4BIN - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['COUNT4BIN']  = task4kernel2opu['COUNT4BIN']  
    
            message2print = "{(Step 31F2/70) initialized" + "; count4bin-created-by-create2kernel4opu: " + str(opu2kernel4xi['COUNT4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 0
            code2ack  = code2ack + '31F2-'
        except: 
            message2print = "{(Step 31Z5/70) yielded" + "; count4bin-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z5-' 
                            
    if 'DIRECTORY4PY' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A) DIRECTORY4PY - REQUIRED                
            # ---------------------------------------------------------------------------------------------             
            dir2py4opu = folder2lib4opu                                                                                                                                                            
            message2print = "{(Step 32A/70) set" + "; dir2py4opu-set-by-create2kernel4opu to: " + str(dir2py4opu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4opu 
            code2ack  = code2ack + '32A-' 
        
            task4kernel2opu ['DIRECTORY4PY'] = dir2py4opu
        except: 
            message2print = "{(Step 32AZ/70) yielded" + "; directory4py-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32AZ-'                         
               
    if 'DIRECTORY4PY' in keys2task:
        message2print = "{(Step 32A1/70) try" + "; directory4py-try-by-create2kernel4opu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4PY - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['DIRECTORY4PY']  = task4kernel2opu['DIRECTORY4PY']  
     
            message2print = "{(Step 32B1/70) initialized" + "; directory2py4opu-created-by-create2kernel4opu: " + str(opu2kernel4xi['DIRECTORY4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4opu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z1/70) yielded" + "; directory2py4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
             
    if 'DIRECTORY4CPP' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4CPP - C++                 
            # ---------------------------------------------------------------------------------------------             
            dir2cpp4opu = folder2lib4opu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2cpp4opu-set-by-create2kernel4opu to: " + str(dir2cpp4opu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4opu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2opu ['DIRECTORY4CPP'] = dir2cpp4opu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4CPP' in keys2task:
        message2print = "{(Step 32A2/70) try" + "; directory2cpp4opu-try-by-create2kernel4opu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4CPP - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['DIRECTORY4CPP']  = task4kernel2opu['DIRECTORY4CPP']  
     
            message2print = "{(Step 32B2/70) initialized" + "; directory2cpp4opu-created-by-create2kernel4opu: " + str(opu2kernel4xi['DIRECTORY4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4opu
            code2ack  = code2ack + '32B2-'
        except: 
            message2print = "{(Step 32Z2/70) yielded" + "; directory2cpp4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
                         
    if 'DIRECTORY4C' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4C - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2c4opu = folder2lib4opu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2c4opu-set-by-create2kernel4opu to: " + str(dir2c4opu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4opu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2opu ['DIRECTORY4C'] = dir2c4opu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4C' in keys2task:
        message2print = "{(Step 32A3/70) try" + "; directory2c4opu-try-by-create2kernel4opu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4C - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['DIRECTORY4C']  = task4kernel2opu['DIRECTORY4C']  
     
            message2print = "{(Step 32B3/70) initialized" + "; directory2c4opu-created-by-create2kernel4opu: " + str(opu2kernel4xi['DIRECTORY4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4opu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z3/70) yielded" + "; directory2c4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
             
    if 'DIRECTORY4CL' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4CL - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2cl4opu = folder2lib4opu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2cl4opu-set-by-create2kernel4opu to: " + str(dir2cl4opu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4opu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2opu ['DIRECTORY4CL'] = dir2cl4opu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4CL' in keys2task:
        message2print = "{(Step 32A4/70) try" + "; directory2cl4opu-try-by-create2kernel4opu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4CL - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['DIRECTORY4CL']  = task4kernel2opu['DIRECTORY4CL']  
     
            message2print = "{(Step 32B4/70) initialized" + "; directory2cl4opu-created-by-create2kernel4opu: " + str(opu2kernel4xi['DIRECTORY4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4opu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z4/70) yielded" + "; directory2cl4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-'
              
    if 'DIRECTORY4PYC' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4PYC - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2pycache4opu = folder2lib4opu + '__pycache__//'                                                                                                                                                           
            message2print = "{(Step 32B2/70) set" + "; dir2pycache4opu-set-by-create2kernel4opu to: " + str(dir2pycache4opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4opu + '__pycache__//'
            code2ack  = code2ack + '32B2-' 
        
            task4kernel2opu ['DIRECTORY4PYC'] = dir2pycache4opu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'                     
                                                    
    if 'DIRECTORY4PYC' in keys2task:
        message2print = "{(Step 32C/70) try" + "; directory2pyc4opu-try-by-create2kernel4opu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4PYC - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['DIRECTORY4PYC']  = task4kernel2opu['DIRECTORY4PYC']  
     
            message2print = "{(Step 32D/70) initialized" + "; directory2pyc4opu-created-by-create2kernel4opu: " + str(opu2kernel4xi['DIRECTORY4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4opu + __pycache__//
            code2ack  = code2ack + '32D-'
        except: 
            message2print = "{(Step 32Z2/70) yielded" + "; directory2pyc4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z2-' 
             
    if 'DIRECTORY4BIN' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4BIN - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2bin4opu = folder2lib4opu + 'bin//'                                                                                                                                                           
            message2print = "{(Step 12A3/70) set" + "; dir2bin4opu-set-by-create2kernel4opu to: " + str(dir2bin4opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4opu + 'bin//'
            code2ack  = code2ack + '12A3-' 
        
            task4kernel2opu ['DIRECTORY4BIN'] = dir2bin4opu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4bin-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-' 
                                        
    if 'DIRECTORY4BIN' in keys2task:
        message2print = "{(Step 32E/70) try" + "; directory2bin4opu-try-by-create2kernel4opu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4BIN - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['DIRECTORY4BIN']  = task4kernel2opu['DIRECTORY4BIN']  
     
            message2print = "{(Step 32F/70) initialized" + "; directory2bin4opu-created-by-create2kernel4opu: " + str(opu2kernel4xi['DIRECTORY4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4opu + bin//
            code2ack  = code2ack + '32F-'
        except: 
            message2print = "{(Step 32Z3/70) yielded" + "; directory2bin4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z3-'  
    
                     
    if 'CODE4PY' in keys2task:            
        message2print = "{(Step 33A1/70) try" + "; code2py4oputask-try-by-create2kernel4opu: " + str(task4kernel2opu ['CODE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4opu + 'opu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2: ...
        
        opu2kernel4xi['CODE4PY'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4PY - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['CODE4PY'] = task4kernel2opu ['CODE4PY']
    
     
            message2print = "{(Step 33B1/70) created" + "; code2py4opu-created-by-create2kernel4opu: " + str(opu2kernel4xi['CODE4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4opu + 'opu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2:
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z1/70) yielded" + "; code2py4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi['CODE4PY']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2py4opu2nack  = code2py4opu2nack + '33Z1-'     
                     
    if 'CODE4CPP' in keys2task:            
        message2print = "{(Step 33A2/70) try" + "; code2cpp4oputask-try-by-create2kernel4opu: " + str(len(task4kernel2opu ['CODE4CPP']))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4opu +  opu2dummy4xi5test.cpp
        
        opu2kernel4xi['CODE4CPP'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4CPP - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['CODE4CPP'] = task4kernel2opu ['CODE4CPP']
    
     
            message2print = "{(Step 33B2/70) created" + "; code2cpp4opu-created-by-create2kernel4opu: " + str(len(opu2kernel4xi['CODE4CPP']))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4opu + opu2dummy4xi5test.cpp
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z2/70) yielded" + "; code2cpp4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi['CODE4CPP']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2cpp4opu2nack  = code2cpp4opu2nack + '33Z2-'     
                     
    if 'CODE4C' in keys2task:            
        message2print = "{(Step 33A3/70) try" + "; code2c4oputask-try-by-create2kernel4opu: " + str(task4kernel2opu ['CODE4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4opu + 
        
        opu2kernel4xi['CODE4C'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4C - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['CODE4C'] = task4kernel2opu ['CODE4C']
    
     
            message2print = "{(Step 33B3/70) created" + "; code2c4opu-created-by-create2kernel4opu: " + str(opu2kernel4xi['CODE4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4opu + 
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z3/70) yielded" + "; code2c4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi['CODE4C']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2c4opu2nack  = code2c4opu2nack + '33Z3-'                             
                     
    if 'CODE4CL' in keys2task:            
        message2print = "{(Step 33A4/70) try" + "; code2cl4oputask-try-by-create2kernel4opu: " + str(task4kernel2opu ['CODE4CL'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4opu + 
        
        opu2kernel4xi['CODE4CL'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4CL - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['CODE4CL'] = task4kernel2opu ['CODE4CL']
    
     
            message2print = "{(Step 33B4/70) created" + "; code2cl4opu-created-by-create2kernel4opu: " + str(opu2kernel4xi['CODE4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4opu + 
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z4/70) yielded" + "; code2cl4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi['CODE4CL']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2cl4opu2nack  = code2cl4opu2nack + '33Z1-'     
                                        
    if 'CODE4PYC' in keys2task:            
        message2print = "{(Step 33C/70) try" + "; code2pyc4opu-try-by-create2kernel4opu: " + str(task4kernel2opu ['CODE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4opu + 
        
        opu2kernel4xi['CODE4PYC'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4PYC - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['CODE4PYC'] = task4kernel2opu ['CODE4PYC']
    
     
            message2print = "{(Step 33D/70) created" + "; code2pyc4opu-created-by-create2kernel4opu: " + str(opu2kernel4xi['CODE4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4opu + 
             
            code2ack  = code2ack + '33D-'
        except: 
            message2print = "{(Step 33Z2/70) yielded" + "; code2pyc4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi['CODE4PYC']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2pyc4opu2nack  = code2pyc4opu2nack + '33Z2-'     
                            
    if 'CODE4BIN' in keys2task:            
        message2print = "{(Step 33E/70) try" + "; code2bin4opu2bin4opu-try-by-create2kernel4opu: " + str(task4kernel2opu ['CODE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4opu + 
        
        opu2kernel4xi['CODE4BIN'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4BIN - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['CODE4BIN'] = task4kernel2opu ['CODE4BIN']
    
     
            message2print = "{(Step 33F/70) created" + "; code2bin4opu-created-by-create2kernel4opu: " + str(opu2kernel4xi['CODE4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4opu + 
             
            code2ack  = code2ack + '33F-'
        except: 
            message2print = "{(Step 33Z3/70) yielded" + "; code2bin4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi['CODE4BIN']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2bin4opu2nack  = code2bin4opu2nack + '33Z3-'     
            
    if 'SIZE4PY' in keys2task:        
        message2print = "{(Step 34A1/70) try" + "; size2py4opu-try-by-create2kernel4opu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['SIZE4PY']  = task4kernel2opu['SIZE4PY']  
     
            message2print = "{(Step 34B1/70) initialized" + "; size2py4opu-initialized-by-create2kernel4opu to: " + str(opu2kernel4xi['SIZE4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4opu + 'opu2sampler4xi5test.py': 1337}
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z1/70) yielded" + "; size2py4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
            
    if 'SIZE4CPP' in keys2task:        
        message2print = "{(Step 34A2/70) try" + "; size2cpp4opu-try-by-create2kernel4opu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['SIZE4CPP']  = task4kernel2opu['SIZE4CPP']  
     
            message2print = "{(Step 34B2/70) initialized" + "; size2cpp4opu-initialized-by-create2kernel4opu to: " + str(opu2kernel4xi['SIZE4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4opu + opu2dummy4xi5test.cpp': 333}
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z2/70) yielded" + "; size2cpp4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
    if 'SIZE4C' in keys2task:        
        message2print = "{(Step 34A3/70) try" + "; size2c4opu-try-by-create2kernel4opu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['SIZE4C']  = task4kernel2opu['SIZE4C']  
     
            message2print = "{(Step 34B3/70) initialized" + "; size2c4opu-initialized-by-create2kernel4opu to: " + str(opu2kernel4xi['SIZE4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4opu + 
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z3/70) yielded" + "; size2c4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
    if 'SIZE4CL' in keys2task:        
        message2print = "{(Step 34A4/70) try" + "; size2cl4opu-try-by-create2kernel4opu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['SIZE4CL']  = task4kernel2opu['SIZE4CL']  
     
            message2print = "{(Step 34B4/70) initialized" + "; size2cl4opu-initialized-by-create2kernel4opu to: " + str(opu2kernel4xi['SIZE4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4opu + 
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z4/70) yielded" + "; size2cl4opu-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
                                    
                        
    if 'SIZE4PYC' in keys2task:        
        message2print = "{(Step 34E/70) try" + "; size-try-by-create2kernel4opu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34F) SIZE4PYC - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['SIZE4PYC']  = task4kernel2opu['SIZE4PYC']  
     
            message2print = "{(Step 34F/70) initialized" + "; size-initialized-by-create2kernel4opu to: " + str(opu2kernel4xi['SIZE4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4opu + 
            code2ack  = code2ack + '34F-'
        except: 
            message2print = "{(Step 34Z3/70) yielded" + "; size-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z3-'     
            
    if 'SIZE4BIN' in keys2task:        
        message2print = "{(Step 34G/70) try" + "; size-try-by-create2kernel4opu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34G) SIZE4BIN - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            opu2kernel4xi['SIZE4BIN']  = task4kernel2opu['SIZE4BIN']  
     
            message2print = "{(Step 34H/70) initialized" + "; size-initialized-by-create2kernel4opu to: " + str(opu2kernel4xi['SIZE4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4opu + 
            code2ack  = code2ack + '34H-'
        except: 
            message2print = "{(Step 34Z4/70) yielded" + "; size-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z4-'
                 
    if 'LANGUAGE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (35A0) LANGUAGE - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            task4kernel2opu ['LANGUAGE'] = {}
            
            for key2code4opu in keys2code4opu:
                name2program4opu=os.path.splitext(key2code4opu)                                                     
                key2extension4opu = name2program4opu[1]                                                             
                if key2extension4opu == '.py':                          
                    task4kernel2opu ['LANGUAGE'] ['PY']  = "Python"  
                if key2extension4opu == '.cpp':                          
                    task4kernel2opu ['LANGUAGE'] ['CPP'] = "C++"
                if key2extension4opu == '.c':                          
                    task4kernel2opu ['LANGUAGE'] ['C']   = "C"  
                if key2extension4opu == '.cl':                          
                    task4kernel2opu ['LANGUAGE'] ['CL']  = "CL"                                     
                    
            message2print = "{(Step 15B/70) set" + "; language2task4opu-set-by-create2kernel4opu to: " + str(task4kernel2opu ['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '35B-' 
        except: 
            message2print = "{(Step 35Z0/70) yielded" + "; language-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '35Z0-'
                                     
    if 'LANGUAGE' in keys2task:        
        message2print = "{(Step 35A/70) try" + "; language-try-by-create2kernel4opu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (35) LANGUAGE - PYTHON, C++, C, CL                              
            # ---------------------------------------------------------------------------------------------             
                            
            opu2kernel4xi['LANGUAGE']  = task4kernel2opu['LANGUAGE']  
     
            message2print = "{(Step 35B/70) initialized" + "; language-created-by-create2kernel4opu: " + str(opu2kernel4xi['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '35B-'
        except: 
            message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '35Z1-'  
                     
    if 'COUNT2REFERENCE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (36A0) COUNT2REFERENCE - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            count2reference2opu  = 1
           
            message2print = "{(Step 36B/70) set" + "; count2reference2opu-set-by-create2kernel4opu to: " + str(count2reference2opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1 
            code2ack  = code2ack + '36B-' 
        
            task4kernel2opu ['COUNT2REFERENCE'] = count2reference2opu     
        except: 
            message2print = "{(Step 36Z0/70) yielded" + "; count2reference2opu-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '36Z0-'             
                
    if 'COUNT2REFERENCE' in keys2task:                
        message2print = "{(Step 36A/70) try" + "; count2reference-try-by-create2kernel4opu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (36) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
                            
            opu2kernel4xi['COUNT2REFERENCE']  = task4kernel2opu['COUNT2REFERENCE']  
     
            message2print = "{(Step 36B/70) initialized" + "; count2reference-created-by-create2kernel4opu: " + str(opu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '36B-'
        except: 
            message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '36Z1-' 
                
    if 'PROGRAM' not in keys2task:
        message2print = "{(Step 37/70) warned" + "; keys2task4program-warned-by-create2kernel4opu: " + " ** " + str(keys2task)  + " ** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        try:             
            # ---------------------------------------------------------------------------------------------
            # (37A0) PROGRAM - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            task4kernel2opu ['PROGRAM'] = None
            message2print = "{(Step 37A/70) try" + "; program2opu-try-by-create2kernel4opu: " + str(task4kernel2opu ['PROGRAM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #             
            try:
                task4kernel2opu ['PROGRAM'] = create2programwithsource4opu()
                keys2program = task4kernel2opu ['PROGRAM'].keys()
                
                message2print = "{(Step 37B/70) set" + "; program-set-by-create2kernel4opu to: " + str(keys2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # ['CODE2ERROR' ... 
                #  'PROGRAM', 'NACK2RETURN', 'CONTEXT', 'COMMANDQUEUE', 'DEVICE', ... 'PIPE']

                code2ack  = code2ack + '37B-'
            except:
                message2print = "{(Step 37Z1/70) failed" + "; task4kernel2opu-failed-by-create2kernel4opu: " + str(task4kernel2opu ['PROGRAM']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '37Z-'    
        except: 
            message2print = "{(Step 37Z0/70) yielded" + "; program-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z0-' 
                            
    if 'PROGRAM' in keys2task:
        message2print = "{(Step 37A/70) try" + "; program-try-by-create2kernel4opu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (37) PROGRAM - REQUIRED                          
            # ---------------------------------------------------------------------------------------------             
                            
            opu2kernel4xi['PROGRAM']  = task4kernel2opu['PROGRAM']  
     
            message2print = "{(Step 37B/70) initialized" + "; program-created-by-create2kernel4opu: " + str(len(opu2kernel4xi['PROGRAM']))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0 ... 
            
            code2ack  = code2ack + '37B-'
        except: 
            message2print = "{(Step 37Z1/70) yielded" + "; program-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z1-' 
                       
    if 'FUNCTION' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (38) FUNCTION - REQUIRED                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2opu ['FUNCTION'] = {}
            message2print = "{(Step 38A0/70) set" + "; function4opu-set-by-create2kernel4opu to: " + str(task4kernel2opu ['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
             
            task4kernel2opu ['FUNCTION'] ['.py'] = {}
            message2print = "{(Step 38A1/70) set" + "; pythonfunction4opu-set-by-create2kernel4opu to: " + str(task4kernel2opu ['FUNCTION'] ['.py'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
                        
            tag2search4opu  = kb2kernel4opu ['.py'] ['TAG']
            message2print = "{(Step 38A2/70) using" + "; tag2search4opu-using-by-create2kernel4opu: " + str(tag2search4opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # ... function =
            
            value2search4opu    = kb2kernel4opu ['.py'] ['VALUE']
            message2print = "{(Step 38A3/70) using" + "; value2search4opu-using-by-create2kernel4opu: " + str(value2search4opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # opu2sampler4xi5test
            
            attribute2search4opu= kb2kernel4opu ['.py'] ['ATTRIBUTE'] 
            message2print = "{(Step 38A4/70) using" + "; attribute2search4opu-using-by-create2kernel4opu: " + str(attribute2search4opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage =
            try:
                keys2code4opu = task4kernel2opu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4opu in keys2code4opu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4opu = task4kernel2opu ['PROGRAM'] ['CODE4SOURCE'] [key2code4opu]
                    keys2line4opu = code2examine4opu.keys()
                    for key2line4opu in keys2line4opu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4opu = task4kernel2opu ['PROGRAM'] ['CODE4SOURCE'] [key2code4opu] [key2line4opu]
                        # message2print = "{(Step 38A5/70) examining" + "; line2examine4opu-examining-by-create2kernel4opu: " + str(line2examine4opu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        #                             
                        
                        index2pattern = str.find(line2examine4opu,tag2search4opu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 38B/70) examining" + "; line2function4opu-examining-by-create2kernel4opu: " + str(line2examine4opu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # ... function = "set2trace4sampler" ... # function = "opu2sampler4xi5test" usage = "
                             
                            index2function = str.find(line2examine4opu,value2search4opu)
                            if index2function == -1:
                                message2print = "{(Step 38C/70) skipped" + "; line2function4opu-skipped-by-create2kernel4opu: " + str(line2examine4opu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "set2trace4sampler" ... # function = "opu2sampler4xi5test" usage = " ...function = "main" usage = "
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                index2usage = str.find(line2examine4opu,attribute2search4opu)             # ....function = "opu2sampler4xi5test" usage = "
                                if index2usage  == -1:                                                
                                    # ------------------------------------------------------------------------------
                                    # NOT OK KERNEL FUNCTION TAG LINE - USAGE ATTRIBUTE MISSING
                                    # ------------------------------------------------------------------------------
                                    message2print = "{(Step 38D/70) warning" + "; line2function4opu-warning-by-create2kernel4opu: " + str(line2examine4opu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # 
                                    
                                else:
                                    # ------------------------------------------------------------------------------
                                    # OK KERNEL FUNCTION TAG LINE
                                    # ------------------------------------------------------------------------------    
                                    message2print = "{(Step 38E/70) accepted" + "; line2examine4opu-accepted-by-create2kernel4opu: " + str(line2examine4opu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # ... function = "opu2sampler4xi5test" usage = "
                                    # 0123456789012345678901234567890123456789012345678901234
                                    
                                    key2pythonfunction4opu = line2examine4opu[index2function:index2usage-2]
                                    
                                    task4kernel2opu ['FUNCTION'] ['.py'] [key2pythonfunction4opu] = {}                                  

                                    message2print = "{(Step 38F/70) used" + "; key2pythonfunction4opu-used-by-create2kernel4opu: " + str(key2pythonfunction4opu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # opu2sampler4xi5test
                                    
                                    code2ack  = code2ack + '38F-'
                            # -------------------------------------------------------------------------------------
                            # 
                            # -------------------------------------------------------------------------------------                                        
                             
            except:
                message2print = "{(Step 38Z1/70) failed" + "; task4kernel2opu-failed-by-create2kernel4opu: " + str(task4kernel2opu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '38Z-'            
                                    
            # ---------------------------------------------------------------------------------------------
            # (39) FUNCTION - KERNEL FUNCTIONS FROM FECTHED C++ FILE(S) - NOT FROM PROGRAM OBJECT                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2opu ['FUNCTION'] ['.cpp'] = {}            
            message2print = "{(Step 39A0F/70) set" + "; cplusfunction4opu-set-by-create2kernel4opu to: " + str(task4kernel2opu ['FUNCTION'] ['.cpp'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}   
            
            tag2search4opu      = kb2kernel4opu ['.cpp'] ['TAG']
            message2print = "{(Step 39A2/70) using" + "; tag2search4opu-using-by-create2kernel4opu: " + str(tag2search4opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # function =
            
            attribute2search4opu= kb2kernel4opu ['.cpp'] ['ATTRIBUTE'] 
            message2print = "{(Step 39A4/70) using" + "; attribute2search4opu-using-by-create2kernel4opu: " + str(attribute2search4opu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage = kernel
            

            try:
                keys2code4opu = task4kernel2opu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4opu in keys2code4opu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4opu = task4kernel2opu ['PROGRAM'] ['CODE4SOURCE'] [key2code4opu]
                    message2print = "{(Step 39A5/70) using" + "; key2code4opu-using-by-create2kernel4opu: " + str(key2code4opu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # opu2dummy4xi5test.cpp
                       
                    keys2line4opu = code2examine4opu.keys()
                    # message2print = "{(Step 39A6/70) using" + "; keys2line4opu-using-by-create2kernel4opu: " + str(keys2line4opu)  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print) 
                    # 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ...                    
                    for key2line4opu in keys2line4opu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4opu = task4kernel2opu ['PROGRAM'] ['CODE4SOURCE'] [key2code4opu] [key2line4opu]
                        # message2print = "{(Step 39A7/70) examining" + "; line2examine4opu-examining-by-create2kernel4opu: " + str(line2examine4opu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        # function = "nbody_kern" usage = "kernel example 1"*/                        
                        
                        index2pattern = str.find(line2examine4opu,tag2search4opu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG 
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 39B1/70) examining" + "; line2function4opu-examining-by-create2kernel4opu: " + str(line2examine4opu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # function = "OCLError" usage = "error code checking"*/
                            # function = "nbody_kern" usage = "kernel example 1"*/
                            
                            message2print = "{(Step 39B2/70) using" + "; attribute2search4opu-using-by-create2kernel4opu: " + str(attribute2search4opu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            #                                                         
                            index2usage = str.find(line2examine4opu,attribute2search4opu)
                            if index2usage == -1:
                                # ----------------------------------------------------------------------------------
                                # NON KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------                            
                                message2print = "{(Step 39C/70) skipped" + "; line2function4opu-skipped-by-create2kernel4opu: " + str(line2examine4opu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "OCLError" usage = "error code checking"*/
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                message2print = "{(Step 39E/70) accepted" + "; line2examine4opu-accepted-by-create2kernel4opu: " + str(line2examine4opu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "nbody_kern" usage = "kernel example 1"*/; 
                                # function = "nbody2_kern" usage = "kernel example 2"*/ 
                                # 012345678901234567890123456789012345678901234567890
                                 
                                key2kernelfunction4opu = line2examine4opu[27:index2usage-2]  
                                task4kernel2opu ['FUNCTION'] ['.cpp'] [key2kernelfunction4opu] =  {}                                       

                                message2print = "{(Step 39F/70) used" + "; key2kernelfunction4opu-used-by-create2kernel4opu: " + str(key2kernelfunction4opu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # nbody_kern; nbody2_kern 
                                    
                                code2ack  = code2ack + '39F-'
                                    
            except: 
                message2print = "{(Step 37Z1/70) yielded" + "; program-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + '37Z1-'
        except: 
            message2print = "{(Step 37Z0/70) yielded" + "; function-opu2kernel4xi-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z0-'                               
                
    if 'FUNCTION' in keys2task:    
        message2print = "{(Step 38A/70) trying" + "; function-trying-by-create2kernel4opu: " + str(task4kernel2opu['FUNCTION'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {'.py': {'opu2sampler4xi5test': {}}, 
        # '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}}    
        try:            
            # ---------------------------------------------------------------------------------------------
            # (38) FUNCTION - REQUIRED                          
            # ---------------------------------------------------------------------------------------------             
                            
            opu2kernel4xi['FUNCTION']  = task4kernel2opu['FUNCTION']   
     
            message2print = "{(Step 38B/70) created" + "; function-created-by-create2kernel4opu: " + str(opu2kernel4xi['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'.py': {'opu2sampler4xi5test': {}}, '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}} 
            
            code2ack  = code2ack + '38B-'
        except: 
            message2print = "{(Step 38Z1/70) yielded" + "; function-yielded-by-create2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '38Z1-'            
                                       
                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)     
    # -----------------------------------------------------------------------------------------
    opu2kernel4xi ['ACK2RETURN']  = code2ack
    opu2kernel4xi ['NACK2RETURN'] = code2nack 
     
    keys2kernel4opu = opu2kernel4xi.keys()
    message2print = "{(Step 70A/70) returning" + "; keys2kernel4opu-returning-by-create2kernel4opu: " + str(keys2kernel4opu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    #1 (no parameters given by caller): 
    # ['DIRECTORY4CL',
    #  'DIRECTORY4PY',
    #  'DIRECTORY4C',
    #  'DIRECTORY4CPP',
    #  'DIRECTORY4PYC',    
    #  'DIRECTORY4BIN',    
    #  'CODE4PY',
    #  'CODE4PYC',
    #  'CODE4CPP',
    #  'CODE4BIN',
    #  'CODE4C',
    #  'CODE4CL',
    #  'COUNT4C',                
    #  'COUNT4CL',    
    #  'COUNT4CPP',
    #  'COUNT4PYC',
    #  'COUNT4PY',
    #  'COUNT4BIN',
    #  'SIZE4PY',    
    #  'SIZE4CPP', <-- OK: C and CL MISSING
    #  'SIZE4PYC',
    #  'SIZE4BIN',
                        
    #  'QUEUE',
    #  'PROGRAM',
    #  'CONTEXT',
    #  'PIPE',
    #  'FUNCTION2CALLBACK',
    #  'COMMANDQUEUE',
    #  'PLATFORM',
    #  'FUNCTION',
    #  'CODE2ERROR',
    #  'ACK2RETURN',
    #  'DATA2CALLBACK',
    #  'BUFFER',
    #  'COUNT2REFERENCE',
    #  'DEVICE',
    #  'LANGUAGE',
    #  'NACK2RETURN',
    #  'EVENT']



    
    #2 (function and program parameters given by user):
    # ['FUNCTION',
    #  'ACK2RETURN',
    #  'PROGRAM',
    #  'NACK2RETURN']

    
    keys2programkernel4opu = opu2kernel4xi['PROGRAM'].keys()
    message2print = "{(Step 70B/70) returning" + "; keys2programkernel4opu-returning-by-create2kernel4opu: " + str(keys2programkernel4opu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    #1 and 2:
    # ['CODE2ERROR', 'LANGUAGE4SOURCE', 'COUNT4SOURCE' ...
    
    try:
        message2print = "{(Step 70C1/70) returning" + "; count2py4opu-returning-by-create2kernel4opu: " + str(opu2kernel4xi ['COUNT4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1
    except:
        pass    
    
    try:
        message2print = "{(Step 70C2/70) returning" + "; count2cpp4opu-returning-by-create2kernel4opu: " + str(opu2kernel4xi ['COUNT4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1
    except:
        pass    
    
    try:
        message2print = "{(Step 70C3/70) returning" + "; count2c4opu-returning-by-create2kernel4opu: " + str(opu2kernel4xi ['COUNT4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 0
    except:
        pass    
    
    try:
        message2print = "{(Step 70C4/70) returning" + "; count2cl4opu-returning-by-create2kernel4opu: " + str(opu2kernel4xi ['COUNT4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 0
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S1/70) returning" + "; size2py4opu-returning-by-create2kernel4opu: " + str(opu2kernel4xi['SIZE4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # pu2sampler4xi5test.py': 1337
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S2/70) returning" + "; size2cpp4opu-returning-by-create2kernel4opu: " + str(opu2kernel4xi['SIZE4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # opu2dummy4xi5test.cpp': 331
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S3/70) returning" + "; size2c4opu-returning-by-create2kernel4opu: " + str(opu2kernel4xi['SIZE4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S4/70) returning" + "; size2cl4opu-returning-by-create2kernel4opu: " + str(opu2kernel4xi['SIZE4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    


    message2print = "{(Step 70T/70) returning" + "; function2kernel4opu-returning-by-create2kernel4opu: " + str(opu2kernel4xi['FUNCTION']) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # {'.py':  {'opu2sampler4xi5test': {}},
    #  '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}
    # }  
        
    
                         
    return opu2kernel4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "add2kernel4opu" usage = "
#     
#   print('(Step 3A2/700) OF OPU2KERNEL4XI5TEST - TRYING TO ADD KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())        
#   try:
#       task4add2kernel = {}
#       task4add2kernel ['CODE4KERNEL'] = {}
#       task4add2kernel ['CODE4KERNEL'] [folder2lib4opu + 'opu2dummy4xi.py'] = {}
#       task4add2kernel ['CODE4KERNEL'] [folder2lib4opu + 'opu2dummy4xi.py'] [1] = '... profile = "11" />'
#       task4add2kernel ['SIZE4KERNEL'] = {}
#       task4add2kernel ['SIZE4KERNEL'] [folder2lib4opu + 'opu2dummy4xi.py'] = len(task4add2kernel ['CODE4KERNEL'] [folder2lib4opu + 'opu2dummy4xi.py'])
#       
#       response4add2kernel = add2kernel4opu(task4add2kernel)
#       print('(Step 3A3/700) OF OPU2KERNEL4XI5TEST - ADDED KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())
#   except:
#       print('(Step 3Z2/700) OF OPU2KERNEL4XI5TEST *** FAILED TO PRINT response4add2kernel: ', response4add2kernel)
#          
#">

# -------------------------------------------------------------------------------------------------   
def add2kernel4opu(task4kernel2opu):

    '''
    adds to kernel for OPU
    '''
    global opu2kernel4xi                                                                                            # Kernel of OPU    
    global folder2lib4opu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 10/70)      
    # -----------------------------------------------------------------------------------------          
    class2print = "add2kernel4opu" 
    method2print = "add2kernel4opu"

    message2print = "{(Step 10A/70) started" + "; add2kernel4opu-started: " + str(add2kernel4opu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
    message2print = "{(Step 10B/70) passed" + "; task4kernel2opu-to-add2kernel4opu: " + str(task4kernel2opu) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
    code2ack  = ' '
    code2nack = ' ' 
    try:
        keys2kernel4task = task4kernel2opu ['CODE4KERNEL'].keys()
        message2print = "{(Step 10C/70) using" + "; keys2kernel4task-using-by-add2kernel4opu: " + str(keys2kernel4task)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #         
    except: 
        message2print = "{(Step 10Z1/70) failed" + "; keys2kernel4task-failed-by-add2kernel4opu: " + str(task4kernel2opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
    try:
        keys2exist4task =  opu2kernel4xi ['CODE4KERNEL'].keys() 
        message2print = "{(Step 10D/70) using" + "; keys2exist4task-using-by-add2kernel4opu: " + str(keys2exist4task)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
    except:
        try:
            response2createwb4opu = create2kernelsinkernel4opu()
            keys2createwb4opu = response2createwb4opu.keys()
            for key2createwb4opu in keys2createwb4opu:
                if key2createwb4opu == 'CODE4KERNEL':
                    message2print = "{(Step 10E/70) created" + "; key2createwb4opu-created-by-add2kernel4opu: " + str(key2createwb4opu) + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)
                    # 
            
            keys2exist4task =  opu2kernel4xi ['CODE4KERNEL'].keys() 
            message2print = "{(Step 10F/70) using" + "; keys2exist4task-using-by-add2kernel4opu: " + str(keys2exist4task)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        
        except: 
            message2print = "{(Step 10Z2/70) failed" + "; opu2kernel4xi-failed-by-add2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33) CODE - EXPECTED - SEVERAL KERNEL CODE CAN BE ADDED INTO ONE PROGRAM OBJECT                              
        # ---------------------------------------------------------------------------------------------             
        for key2kernel4task in keys2kernel4task:
            try:
                message2print = "{(Step 33A/70) using" + "; key2kernel4task-using-by-add2kernel4opu: " + str(key2kernel4task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                            
                if key2kernel4task in keys2exist4task:
                    message2print = "{(Step 33Z0/70) yielded" + "; key2kernel4task-yielded-by-add2kernel4opu to: " + str(key2kernel4task)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # folder2lib4opu +  
                     
                    code2nack  = code2nack + '33Z0-'
                else: 
                    try:
                        opu2kernel4xi ['CODE4KERNEL'] [key2kernel4task] = task4kernel2opu ['CODE4KERNEL'] [key2kernel4task]
                    except:
                        message2print = "{(Step 33Z1/70) failed" + "; task4kernel2opu-failed-by-add2kernel4opu: " + str(task4kernel2opu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z1-' 
                    try:             
                        message2print = "{(Step 33B/70) added" + "; key2kernel4task-added-by-add2kernel4opu to: " + str(key2kernel4task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        #folder2lib4opu +  
                    except:
                        message2print = "{(Step 33Z2/70) failed" + "; task4kernel2opu-failed-by-add2kernel4opu: " + str(task4kernel2opu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z2-' 
                    try:             
                        message2print = "{(Step 33C/70) added" + "; code-added-by-add2kernel4opu to: " + str(opu2kernel4xi ['CODE4KERNEL'] [key2kernel4task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                    except:
                        message2print = "{(Step 33Z3/70) failed" + "; task4kernel2opu-failed-by-add2kernel4opu: " + str(task4kernel2opu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        code2nack  = code2nack + '33Z3-'                 
                    try:
                        opu2kernel4xi ['COUNT4KERNEL'] = opu2kernel4xi ['COUNT4KERNEL'] + 1
                        message2print = "{(Step 33D/70) added" + "; count4kernel-added-by-add2kernel4opu to: " + str(opu2kernel4xi ['COUNT4KERNEL'])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                    except:
                        message2print = "{(Step 33Z4/70) failed" + "; task4kernel2opu-failed-by-add2kernel4opu: " + str(task4kernel2opu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z4-' 
                    try:                            
                        opu2kernel4xi ['SIZE4KERNEL'] [key2kernel4task]  = task4kernel2opu['SIZE4KERNEL'] [key2kernel4task]  
                        message2print = "{(Step 33E/70) set" + "; size4kernel-set-by-add2kernel4opu to: " + str(opu2kernel4xi ['SIZE4KERNEL'] [key2kernel4task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                        code2ack  = code2ack + '33D-'
                    except:
                        message2print = "{(Step 33Z5/70) failed" + "; task4kernel2opu-failed-by-add2kernel4opu: " + str(task4kernel2opu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z5-'    
            except:
                message2print = "{(Step 33Z6/70) failed" + "; task4kernel2opu-failed-by-add2kernel4opu: " + str(task4kernel2opu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                code2nack  = code2nack + '33Z6-'                     
    except: 
        message2print = "{(Step 33Z7/70) yielded" + "; kernel-yielded-by-add2kernel4opu: " + str(opu2kernel4xi ['CODE4KERNEL']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '33Z7-'       
          
                                                                                                                   
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    opu2kernel4xi ['ACK2RETURN']  = code2ack
    opu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2kernelkernels = opu2kernel4xi ['CODE4KERNEL'].keys()
    for key2kernelkernel in sorted(keys2kernelkernels):
        message2print = "{(Step 70A/70) got" + "; key2kernelkernel-got-by-add2kernel4opu: " + str(key2kernelkernel) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                              
        #folder2lib4opu +  


    keys2kernel4opu = opu2kernel4xi.keys()
    for key2kernel4opu in keys2kernel4opu:
        message2print = "{(Step 70B/70) returning" + "; key2kernel4opu-returning-by-add2kernel4opu: " + str(key2kernel4opu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
        
    return opu2kernel4xi
            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2nativekernel4opu" usage = "
#     
#   print('(Step 2A2/700) OF OPU2KERNEL4XI5TEST - TRYING TO EXECUTE NATIVE KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())           
#   try:
#       response4execute = execute2nativekernel4opu()
#   except:
#       print('(Step 2Z1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO EXECUTE NATIVE KERNEL INTO PROGRAM OBJECT WITH FUNCTION *** ', time4xi())                                                                      
#          
#">

# -------------------------------------------------------------------------------------------------   
def execute2nativekernel4opu(task4program2opu=None):

    '''
    executes native kernel of OPU
    '''
    global opu2kernel4xi                                                                                            # Kernel of OPU    
    global import2use4opu                                                                                           # Imports of OPU
    global target2function4opu                                                                                      # Target function of Process4Xi
    global folder2lib4opu  
            
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2nativekernel4opu" 
    method2print = "execute2nativekernel4opu"

    message2print = "{(Step 1A/70) started" + "; execute2nativekernel4opu-started: " + str(execute2nativekernel4opu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4program2opu-to-execute2nativekernel4opu: " + str(task4program2opu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    kernel2program4opu = {}                                                                                       # INITIALIZES TO EMPTY DICTIONARY
    message2print = "{(Step 1C/70) initialized" + "; kernel2program4opu-initialized-by-execute2nativekernel4opu to: " + str(kernel2program4opu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #                
    try:             
        if task4program2opu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER
            # -----------------------------------------------------------------------------------------    
            pass                                                                       
        else:
            # -----------------------------------------------------------------------------------------
            # PARAMETERS GIVEN ARE OMITTED 
            # -----------------------------------------------------------------------------------------         
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4program2opu-yielded-by-execute2nativekernel4opu: " + str(task4program2opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
       
        code2nack  = code2nack + '1Z1-' 

    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - EXECUTE NATIVE KERNELS INSIDE PROGRAM OBJECT FOR OPU ! 
    # ---------------------------------------------------------------------------------------------    
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) - SOURCE CODE WITHOUT EOL CHARACTERS                            
        # ---------------------------------------------------------------------------------------------             
        keys2kernel4opu = opu2kernel4xi['CODE4KERNEL'].keys()
        message2print = "{(Step 30A/70) using" + "; keys2kernel4opu-using-by-execute2nativekernel4opu: " + str(keys2kernel4opu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        unit4processing = "opu"
        
        for key2kernel4opu in keys2kernel4opu:
            index2search=str.find(key2kernel4opu,unit4processing) 
            if index2search == -1:
                pass
            else:
                target2execute = key2kernel4opu[index2search:]                                                          # opu2sampler4xi5test.py
                index2search=str.find(target2execute,".py")
                if index2search == -1:
                    pass
                else:
                    target2execute4opu = target2execute[:index2search]                                                  
                    message2print = "{(Step 32A/70) set" + "; target2execute4opu-set-by-execute2nativekernel4opu to: " + str(target2execute4opu)  + "; time: " + time4xi() + "}"  
                    print4xi(class2print, method2print, message2print)
                    # 

                    p2kernel4opu = None    
                    try:
                        # ---------------------------------------------------------------------------------------------    
                        # IMPORT TARGET FUNCTION FROM ITS MODULE AS TARGET2FUNCTION4OPU 
                        # ---------------------------------------------------------------------------------------------    
             
                        try:
                            import2use4opu.get(target2execute4opu, handle2error4opu) ()
                            
                            message2print = "{(Step 32B/70) imported" + "; target2execute4opu-imported-by-execute2nativekernel4opu: " + str(target2execute4opu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2ack  = code2ack + '32B-'
                        except:
                            message2print = "{(Step 32Z1/70) failed" + "; import2use4opu-failed-by-execute2nativekernel4opu: " + str(import2use4opu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                            # 
                            message2print = "{(Step 32Z2/70) used" + "; target2execute4opu-used-by-execute2nativekernel4opu: " + str(target2execute4opu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2nack  = code2nack + '32Z2-'
                                    
                        # ---------------------------------------------------------------------------------------------    
                        # CREATE PROCESS WITH TARGET2FUNCTION4OPU
                        # ---------------------------------------------------------------------------------------------                          
                        p2opu = Process4Xi(target=target2function4opu, args=())                                
                        message2print = "{(Step 33A/70) created" + "; p2opu-created-by-execute2nativekernel4opu: " + str(p2opu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # <Process4Xi(Process4Xi-1, initial)>
                        
                        code2ack  = code2ack + '33A-'
                        try:
                            # ---------------------------------------------------------------------------------------------    
                            # START PROCESS
                            # --------------------------------------------------------------------------------------------- 
                            p2opu.start()
                            message2print = "{(Step 34A/70) started" + "; p2opu-started-by-execute2nativekernel4opu: " + str(p2opu.name) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # Process4Xi-1
                            
                            try:
                                # ---------------------------------------------------------------------------------------------    
                                # STATUS OF PROCESS
                                # ---------------------------------------------------------------------------------------------                             
                                status2process4opu = p2opu.is_alive()
                                message2print = "{(Step 35A/70) got" + "; status-got-by-execute2nativekernel4opu: " + str(status2process4opu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # True
                                
                                try:
                                    # ---------------------------------------------------------------------------------------------    
                                    # RUN PROCESS
                                    # ---------------------------------------------------------------------------------------------                                  
                                    p2opu.run()
                                    message2print = "{(Step 36A/70) run" + "; p2opu-run-by-execute2nativekernel4opu: " + str(p2opu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # <Process4Xi(Process4Xi-1, stopped[1])>
                                except:
                                    message2print = "{(Step 36Z/70) failed" + "; run-failed-by-execute2nativekernel4opu: " + str(p2opu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)  
                                    code2nack  = code2nack + '36Z-'            
                                    # 
                            except:
                                message2print = "{(Step 35Z/70) failed" + "; status-failed-by-execute2nativekernel4opu: " + str(p2opu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # 
                                code2nack  = code2nack + '35Z-'                                   
                                
                        except:
                            message2print = "{(Step 33Z/70) failed" + "; start-failed-by-execute2nativekernel4opu: " + str(p2opu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)  
                            code2nack  = code2nack + '33Z-'     
                        
                    except:
                        message2print = "{(Step 32Z/70) failed" + "; p2kernel4opu-failed-by-execute2nativekernel4opu: " + str(p2kernel4opu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        code2nack  = code2nack + '32Z-' 
                                                                                    
            # ---------------------------------------------------------------------------------------------
            # SAVE SOURCE WITHOUT END OF LINES
            # ---------------------------------------------------------------------------------------------        
            keys2lines = opu2kernel4xi['CODE4KERNEL'][key2kernel4opu].keys()     
            kernel2program4opu[key2kernel4opu] = ""
            for key2line in keys2lines:
                code2add4opu = opu2kernel4xi ['CODE4KERNEL'] [key2kernel4opu] [key2line]
                kernel2program4opu[key2kernel4opu] = kernel2program4opu[key2kernel4opu] + code2add4opu.replace("\n","")
        
            message2print = "{(Step 34A/70) saved" + "; lenght-kernel4opu-saved-by-execute2nativekernel4opu to: " + str(len(kernel2program4opu[key2kernel4opu]))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #     
                
 
        message2print = "{(Step 38A/70) set" + "; lenght-kernel2program4opu-set-by-execute2nativekernel4opu to: " + str(len(kernel2program4opu))  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '38A-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; kernel-yielded-by-execute2nativekernel4opu: " + str(opu2kernel4xi['CODE4KERNEL']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '30Z1-'     

                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    opu2kernel4xi ['ACK2RETURN']  = code2ack
    opu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2kernel4opu = kernel2program4opu.keys()
    for key2kernel4opu in keys2kernel4opu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4opu-returning-by-execute2nativekernel4opu: " + str(key2kernel4opu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                              
        # 
    
    return kernel2program4opu
            
#</function4xi> 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "delete2kernel4opu" usage = "
#     
#   print('(Step 3A3/700) OF OPU2KERNEL4XI5TEST - TRYING TO DELETE KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION ', time4xi())        
#   try:
#       task4delete2kernel = {}
#       task4delete2kernel ['CODE4KERNEL'] = {}
#       task4delete2kernel ['CODE4KERNEL'] [folder2lib4opu + 'opu2program4xi.py'] = 'Yes'
#       task4delete2kernel ['SIZE4KERNEL'] = {}
#       task4delete2kernel ['SIZE4KERNEL'] [folder2lib4opu + 'opu2program4xi.py'] = 'Yes'
#       
#       response4delete2kernel = delete2kernel4opu(task4delete2kernel) 
#       print('(Step 3A3/700) OF OPU2KERNEL4XI5TEST - DELETED KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF OPU2KERNEL4XI5TEST *** FAILED TO DELETE KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION *** ', time4xi()) 
#          
#">

# -------------------------------------------------------------------------------------------------   
def delete2kernel4opu(task4kernel2opu):

    '''
    deletes kernel for OPU
    '''
    global opu2kernel4xi                                                                                     
    global folder2lib4opu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 10/70)      
    # -----------------------------------------------------------------------------------------          
    class2print = "delete2kernel4opu" 
    method2print = "delete2kernel4opu"

    message2print = "{(Step 10A/70) started" + "; delete2kernel4opu-started: " + str(delete2kernel4opu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function delete2kernel4opu at 0x000000000405CEC8>
  
    message2print = "{(Step 10B/70) passed" + "; task4kernel2opu-to-delete2kernel4opu: " + str(task4kernel2opu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 


    code2ack  = ' '
    code2nack = ' '    
    #
    ack4key2kernelkernel = False
    try:
        # ---------------------------------------------------------------------------------------------
        # TASK MUST HAVE BEEN GIVEN BY USER - CONTAINS KERNEL KEYS    
        # ---------------------------------------------------------------------------------------------
        keys2delete4kernel = task4kernel2opu ['CODE4KERNEL'].keys()        
        message2print = "{(Step 19A/70) using" + "; keys2delete4kernel-using-by-delete2kernel4opu: " + str(sorted(keys2delete4kernel))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        # ---------------------------------------------------------------------------------------------
        # (Step 20A/70) - DELETE KERNEL INSIDE PROGRAM OBJECT FOR OPU ! 
        # ---------------------------------------------------------------------------------------------    
        message2print = "{(Step 20A0/70) try" + "; key-try-by-delete2kernel4opu: None" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      

        for key2delete4kernel in keys2delete4kernel:
            try:            
                del opu2kernel4xi ['CODE4KERNEL'] [key2delete4kernel]        
               
                message2print = "{(Step 20C/70) deleted" + "; code4kernel-deleted-by-delete2kernel4opu: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                # 
                
                code2ack  = code2ack + '20C-' 
                
                del opu2kernel4xi ['SIZE4KERNEL'] [key2delete4kernel]        
               
                message2print = "{(Step 20D/70) deleted" + "; size4kernel-deleted-by-delete2kernel4opu: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                # 
                
                code2ack  = code2ack + '20D-' 
                
                opu2kernel4xi ['COUNT4KERNEL'] = opu2kernel4xi ['COUNT4KERNEL'] - 1
                message2print = "{(Step 20E/70) upgraded" + "; count4kernel-upgraded-by-delete2kernel4opu: " + str(opu2kernel4xi ['COUNT4KERNEL'] ) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                #                                
                
            except:
                message2print = "{(Step 20Z1/70) yielded" + "; key2delete4kernel-yielded-by-delete2kernel4opu: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #                
                code2nack  = code2nack + '20Z1-' 
    except: 
        message2print = "{(Step 20Z0/70) failed" + "; task4kernel2opu-opu2kernel4xi-failed-by-delete2kernel4opu: " + str(task4kernel2opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '20Z0-'    
                                                                                            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    opu2kernel4xi ['ACK2RETURN']  = code2ack
    opu2kernel4xi ['NACK2RETURN'] = code2nack  
    try:
        keys2kernelkernels = opu2kernel4xi ['CODE4KERNEL'] .keys()
        for key2kernelkernels in keys2kernelkernels:
            message2print = "{(Step 70A/70) got" + "; key2kernelkernels-got-by-delete2kernel4opu: " + str(key2kernelkernels) + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                              
            #  
    except:
        pass 
               
     
    keys2kernel4opu = opu2kernel4xi.keys()
    for key2kernel4opu in keys2kernel4opu:
        message2print = "{(Step 70B/70) returning" + "; key2kernel4opu-returning-by-delete2kernel4opu: " + str(key2kernel4opu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 


    return opu2kernel4xi
            
#</function4xi> 
 



# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2kernelsinprogram4opu" usage = "
#     
#   print('(Step 3A1/700) OF OPU2KERNEL4XI5TEST - TRYING TO CREATE KERNELS IN PROGRAM FOR OPU ', time4xi())          
#   try:
#       response4create2kernelsinprogram = create2kernelsinprogram4opu()
#       print('(Step 3A2/700) OF OPU2KERNEL4XI5TEST - CREATED KERNELS IN PROGRAM FOR OPU ', time4xi())
#   except:
#       print('(Step 3Z1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNELS IN PROGRAM FOR OPU *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def create2kernelsinprogram4opu(task4kernel2opu=None):

    '''
    creates kernels in program for OPU
    '''
    global opu2kernel4xi                                                                                            # Kernel of OPU    
    global folder2lib4opu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START            
    # -----------------------------------------------------------------------------------------          
    class2print = "create2kernelsinprogram4opu" 
    method2print = "create2kernelsinprogram4opu"

    message2print = "{(Step 1A/70) started" + "; create2kernelsinprogram4opu-started: " + str(create2kernelsinprogram4opu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernel2opu-to-create2kernelsinprogram4opu: " + str(task4kernel2opu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    

    
    keys2kernel4opu = opu2kernel4xi.keys()
    for key2kernel4opu in keys2kernel4opu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4opu-returning-by-create2kernelsinprogram4opu: " + str(key2kernel4opu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return opu2kernel4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fetch2kernel4opu" usage = "
#   fetch2kernel4opu(file2walk)
#"> 
# -------------------------------------------------------------------------------------------------
def fetch2kernel4opu(program2explore4opu):
    global fetch2code4opu                                                                                           # dictionary to receive files 
        
    global kb2fetch4opu                                                                                             # knowledgebase for fetching
    global profile2fetch                                                                                            # profiles
    global keys2profile4opu                                                                                         # file extensions 
    
    global folder2lib4opu  

    class2print  = "fetch2kernel4opu"
    method2print = "fetch2kernel4opu" 
     
    message2print = "{(Step 1A/33) passed" + "; program2explore4opu-passed-to-fetch2kernel4opu: " + str(program2explore4opu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # folder2lib4opu + opu2buffer4xi.py          ... opu2sampler4xi5test.py ... opu2dummy4xi5test.cpp ...           # Python and C++ programs
    # __pycache__\opu2buffer4xi.cpython-33.pyc   ... opu2sampler4xi5test.cpython-33.pyc ...                         # Cache of Python binaries
    # //bin\opu2dummy4xi5test.exe                                                                                   # Built C++ exe files
                  
    # ---------------------------------------------------------------------------------------------
    # SPLIT PROGRAM NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2program4opu=os.path.splitext(program2explore4opu)                                                          # opu2sampler4xi5test + py

    key2extension4opu = name2program4opu[1]                                                                         # py,pyc,cpp,exe 
    message2print = "{(Step 1B/33) set" + "; key2extension4opu-set-by-fetch2kernel4opu to: " + str(key2extension4opu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    # .py; .pyc
    message2print = "{(Step 1C/33) using" + "; profile2fetch-using-by-fetch2kernel4opu: " + str(profile2fetch)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    # {'.pyc': 'NACK', '.py': 'ACK', '.cpp': 'ACK', '.exe': 'NACK'}  
        
    if profile2fetch [key2extension4opu] == 'ACK':                                                                  # profile2fetch ['py']  = 'ACK'       
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF FETCH2SCOPE4XI - EXTENSION IN PROFILE 
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1A/33) analyzing" + "; program2explore4opu-analyzing-by-fetch2kernel4opu: " + str(program2explore4opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # folder2lib4opu +  opu2buffer4xi.py ; opu2sampler4xi5test.py ...  ... __pycache__\opu2sampler4xi5test.cpython-33.pyc
        # opu2dummy4xi5test.cpp
             
        path2input4opu = program2explore4opu
        message2print = "{(Step 1B/33) set" + "; path2input4opu-set-by-fetch2kernel4opu to: " + str(path2input4opu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # folder2lib4opu +  opu2buffer4xi.py ; __pycache__\opu2sampler4xi5test.cpython-33.pyc; opu2dummy4xi5test.cpp

        # -----------------------------------------------------------------------------------------
        # (Step 2/33) OF FETCH2SCOPE4XI - CHECKING WHETHER PROGRAM MUST BE FETCHED 
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A1/33) analyzing" + "; path2input4opu-analyzing-by-fetch2kernel4opu: " + str(path2input4opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #folder2lib4opu +  opu2buffer4xi.py ; opu2dummy4xi5test.cpp 
            
        keys2fetch4opu = kb2fetch4opu.keys()
        message2print = "{(Step 2A2/33) using" + "; keys2fetch4opu-using-by-fetch2kernel4opu: " + str(keys2fetch4opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #        
        ack2match4file = False
        for key2fecth4opu in keys2fetch4opu:                                                                        # 1,2 ...
            # -----------------------------------------------------------------------------------------
            # 
            # -----------------------------------------------------------------------------------------
            index2search=str.find(path2input4opu,kb2fetch4opu[key2fecth4opu])                                       
            if index2search == -1:                                         
                # -----------------------------------------------------------------------------------------
                # VALID FILE TYPE BUT NOT SELECTED TO BE FETCHED - OK ONE MAY ALSO PASS HERE!
                # -----------------------------------------------------------------------------------------               
                message2print = "{(Step 2C1/33) skipped" + "; path2input4opu-skipped-by-fetch2kernel4opu: " + str(path2input4opu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                      
                # folder2lib4opu +  opu2buffer4xi.py 
                
            else:
                ack2match4file = True
                
                message2print = "{(Step 2D/33) decided" + "; program-to-read-decided-by-fetch2kernel4opu: " + str(path2input4opu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)        
                #folder2lib4opu +  opu2sampler4xi5test.py; __pycache__//opu2sampler4xi.cpython-33.pyc; 
                #               +  opu2dummy4xi5test.cpp

                # -----------------------------------------------------------------------------------------
                # (Step 3/33) OF FETCH2SCOPE4XI - OPEN INPUT FILE - READ MODE SET ACCORDING TO FILE TYPE
                # -----------------------------------------------------------------------------------------
                if ((key2extension4opu == '.py') or (key2extension4opu == '.cpp') or (key2extension4opu == '.c') or (key2extension4opu == '.cl')):
                    file2input4opu = open(path2input4opu,'r')
                    message2print = "{(Step 3A/33) opened" + "; file2input4opu-opened-by-fetch2kernel4opu: " + str(file2input4opu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    # <_io.TextIOWrapper name=folder2lib4opu + 'opu2sampler4xi5test.py' mode='r' encoding='cp1252'> 
                     
                if ((key2extension4opu == '.pyc') or (key2extension4opu == '.exe')):
                    file2input4opu = open(path2input4opu,'rb')
                    message2print = "{(Step 3B/33) opened" + "; file2input4opu-opened-by-fetch2kernel4opu: " + str(file2input4opu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    #  __pycache__//opu2sampler4xi.cpython-33.pyc               
                    
                # -----------------------------------------------------------------------------------------
                # (Step 4/33) OF FETCH2SCOPE4XI - OUTPUT 
                # -----------------------------------------------------------------------------------------
                key2save4opu = path2input4opu
                fetch2code4opu[key2save4opu] = {}                                                                   # fetch2code4opu['opu2sampler4xi5test.py'] = {}
                number2line4opu = 0  
                message2print = "{(Step 3B/33) saving" + "; key2fecth4opu-saving-by-fetch2kernel4opu: " + str(key2fecth4opu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
         
                while 1:
                    # -------------------------------------------------------------------------------------
                    # (Step 5/33) OF FETCH2SCOPE4XI - PROCESS FILE
                    # -------------------------------------------------------------------------------------             
                    line2process4opu = file2input4opu.readline()  
                    if not line2process4opu:
                        # ---------------------------------------------------------------------------------
                        # (Step 30/33) OF FETCH2SCOPE4XI - ALL LINES READ, FINISH
                        # ---------------------------------------------------------------------------------             
                        break                                               
                    else:
                        # ---------------------------------------------------------------------------------
                        # (Step 7/33) OF FETCH2SCOPE4XI - SAVE LINE
                        # ---------------------------------------------------------------------------------
                        # message2print = "{(Step 7A/33) read" + "; line2process4opu-read-by-fetch2kernel4opu: " + str(line2process4opu) + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print)              
                        # ... profile = "11" />
                        # ...
                        # # end of opu2sampler4xi5test.py 
                        # #/> 
                        try:
                            number2line4opu = number2line4opu + 1
                            fetch2code4opu[key2save4opu][number2line4opu] = line2process4opu
                        except:
                            message2print = "{(Step 7Z1/33) failed" + "; key2fecth4opu-failed-by-fetch2kernel4opu: " + str(key2fecth4opu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            
                            message2print = "{(Step 7Z2/33) failed" + "; line2process4opu-failed-by-fetch2kernel4opu: " + str(line2process4opu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            
                            message2print = "{(Step 7Z3/33) failed" + "; number2line4opu-failed-by-fetch2kernel4opu: " + str(number2line4opu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                                                             
                # -----------------------------------------------------------------------------------------
                # (Step 31/33) OF FETCH2SCOPE4XI - CLOSE INPUT
                # -----------------------------------------------------------------------------------------            
                file2input4opu.close()
                message2print = "{(Step 31A/33) closed" + "; file2input4opu-closed-by-fetch2kernel4opu: " + str(file2input4opu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)           
                # <_io.TextIOWrapper name=folder2lib4opu + 'opu2sampler4xi5test.py' mode='r' encoding='cp1252'>     # Python source files
                # {folder2lib4opu + 'opu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2: '# -- 
                # opu2dummy4xi5test.cpp                                                                             # C++ source files
                # __pycache__//opu2sampler4xi.cpython-33.pyc                                                        # Cached binary files of Python
                # opu2dummy4xi5test.exe                                                                             # C++ exe files
        
                message2print = "{(Step 31B1/33) saved" + "; fetch2code4opu-saved-by-fetch2kernel4opu: " + str(fetch2code4opu[key2save4opu] [1]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ... profile = "11" />
                
                message2print = "{(Step 31B2/33) saved" + "; fetch2code4opu-saved-by-fetch2kernel4opu: " + str(fetch2code4opu[key2save4opu] [2]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # opu2dummy4xi5test.cpp
                
                message2print = "{(Step 31B3/33) saved" + "; fetch2code4opu-saved-by-fetch2kernel4opu: " + str(fetch2code4opu[key2save4opu] [3]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ... program = "opu2sampler4xi5test.py">
                
                message2print = "{(Step 31B4/33) saved" + "; fetch2code4opu-saved-by-fetch2kernel4opu: " + str(fetch2code4opu[key2save4opu] [4]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ...  abstract = "tests opu2sampler4xi.py"/>
                                                                 
                # ---------------------------------------------------------------------------------------------
                #
                # ---------------------------------------------------------------------------------------------                                          


    else:
        # -----------------------------------------------------------------------------------------
        # FILE TYPE - NOT IN PROFILE
        # -----------------------------------------------------------------------------------------       
        message2print = "{(Step 1F/33) skipped" + "; name2program4opu-skipped-by-fetch2kernel4opu: " + str(name2program4opu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # folder2lib4opu + '__pycache__//opu2buffer4xi.cpython-32', '.pyc')
        
        extension2skip = name2program4opu[1]
        message2print = "{(Step 1G/33) skipped" + "; extension-skipped-by-fetch2kernel4opu: " + str(extension2skip[1:])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # pyc

        message2print = "{(Step 1H/33) returning" + "; fetch2kernel4opu-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
 
    message2print = "{(Step 1H/33) returning" + "; fetch2kernel4opu-returning: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)            
    #   
                                            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernel4opu" usage = "
#
#   ... prepare task4set2kernelws ...    
#
#   response4set2kernel = {} 
#   print('(Step 17F/700) OF OPU2KERNEL4XI5TEST - TRYING TO SET KERNEL: ', set2kernel4opu)   
#   # 
#   try:                               
#       response4set2kernel = set2kernel4opu(task4set2kernelws)
#       print('(Step 17G/700) OF OPU2KERNEL4XI5TEST - SET KERNEL: ', response4set2kernel)                                                                                                           
#   except:
#       print('(Step 17Z/700) OF OPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL: ', set2kernel4opu)  
#
#">

# -------------------------------------------------------------------------------------------------   
def set2kernel4opu(task4kernelset2opu=None):

    '''
    sets kernels for OPU
    '''
    global opu2kernel4xi  
    global folder2lib4opu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2kernel4opu"
    method2print = "set2kernel4opu" 

    message2print = "{(Step 1A/33) started" + "; set2kernel4opu-started: " + str(set2kernel4opu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2kernel4opu at 0x0000000003837948> 
    
    keys2task = task4kernelset2opu.keys()
    for key2task in sorted(keys2task):
        message2print = "{(Step 1B/33) passed" + "; key2task-passed-to-set2kernel4opu: " + str(key2task) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # 
        
    code2ack  = ' '
    code2nack = ' '
    # -----------------------------------------------------------------------------------------
    # CREATE IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if opu2kernel4xi is None:
            opu2kernel4xi = create2kernel4opu()                                                                              # INITIALIZE PROGRAM FOR OPU 
            message2print = "{(Step 1C/70) set" + "; opu2kernel4xi-set-by-set2kernel4opu to: " + str(opu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2kernel4opu-skipped-by-set2kernel4opu: " + str(create2kernel4opu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                                 
    except:
        try:
            opu2kernel4xi = create2kernel4opu()
            message2print = "{(Step 1E/70) set" + "; opu2kernel4xi-set-by-set2kernel4opu to: " + str(opu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            opu2kernel4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; opu2kernel4xi-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
                
    # ---------------------------------------------------------------------------------------------
    # SET       
    # ---------------------------------------------------------------------------------------------     
    message2print = "{(Step 22A0/70) try" + "; data2callback-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 21A/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        opu2kernel4xi['DATA2CALLBACK'] = task4kernelset2opu['DATA2CALLBACK']
                                        
        message2print = "{(Step 21A1/70) set" + "; data2callback-set-by-set2kernel4opu to: " + str(opu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        
        code2ack  = code2ack + '21A1-'
    except: 
        message2print = "{(Step 21Z1/70) yielded" + "; data2callback-opu2kernel4xi-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '21Z1-'
    
    message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        opu2kernel4xi['FUNCTION2CALLBACK'] = task4kernelset2opu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 22B1/70) set" + "; function2callback-set-by-set2kernel4opu to: " + str(opu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        code2ack  = code2ack + '22B1-'
    except: 
        message2print = "{(Step 22Z2/70) yielded" + "; function2callback-opu2kernel4xi-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '22Z2-' 
    
    message2print = "{(Step 22C0/70) try" + "; platform2callback-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22C/70) - PLATFORM - EXTRA
        # -----------------------------------------------------------------------------------------               
        opu2kernel4xi['PLATFORM'] = task4kernelset2opu['PLATFORM']
        
        message2print = "{(Step 2C1/70) set" + "; platform-set-by-set2kernel4opu to: " + str(opu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   
        code2ack  = code2ack + '2C1-'
    except: 
        message2print = "{(Step 22Z3/70) yielded" + "; platform-opu2kernel4xi-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '22Z3-' 
        
        
      
    message2print = "{(Step 23A/70) try" + "; context2opu-try-by-set2kernel4opu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 23/70) - CONTEXT - REQUIRED
        # -----------------------------------------------------------------------------------------               
        opu2kernel4xi['CONTEXT'] = task4kernelset2opu['CONTEXT']
        
        message2print = "{(Step 23B/70) set" + "; context-set-by-set2kernel4opu to: " + str(opu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '23B-'
    except: 
        message2print = "{(Step 23Z1/70) yielded" + "; context-opu2kernel4xi-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
        code2nack  = code2nack + '23Z1-' 
        
    message2print = "{(Step 24A/70) try" + "; device-try-by-set2kernel4opu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 24/70) - DEVICE - EXTRA
        # -----------------------------------------------------------------------------------------               
        opu2kernel4xi['DEVICE'] = task4kernelset2opu['DEVICE']
        
        message2print = "{(Step 24B/70) set" + "; device-set-by-set2kernel4opu to: " + str(opu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        
        code2ack  = code2ack + '24B-'
    except: 
        message2print = "{(Step 24Z1/70) yielded" + "; device-opu2kernel4xi-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '24Z1-'
                 
    message2print = "{(Step 25A/70) try" + "; code2error-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 25/70) - ERROR CODE - REQUIRED
        # -----------------------------------------------------------------------------------------               
        opu2kernel4xi['CODE2ERROR'] = task4kernelset2opu['CODE2ERROR']
        
        message2print = "{(Step 25B/70) set" + "; code2error-set-by-set2kernel4opu to: " + str(opu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '25B-'
    except: 
        message2print = "{(Step 25Z1/70) yielded" + "; code2error-opu2kernel4xi-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '25Z1-'                
                
          
    message2print = "{(Step 26A/70) try" + "; queue-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 26/70) - QUEUE - EXTRA
        # -----------------------------------------------------------------------------------------               
        opu2kernel4xi['QUEUE'] = task4kernelset2opu['QUEUE']
        
        message2print = "{(Step 26B/70) set" + "; queue-set-by-set2kernel4opu to: " + str(opu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '26B-'
    except: 
        message2print = "{(Step 26Z1/70) yielded" + "; queue-opu2kernel4xi-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '26Z1-' 
                                
    message2print = "{(Step 27A/70) try" + "; pipe-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 27/70) - PIPE - EXTRA
        # -----------------------------------------------------------------------------------------               
        opu2kernel4xi['PIPE'] = task4kernelset2opu['PIPE']
        
        message2print = "{(Step 27B/70) set" + "; pipe-set-by-set2kernel4opu to: " + str(opu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        code2ack  = code2ack + '27B-'
    except: 
        message2print = "{(Step 27Z1/70) yielded" + "; pipe-opu2kernel4xi-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '27Z1-'   

    message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-set2kernel4opu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (28) COMMAND QUEUE - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        opu2kernel4xi['COMMANDQUEUE']  = task4kernelset2opu['COMMANDQUEUE']  
 
        message2print = "{(Step 28B/70) set" + "; commandqueue-set-by-set2kernel4opu to: " + str(opu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        code2ack  = code2ack + '28B-'
    except: 
        message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '28Z1-'    

    message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-set2kernel4opu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (29) BUFFER INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
        opu2kernel4xi['BUFFER']  = task4kernelset2opu['BUFFER']  
 
        message2print = "{(Step 29B/70) set" + "; bufferinfo-set-by-set2kernel4opu to: " + str(opu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #  
        code2ack  = code2ack + '29B-'
    except: 
        message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '29Z1-'            

    message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-set2kernel4opu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) EVENT INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        opu2kernel4xi['EVENT']  = task4kernelset2opu['EVENT']  
 
        message2print = "{(Step 30B/70) set" + "; eventinfo-set-by-set2kernel4opu to: " + str(opu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '30B-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '30Z1-'
                    
              
    message2print = "{(Step 31A/70) try" + "; count2py4opu-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31)  - COUNT4PY                           
        # ---------------------------------------------------------------------------------------------             
        opu2kernel4xi['COUNT4PY']  = task4kernelset2opu['COUNT4PY']  
 
        message2print = "{(Step 31B/70) set" + "; count2py4opu-set-by-set2kernel4opu to: " + str(opu2kernel4xi['COUNT4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31B-'
    except: 
        message2print = "{(Step 31Z1/70) yielded" + "; count2py4opu-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z1-'  
                
    message2print = "{(Step 31C/70) try" + "; count2pyc4opu-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31C)  - COUNT4PYC                           
        # ---------------------------------------------------------------------------------------------             
        opu2kernel4xi['COUNT4PYC']  = task4kernelset2opu['COUNT4PYC']  
 
        message2print = "{(Step 31D/70) set" + "; count2pyc4opu-set-by-set2kernel4opu to: " + str(opu2kernel4xi['COUNT4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31D-'
    except: 
        message2print = "{(Step 31Z2/70) yielded" + "; count2pyc4opu-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z2-'  
                
    message2print = "{(Step 31E/70) try" + "; count2c4opu-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31E)  - COUNT4C                           
        # ---------------------------------------------------------------------------------------------             
        opu2kernel4xi['COUNT4C']  = task4kernelset2opu['COUNT4C']  
 
        message2print = "{(Step 31F/70) set" + "; count2c4opu-set-by-set2kernel4opu to: " + str(opu2kernel4xi['COUNT4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31F-'
    except: 
        message2print = "{(Step 31Z3/70) yielded" + "; count2c4opu-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z3-'                  
                
    message2print = "{(Step 31G/70) try" + "; count2bin4opu-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31G)  - COUNT4BIN                           
        # ---------------------------------------------------------------------------------------------             
        opu2kernel4xi['COUNT4BIN']  = task4kernelset2opu['COUNT4BIN']  
 
        message2print = "{(Step 31H/70) set" + "; count2bin4opu-set-by-set2kernel4opu to: " + str(opu2kernel4xi['COUNT4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31H-'
    except: 
        message2print = "{(Step 31Z4/70) yielded" + "; count2bin4opu-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z4-'  
        
    message2print = "{(Step 32A/70) try" + "; directory-try-by-set2kernel4opu: " + str(task4kernelset2opu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # 
    
    try:            
        # ---------------------------------------------------------------------------------------------
        # (32B) DIRECTORY4PY - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        opu2kernel4xi['DIRECTORY4PY']  = task4kernelset2opu['DIRECTORY4PY'] 
        
        message2print = "{(Step 32B/70) set" + "; directory2py4opu-set-by-set2kernelwithdirectory2py4opu4opu to: " + str(opu2kernel4xi['DIRECTORY4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32B-'
    except: 
        message2print = "{(Step 32Z1/70) yielded" + "; directory2py4opu-yielded-by-set2kernelwithdirectory2py4opu4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z1-' 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32C) DIRECTORY4PYC - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        opu2kernel4xi['DIRECTORY4PYC']  = task4kernelset2opu['DIRECTORY4PYC'] 
        
        message2print = "{(Step 32C/70) set" + "; directory2pyc4opu-set-by-set2kernelwithdirectory2pyc4opu4opu to: " + str(opu2kernel4xi['DIRECTORY4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32C-'
    except: 
        message2print = "{(Step 32Z2/70) yielded" + "; directory2pyc4opu-yielded-by-set2kernelwithdirectory2pyc4opu4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z2-'

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32D) DIRECTORY4C - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        opu2kernel4xi['DIRECTORY4CPP']  = task4kernelset2opu['DIRECTORY4CPP'] 
        
        message2print = "{(Step 32D/70) set" + "; directory2c4opu-set-by-set2kernelwithdirectory2c4opu4opu to: " + str(opu2kernel4xi['DIRECTORY4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32D-'
    except: 
        message2print = "{(Step 32Z3/70) yielded" + "; directory2c4opu-yielded-by-set2kernelwithdirectory2c4opu4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z3-' 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32E) DIRECTORY4BIN - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        opu2kernel4xi['DIRECTORY4BIN']  = task4kernelset2opu['DIRECTORY4BIN'] 
        
        message2print = "{(Step 32E/70) set" + "; directory2bin4opu-set-by-set2kernelwithdirectory2bin4opu4opu to: " + str(opu2kernel4xi['DIRECTORY4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32E-'
    except: 
        message2print = "{(Step 32Z4/70) yielded" + "; directory2bin4opu-yielded-by-set2kernelwithdirectory2bin4opu4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z34-'         
                         
    message2print = "{(Step 33A/70) try" + "; code2py4opu-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33B) CODE4PY - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        opu2kernel4xi['CODE4PY']  = task4kernelset2opu['CODE4PY']  
 
        message2print = "{(Step 33B/70) set" + "; code2py4opu-set-by-set2kernel4opu to: " + str(opu2kernel4xi['CODE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4opu + 'opu2image4xi5test.py': 
        #  {1: '... profile = "11" />\n', 
        #   2: '... kernel = "opu2image4xi5test.py">\n'}
 
        code2ack  = code2ack + '33B-'
    except: 
        message2print = "{(Step 33Z1/70) yielded" + "; code2py4opu-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2py4opu2nack  = code2py4opu2nack + '33Z1-'        
                         
    message2print = "{(Step 33C/70) try" + "; code2c4opu-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33C) CODE4C - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        opu2kernel4xi['CODE4CPP']  = task4kernelset2opu['CODE4CPP']  
 
        message2print = "{(Step 33D/70) set" + "; code2c4opu-set-by-set2kernel4opu to: " + str(opu2kernel4xi['CODE4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4opu + 
 
        code2c4opu2ack  = code2c4opu2ack + '33D-'
    except: 
        message2print = "{(Step 33Z2/70) yielded" + "; code2c4opu-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2c4opu2nack  = code2c4opu2nack + '33Z2-'                     
                         
    message2print = "{(Step 33D/70) try" + "; code2pyc4opu-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33D) CODE4PYC - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        opu2kernel4xi['CODE4PYC']  = task4kernelset2opu['CODE4PYC']  
 
        message2print = "{(Step 33E/70) set" + "; code2pyc4opu-set-by-set2kernel4opu to: " + str(opu2kernel4xi['CODE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4opu + 
 
        code2pyc4opu2ack  = code2pyc4opu2ack + '33E-'
    except: 
        message2print = "{(Step 33Z3/70) yielded" + "; code2pyc4opu-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2pyc4opu2nack  = code2pyc4opu2nack + '33Z3-'        
                         
    message2print = "{(Step 33F/70) try" + "; code2bin4opu-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33D) CODE4BIN - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        opu2kernel4xi['CODE4BIN']  = task4kernelset2opu['CODE4BIN']  
 
        message2print = "{(Step 33G/70) set" + "; code2bin4opu-set-by-set2kernel4opu to: " + str(opu2kernel4xi['CODE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4opu + 
 
        code2bin4opu2ack  = code2bin4opu2ack + '33G-'
    except: 
        message2print = "{(Step 33Z4/70) yielded" + "; code2bin4opu-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2bin4opu2nack  = code2bin4opu2nack + '33Z4-'                
                
    message2print = "{(Step 34A/70) try" + "; size2py4opu-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34B) SIZE4PY - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        opu2kernel4xi['SIZE4PY']  = task4kernelset2opu['SIZE4PY']  
 
        message2print = "{(Step 34B/70) set" + "; size2py4opu-set-by-set2kernel4opu to: " + str(opu2kernel4xi['SIZE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34B-'
    except: 
        message2print = "{(Step 34Z1/70) yielded" + "; size2py4opu-yielded-by-set2kernel4opu: " + str(task4kernelset2opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z1-'    
                
    message2print = "{(Step 34C/70) try" + "; size2c4opu-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34C) SIZE4C - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        opu2kernel4xi['SIZE4C']  = task4kernelset2opu['SIZE4C']  
 
        message2print = "{(Step 34D/70) set" + "; size2c4opu-set-by-set2kernel4opu to: " + str(opu2kernel4xi['SIZE4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34D-'
    except: 
        message2print = "{(Step 34Z2/70) yielded" + "; size2c4opu-yielded-by-set2kernel4opu: " + str(task4kernelset2opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z2-'
                
    message2print = "{(Step 34E/70) try" + "; size2pyc4opu-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34E) SIZE4PYC - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        opu2kernel4xi['SIZE4PYC']  = task4kernelset2opu['SIZE4PYC']  
 
        message2print = "{(Step 34F/70) set" + "; size2pyc4opu-set-by-set2kernel4opu to: " + str(opu2kernel4xi['SIZE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34F-'
    except: 
        message2print = "{(Step 34Z3/70) yielded" + "; size2pyc4opu-yielded-by-set2kernel4opu: " + str(task4kernelset2opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z3-'          
                
    message2print = "{(Step 34G/70) try" + "; size2bin4opu-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34G) SIZE4BIN - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        opu2kernel4xi['SIZE4BIN']  = task4kernelset2opu['SIZE4BIN']  
 
        message2print = "{(Step 34H/70) set" + "; size2bin4opu-set-by-set2kernel4opu to: " + str(opu2kernel4xi['SIZE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34H-'
    except: 
        message2print = "{(Step 34Z4/70) yielded" + "; size2bin4opu-yielded-by-set2kernel4opu: " + str(task4kernelset2opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z4-'  
        
    
                                  
    message2print = "{(Step 35A/70) try" + "; language-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (35) LANGUAGE (DICTIONARY) - REQUIRED                     
        # ---------------------------------------------------------------------------------------------             
                        
        opu2kernel4xi['LANGUAGE']  = task4kernelset2opu['LANGUAGE']  
 
        message2print = "{(Step 35B/70) set" + "; language-set-by-set2kernel4opu to: " + str(opu2kernel4xi['LANGUAGE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '35B-'
    except: 
        message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '35Z1-'          
                        
    message2print = "{(Step 36A/70) try" + "; count2reference-try-by-set2kernel4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (36) COUNT2REFERENCE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        opu2kernel4xi['COUNT2REFERENCE']  = task4kernelset2opu['COUNT2REFERENCE']  
 
        message2print = "{(Step 36B/70) set" + "; count2reference-set-by-set2kernel4opu to: " + str(opu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '36B-'
    except: 
        message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-set2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '36Z1-'                           

    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    opu2kernel4xi ['ACK2RETURN']  = code2ack
    opu2kernel4xi ['NACK2RETURN'] = code2nack 
    
     
    keys2kernel4opu = opu2kernel4xi.keys()
    for key2kernel4opu in keys2kernel4opu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4opu-returning-by-set2kernel4opu: " + str(key2kernel4opu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 

    return opu2kernel4xi

           
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernelarg4opu" usage = "
#
#   ... prepare task4set2kernelargws ...    
#
#   response4set2kernelarg = {} 
#   print('(Step 17F/700) OF OPU2KERNEL4XI5TEST - TRYING TO SET KERNEL ARGUMENTS : ', set2kernelarg4opu)   
#   # <function set2kernelarg4opu at 0x0000000003837948>
#   try:                               
#       response4set2kernel = set2kernelarg4opu(task4set2kernelargws)
#       print('(Step 17G/700) OF OPU2KERNEL4XI5TEST - SET KERNEL ARGUMENTS: ', set2kernelarg4opu)                                                                                                           
#   except:
#       print('(Step 17Z/700) OF OPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL ARGUMENTS: ', set2kernelarg4opu)  
#
#">

# -------------------------------------------------------------------------------------------------   
def set2kernelarg4opu(task4kernelargset2opu=None):

    '''
    sets kernel arguments for OPU
    '''
    global opu2kernel4xi  
    global folder2lib4opu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2kernelarg4opu"
    method2print = "set2kernelarg4opu" 

    message2print = "{(Step 1A/33) started" + "; set2kernelarg4opu-started: " + str(set2kernelarg4opu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2kernelarg4opu at 0x0000000003837948> 
    
    keys2task = task4kernelargset2opu.keys()
    for key2task in sorted(keys2task):
        message2print = "{(Step 1B/33) passed" + "; key2task-passed-to-set2kernelarg4opu: " + str(key2task) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # 
          
    code2ack  = ' '
    code2nack = ' '
    # -----------------------------------------------------------------------------------------
    # CREATE IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if opu2kernel4xi is None:
            opu2kernel4xi = create2kernel4opu()                                                                              # INITIALIZE PROGRAM FOR OPU 
            message2print = "{(Step 1C/70) set" + "; opu2kernel4xi-set-by-set2kernelarg4opu to: " + str(opu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2kernel4opu-skipped-by-set2kernelarg4opu: " + str(create2kernel4opu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                                 
    except:
        try:
            opu2kernel4xi = create2kernel4opu()
            message2print = "{(Step 1E/70) set" + "; opu2kernel4xi-set-by-set2kernelarg4opu to: " + str(opu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            opu2kernel4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; opu2kernel4xi-yielded-by-set2kernelarg4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
                
    # ---------------------------------------------------------------------------------------------
    # SET       
    # ---------------------------------------------------------------------------------------------     
    message2print = "{(Step 22A0/70) try" + "; data2callback-try-by-set2kernelarg4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 21A/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        opu2kernel4xi['DATA2CALLBACK'] = task4kernelargset2opu['DATA2CALLBACK']
                                        
        message2print = "{(Step 21A1/70) set" + "; data2callback-set-by-set2kernelarg4opu to: " + str(opu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        
        code2ack  = code2ack + '21A1-'
    except: 
        message2print = "{(Step 21Z1/70) yielded" + "; data2callback-opu2kernel4xi-yielded-by-set2kernelarg4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '21Z1-'
    
    message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-set2kernelarg4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        opu2kernel4xi['FUNCTION2CALLBACK'] = task4kernelargset2opu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 22B1/70) set" + "; function2callback-set-by-set2kernelarg4opu to: " + str(opu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        code2ack  = code2ack + '22B1-'
    except: 
        message2print = "{(Step 22Z2/70) yielded" + "; function2callback-opu2kernel4xi-yielded-by-set2kernelarg4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '22Z2-' 
    
    message2print = "{(Step 22C0/70) try" + "; platform2callback-try-by-set2kernelarg4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22C/70) - PLATFORM - EXTRA
        # -----------------------------------------------------------------------------------------               
        opu2kernel4xi['PLATFORM'] = task4kernelargset2opu['PLATFORM']
        
        message2print = "{(Step 2C1/70) set" + "; platform-set-by-set2kernelarg4opu to: " + str(opu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   
        code2ack  = code2ack + '2C1-'
    except: 
        message2print = "{(Step 22Z3/70) yielded" + "; platform-opu2kernel4xi-yielded-by-set2kernelarg4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '22Z3-' 
        
        
      
    message2print = "{(Step 23A/70) try" + "; context2opu-try-by-set2kernelarg4opu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 23/70) - CONTEXT - REQUIRED
        # -----------------------------------------------------------------------------------------               
        opu2kernel4xi['CONTEXT'] = task4kernelargset2opu['CONTEXT']
        
        message2print = "{(Step 23B/70) set" + "; context-set-by-set2kernelarg4opu to: " + str(opu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '23B-'
    except: 
        message2print = "{(Step 23Z1/70) yielded" + "; context-opu2kernel4xi-yielded-by-set2kernelarg4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
        code2nack  = code2nack + '23Z1-' 
        
    message2print = "{(Step 24A/70) try" + "; device-try-by-set2kernelarg4opu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 24/70) - DEVICE - EXTRA
        # -----------------------------------------------------------------------------------------               
        opu2kernel4xi['DEVICE'] = task4kernelargset2opu['DEVICE']
        
        message2print = "{(Step 24B/70) set" + "; device-set-by-set2kernelarg4opu to: " + str(opu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        
        code2ack  = code2ack + '24B-'
    except: 
        message2print = "{(Step 24Z1/70) yielded" + "; device-opu2kernel4xi-yielded-by-set2kernelarg4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '24Z1-'
                 
    message2print = "{(Step 25A/70) try" + "; code2error-try-by-set2kernelarg4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 25/70) - ERROR CODE - REQUIRED
        # -----------------------------------------------------------------------------------------               
        opu2kernel4xi['CODE2ERROR'] = task4kernelargset2opu['CODE2ERROR']
        
        message2print = "{(Step 25B/70) set" + "; code2error-set-by-set2kernelarg4opu to: " + str(opu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '25B-'
    except: 
        message2print = "{(Step 25Z1/70) yielded" + "; code2error-opu2kernel4xi-yielded-by-set2kernelarg4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '25Z1-'                
                
          
    message2print = "{(Step 26A/70) try" + "; queue-try-by-set2kernelarg4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 26/70) - QUEUE - EXTRA
        # -----------------------------------------------------------------------------------------               
        opu2kernel4xi['QUEUE'] = task4kernelargset2opu['QUEUE']
        
        message2print = "{(Step 26B/70) set" + "; queue-set-by-set2kernelarg4opu to: " + str(opu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '26B-'
    except: 
        message2print = "{(Step 26Z1/70) yielded" + "; queue-opu2kernel4xi-yielded-by-set2kernelarg4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '26Z1-' 
                                
    message2print = "{(Step 27A/70) try" + "; pipe-try-by-set2kernelarg4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 27/70) - PIPE - EXTRA
        # -----------------------------------------------------------------------------------------               
        opu2kernel4xi['PIPE'] = task4kernelargset2opu['PIPE']
        
        message2print = "{(Step 27B/70) set" + "; pipe-set-by-set2kernelarg4opu to: " + str(opu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        code2ack  = code2ack + '27B-'
    except: 
        message2print = "{(Step 27Z1/70) yielded" + "; pipe-opu2kernel4xi-yielded-by-set2kernelarg4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '27Z1-'   

    message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-set2kernelarg4opu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (28) COMMAND QUEUE - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        opu2kernel4xi['COMMANDQUEUE']  = task4kernelargset2opu['COMMANDQUEUE']  
 
        message2print = "{(Step 28B/70) set" + "; commandqueue-set-by-set2kernelarg4opu to: " + str(opu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        code2ack  = code2ack + '28B-'
    except: 
        message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-set2kernelarg4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '28Z1-'    

    message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-set2kernelarg4opu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (29) BUFFER INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
        opu2kernel4xi['BUFFER']  = task4kernelargset2opu['BUFFER']  
 
        message2print = "{(Step 29B/70) set" + "; bufferinfo-set-by-set2kernelarg4opu to: " + str(opu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #  
        code2ack  = code2ack + '29B-'
    except: 
        message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-set2kernelarg4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '29Z1-'            

    message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-set2kernelarg4opu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) EVENT INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        opu2kernel4xi['EVENT']  = task4kernelargset2opu['EVENT']  
 
        message2print = "{(Step 30B/70) set" + "; eventinfo-set-by-set2kernelarg4opu to: " + str(opu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '30B-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-set2kernelarg4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '30Z1-'            
                
    message2print = "{(Step 31A/70) try" + "; count4source-try-by-set2kernelarg4opu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31)  - COUNT4SOURCE                           
        # ---------------------------------------------------------------------------------------------             
        opu2kernel4xi['COUNT4SOURCE']  = task4kernelargset2opu['COUNT4SOURCE']  
 
        message2print = "{(Step 31B/70) set" + "; count4source-set-by-set2kernelarg4opu to: " + str(opu2kernel4xi['COUNT4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31B-'
    except: 
        message2print = "{(Step 31Z1/70) yielded" + "; count4source-yielded-by-set2kernelarg4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z1-'  

    message2print = "{(Step 32A/70) try" + "; directory-try-by-set2kernelarg4opu: " + str(task4kernelargset2opu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # {'CODE2ERROR': 0 ... 'DIRECTORY4SOURCE': '...//a' ... 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32) DIRECTORY - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        opu2kernel4xi['DIRECTORY4SOURCE']  = task4kernelargset2opu['DIRECTORY4SOURCE'] 
        
        message2print = "{(Step 32B/70) set" + "; directory-set-by-set2kernelargwithdirectory4opu to: " + str(opu2kernel4xi['DIRECTORY4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # OK
        code2ack  = code2ack + '32B-'
    except: 
        message2print = "{(Step 32Z1/70) yielded" + "; directory-yielded-by-set2kernelargwithdirectory4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z1-' 
        
    message2print = "{(Step 33A/70) try" + "; code-try-by-set2kernelarg4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33) CODE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        opu2kernel4xi['CODE4SOURCE']  = task4kernelargset2opu['CODE4SOURCE']  
 
        message2print = "{(Step 33B/70) set" + "; code-set-by-set2kernelarg4opu to: " + str(opu2kernel4xi['CODE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4opu + 'opu2image4xi5test.py': 
        #  {1: '... profile = "11" />\n', 
        #   2: '... kernelarg = "opu2image4xi5test.py">\n'}
 
        code2ack  = code2ack + '33B-'
    except: 
        message2print = "{(Step 33Z1/70) yielded" + "; code-yielded-by-set2kernelarg4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '33Z1-'             
        
    message2print = "{(Step 34A/70) try" + "; size-try-by-set2kernelarg4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34) SIZE - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        opu2kernel4xi['SIZE4SOURCE']  = task4kernelargset2opu['SIZE4SOURCE']  
 
        message2print = "{(Step 34B/70) set" + "; size-set-by-set2kernelarg4opu to: " + str(opu2kernel4xi['SIZE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34B-'
    except: 
        message2print = "{(Step 34Z1/70) yielded" + "; size-yielded-by-set2kernelarg4opu: " + str(task4kernelargset2opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z1-'    
                
    message2print = "{(Step 35A/70) try" + "; language-try-by-set2kernelarg4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (35) LANGUAGE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        opu2kernel4xi['LANGUAGE4SOURCE']  = task4kernelargset2opu['LANGUAGE4SOURCE']  
 
        message2print = "{(Step 35B/70) set" + "; language-set-by-set2kernelarg4opu to: " + str(opu2kernel4xi['LANGUAGE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '35B-'
    except: 
        message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-set2kernelarg4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '35Z1-'          
                        
    message2print = "{(Step 36A/70) try" + "; count2reference-try-by-set2kernelarg4opu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (36) COUNT2REFERENCE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        opu2kernel4xi['COUNT2REFERENCE']  = task4kernelargset2opu['COUNT2REFERENCE']  
 
        message2print = "{(Step 36B/70) set" + "; count2reference-set-by-set2kernelarg4opu to: " + str(opu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '36B-'
    except: 
        message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-set2kernelarg4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '36Z1-'                           

    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    opu2kernel4xi ['ACK2RETURN']  = code2ack
    opu2kernel4xi ['NACK2RETURN'] = code2nack 
    
     
    keys2kernelarg4opu = opu2kernel4xi.keys()
    for key2kernelarg4opu in keys2kernelarg4opu:
        message2print = "{(Step 70/70) returning" + "; key2kernelarg4opu-returning-by-set2kernelarg4opu: " + str(key2kernelarg4opu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 

    return opu2kernel4xi

           
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2kernel4opu" usage = "
#
#   task4release2kernel  = {} 
#   task4release2kernel  ['COUNT2REFERENCE'] = 1 
#   response4release2kernel = {}
#   
#   print('(Step 18A/700) OF OPU2KERNEL4XI5TEST - TRYING TO RELEASE KERNEL OF OPU DEVICE ', time4xi())    
#   try:                               
#       response4release2kernel = release2kernel4opu(task4release2kernel)
#       print('(Step 18B/700) OF OPU2KERNEL4XI5TEST - RELEASED KERNEL OF OPU DEVICE ', time4xi()) 
#   except:
#       print('(Step 18Z1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL OF OPU DEVICE ', time4xi())                                                                                                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def release2kernel4opu(task4release2opu=None):

    '''
    releases kernel for OPU
    '''
    global opu2kernel4xi  
    global folder2lib4opu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2kernel4opu"
    method2print = "release2kernel4opu" 

    message2print = "{(Step 1A/33) started" + "; release2kernel4opu-started: " + str(release2kernel4opu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    
    message2print = "{(Step 1B/33) passed" + "; task4release2opu-to-release2kernel4opu: " + str(task4release2opu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
    

    code2ack  = ' '
    code2nack = ' '

    try:
        if opu2kernel4xi is None:
            opu2kernel4xi = create2kernel4opu()                                                                       # INITIALIZE KERNEL                 
    except:
        try:
            opu2kernel4xi = create2kernel4opu()
        except:
            opu2kernel4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; opu2kernel4xi-yielded-by-release2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; release-try-by-release2kernel4opu: None"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    if task4release2opu is None:
        task4release2opu = {}
        task4release2opu['COUNT2REFERENCE'] = 1
           
    try:
        # -----------------------------------------------------------------------------------------
        # RELEASE
        # -----------------------------------------------------------------------------------------               
        opu2kernel4xi['COUNT2REFERENCE'] = opu2kernel4xi['COUNT2REFERENCE'] - task4release2opu['COUNT2REFERENCE']
        
        message2print = "{(Step 1A/70) calculated" + "; count2reference-calculated-by-release2kernel4opu: " + str(opu2kernel4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
         
        if opu2kernel4xi['COUNT2REFERENCE'] < 0:
            opu2kernel4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 1B/70) warning" + "; count2reference-warning-by-release2kernel4opu: " + " ** " + str(opu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            # 
             
            code2nack  = code2nack + '1B-'
        else:
            code2ack  = code2ack + '1B-'
    except:
        try:
            opu2kernel4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 8Z1/70) warning" + "; count2reference-warning-by-release2kernel4opu: " + " ** " + str(opu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            code2nack  = code2nack + '8Z1-'
            
        except:
            message2print = "{(Step 8Z2/70) yielded" + "; opu2kernel4xi-yielded-by-release2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '8Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    opu2kernel4xi ['ACK2RETURN']  = code2ack
    opu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2program4opu = opu2kernel4xi.keys()
    for key2program4opu in keys2program4opu:
        message2print = "{(Step 70/70) returning" + "; key2program4opu-returning-by-release2kernel4opu: " + str(key2program4opu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return opu2kernel4xi

#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2kernel4opu" usage = "
#
#   task4retain2kernel  = {} 
#   task4retain2kernel  ['COUNT2REFERENCE'] = 1 
#   response4retain2kernel = {}
#   
#   print('(Step 19A/700) OF OPU2KERNEL4XI5TEST - TRYING TO RETAIN PROGRAM OF OPU DEVICE ', time4xi())    
#   # 
#   try:                               
#       response4retain2kernel = retain2kernel4opu(task4retain2kernel)
#       print('(Step 19B/700) OF OPU2KERNEL4XI5TEST - RETAINED PROGRAM OF OPU DEVICE ', time4xi()) 
#   except:
#       print('(Step 19Z1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO RETAIN PROGRAM OF OPU DEVICE ', time4xi())                                                                                                  
#
#">

# -------------------------------------------------------------------------------------------------   
def retain2kernel4opu(task4retain2opu=None):

    '''
    retains kernel of OPU
    '''
    global opu2kernel4xi 
    global folder2lib4opu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2kernel4opu"
    method2print = "retain2kernel4opu"

    message2print = "{(Step 1A/33) started" + "; retain2kernel4opu-started: " + str(retain2kernel4opu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    
    message2print = "{(Step 1B/33) passed" + "; task4retain2opu-to-retain2kernel4opu: " + str(task4retain2opu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
    
    code2ack  = ' '
    code2nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # (Step 2/70) - PROVIDE TASKS, IF NECESSARY AND CHECK GIVEN TASKS 
    # -----------------------------------------------------------------------------------------    
    if task4retain2opu is None:
        task4retain2opu = {}
        task4retain2opu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 2A/33) set" + "; task4retain2opu-set-by-retain2kernel4opu to: " + str(task4retain2opu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
    else:
        pass

    
    # -----------------------------------------------------------------------------------------
    # (Step 3/70) - CHECK COUNT2REFERENCE
    # -----------------------------------------------------------------------------------------         
    if 'COUNT2REFERENCE' in task4retain2opu.keys():
        pass
    else:
        task4retain2opu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3A/33) set" + "; count2reference-set-by-retain2kernel4opu to: " + str(task4retain2opu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
                                   
    if task4retain2opu['COUNT2REFERENCE'] < 1:
        task4retain2opu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3B/33) set" + "; count2reference-set-by-retain2kernel4opu to: " + str(task4retain2opu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
        
    # -----------------------------------------------------------------------------------------
    # (Step 4/70) - INITIALIZE PROGRAM IF NECESSARY
    # -----------------------------------------------------------------------------------------
    try:
        if opu2kernel4xi is None:
            opu2kernel4xi = create2kernel4opu()
            message2print = "{(Step 4A/70) created" + "; opu2kernel4xi-created-by-retain2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                                                          
    except:
        try:
            opu2kernel4xi = create2kernel4opu()
            message2print = "{(Step 4B/70) created" + "; opu2kernel4xi-created-by-retain2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                 
        except:
            opu2kernel4xi = {}
            message2print = "{(Step 4Z/70) yielded" + "; opu2kernel4xi-yielded-by-retain2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '4Z-' 


    # -----------------------------------------------------------------------------------------
    # (Step 5/70) - RETAIN
    # -----------------------------------------------------------------------------------------             
    try:
        opu2kernel4xi['COUNT2REFERENCE'] = opu2kernel4xi['COUNT2REFERENCE'] + task4retain2opu['COUNT2REFERENCE']
        message2print = "{(Step 6A/70) calculated" + "; count2reference-calculated-by-retain2kernel4opu: " + str(opu2kernel4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1            
        if opu2kernel4xi['COUNT2REFERENCE'] <= 0:
            opu2kernel4xi['COUNT2REFERENCE'] = 1
            message2print = "{(Step 6Z1/70) warning" + "; count2reference-warning-by-retain2kernel4opu: " + " ** " + str(opu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            code2nack  = code2nack + '6Z1-'
        else:
            code2ack  = code2ack + '6C-'

    except:
        try:
            opu2kernel4xi['COUNT2REFERENCE'] = 1
        
            message2print = "{(Step 7Z1/70) warning" + "; count2reference-warning-by-retain2kernel4opu: " + " ** " + str(opu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '7Z1-'
        
        except:
            message2print = "{(Step 7Z2/70) yielded" + "; opu2kernel4xi-yielded-by-retain2kernel4opu: " + str(opu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '7Z2-'
        
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70) - RETURN           
    # -----------------------------------------------------------------------------------------
    
    opu2kernel4xi ['ACK2RETURN']  = code2ack
    opu2kernel4xi ['NACK2RETURN'] = code2nack     
     
    keys2program4opu = opu2kernel4xi.keys()
    for key2program4opu in keys2program4opu:
        message2print = "{(Step 70/70) returning" + "; key2program4opu-returning-by-retain2kernel4opu: " + str(key2program4opu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return opu2kernel4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelinfo4opu" usage = "
#
#   print('(Step 3B1/700) OF OPU2KERNEL4XI5TEST - TRYING TO GET KERNEL INFORMATION FOR OPU ', time4xi())     
#   try:
#       response4kernelinfo2opu = get2kernelinfo4opu() 
#       print('(Step 3B2/700) OF OPU2KERNEL4XI5TEST - GOT KERNEL INFORMATION FOR OPU ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF OPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL INFORMATION FOR OPU', time4xi())                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelinfo4opu(task4getinfo2kernel=None):

    '''
    gets kernel information of OPU
    '''
    
    global opu2kernel4xi
    global folder2lib4opu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelinfo4opu"
    method2print = "get2kernelinfo4opu"

    message2print = "{(Step 0A/33) started" + "; get2kernelinfo4opu-started: " + str(get2kernelinfo4opu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2kernel-passed-to-get2kernelinfo4opu: " + str(task4getinfo2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    opu2kernel = {}
    try: 
        if opu2kernel4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR OPU           
            # -------------------------------------------------------------------------------------           
            opu2kernel = create2kernel4opu()
            message2print = "{(Step 1B2/33) initialized" + "; opu2kernel-initialized-by-get2kernelinfo4opu to: " + str(opu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; opu2kernel4xi-using-by-get2kernelinfo4opu: " + str(opu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF OPU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2kernel is None:
            task4getinfo2kernel = {}
            opu2kernel = opu2kernel4xi
            message2print = "{(Step 1C/33) using" + "; opu2kernel-got-by-get2kernelinfo4opu: " + str(opu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4kernelinfo = task4getinfo2kernel.keys()
        keys2task = task4getinfo2kernel.keys()
            
        # -------------------------------------------------------------------------------------
        # SOURCE OR BINARY PROGRAM INFO OF OPU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2kernel4opu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                opu2kernel [key2task] = opu2kernel4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-opu2kernel-set-by-get2kernelinfo4opu to: " + str(opu2kernel [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2kernel4opu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2kernel-using-by-get2kernel4opu: " + str(task4getinfo2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; opu2kernel4xi-using-by-get2kernel4opu: " + str(opu2kernel4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE PROGRAM WITH SOURCE DATA           
            # -------------------------------------------------------------------------------------           
            opu2kernel = create2kernel4opu()
            
            message2print = "{(Step 1F/33) initialized" + "; opu2kernel-initialized-by-get2kernelinfo4opu to: " + str(opu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2kernel is None:
                opu2kernel = opu2kernel4xi
                message2print = "{(Step 1G/33) set" + "; opu2kernel-set-by-get2kernelinfo4opu to: " + str(opu2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2kernel.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2kernel4opu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        opu2kernel [key2task] = opu2kernel4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-opu2kernel -set-by-get2kernelinfo4opu to: " + str(opu2kernel  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2kernel4opu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            opu2kernel = {}
            message2print = "{(Step 1Z3/70) yielded" + "; opu2kernel-yielded-by-get2kernel4opu: " + str(opu2kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
     
    keys2kernel4opu = opu2kernel4xi.keys()
    for key2kernel4opu in keys2kernel4opu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4opu-returning-by-get2kernelinfo4opu: " + str(key2kernel4opu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # CODE2ERROR ...
        
    return opu2kernel
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelarginfo4opu" usage = "
#
#   print('(Step 3B1/700) OF OPU2KERNEL4XI5TEST - TRYING TO GET KERNEL ARGUMENTGS INFO FOR OPU ', time4xi())     
#   try:
#       response4kernelinfo2opu = get2kernelarginfo4opu(task4getinfo2kernel) 
#       print('(Step 3B2/700) OF OPU2KERNEL4XI5TEST - GOT KERNEL ARGUMENTGS INFO FOR OPU ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF OPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL ARGUMENTGS INFO FOR OPU ', time4xi())                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelarginfo4opu(task4getinfo2kernel=None):

    '''
    gets kernel argument information of OPU
    '''
    
    global opu2kernel4xi
    global folder2lib4opu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelarginfo4opu"
    method2print = "get2kernelarginfo4opu"

    message2print = "{(Step 0A/33) started" + "; get2kernelarginfo4opu-started: " + str(get2kernelarginfo4opu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2kernel-passed-to-get2kernelarginfo4opu: " + str(task4getinfo2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    opu2kernel = {}
    try: 
        if opu2kernel4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR OPU           
            # -------------------------------------------------------------------------------------           
            opu2kernel = create2kernel4opu()
            message2print = "{(Step 1B2/33) initialized" + "; opu2kernel-initialized-by-get2kernelarginfo4opu to: " + str(opu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; opu2kernel4xi-using-by-get2kernelarginfo4opu: " + str(opu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF OPU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2kernel is None:
            task4getinfo2kernel = {}
            opu2kernel = opu2kernel4xi
            message2print = "{(Step 1C/33) using" + "; opu2kernel-got-by-get2kernelarginfo4opu: " + str(opu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4kernelinfo = task4getinfo2kernel.keys()
        keys2task = task4getinfo2kernel.keys()
            
        # -------------------------------------------------------------------------------------
        # SOURCE OR BINARY PROGRAM INFO OF OPU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2kernel4opu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                opu2kernel [key2task] = opu2kernel4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-opu2kernel-set-by-get2kernelarginfo4opu to: " + str(opu2kernel [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2kernel4opu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2kernel-using-by-get2kernel4opu: " + str(task4getinfo2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; opu2kernel4xi-using-by-get2kernel4opu: " + str(opu2kernel4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE PROGRAM WITH SOURCE DATA           
            # -------------------------------------------------------------------------------------           
            opu2kernel = create2kernel4opu()
            
            message2print = "{(Step 1F/33) initialized" + "; opu2kernel-initialized-by-get2kernelarginfo4opu to: " + str(opu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2kernel is None:
                opu2kernel = opu2kernel4xi
                message2print = "{(Step 1G/33) set" + "; opu2kernel-set-by-get2kernelarginfo4opu to: " + str(opu2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2kernel.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2kernel4opu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        opu2kernel [key2task] = opu2kernel4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-opu2kernel -set-by-get2kernelarginfo4opu to: " + str(opu2kernel  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2kernel4opu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            opu2kernel = {}
            message2print = "{(Step 1Z3/70) yielded" + "; opu2kernel-yielded-by-get2kernel4opu: " + str(opu2kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
     
    keys2kernel4opu = opu2kernel4xi.keys()
    for key2kernel4opu in keys2kernel4opu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4opu-returning-by-get2kernelarginfo4opu: " + str(key2kernel4opu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
        
    return opu2kernel
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2buildinfo4opu" usage = "
#
#   response4get2buildinfo = get2buildinfo4opu()
#            
#">

# -------------------------------------------------------------------------------------------------   
def get2buildinfo4opu(task4getinfo2build=None):

    '''
    gets opu2build4xi and opu2build4xi
    '''
    
    global opu2build4xi
    global folder2lib4opu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2buildinfo4opu"
    method2print = "get2buildinfo4opu"

    message2print = "{(Step 0A/33) started" + "; get2buildinfo4opu-started: " + str(get2buildinfo4opu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2build-passed-to-get2buildinfo4opu: " + str(task4getinfo2build) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    opu2build = {}
    try: 
        if opu2build4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR OPU           
            # -------------------------------------------------------------------------------------           
            opu2build = {}
            message2print = "{(Step 1B2/33) initialized" + "; opu2build-initialized-by-get2buildinfo4opu to: " + str(opu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; opu2build4xi-using-by-get2buildinfo4opu: " + str(opu2build4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF OPU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2build is None:
            task4getinfo2build = {}
            opu2build = opu2build4xi
            message2print = "{(Step 1C/33) using" + "; opu2build-got-by-get2buildinfo4opu: " + str(opu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4buildinfo = task4getinfo2build.keys()
        keys2task = task4getinfo2build.keys()
            
        # -------------------------------------------------------------------------------------
        # BUILD INFO OF OPU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2build4opu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                opu2build [key2task] = opu2build4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-opu2build-set-by-get2buildinfo4opu to: " + str(opu2build [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2build4opu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2build-using-by-get2build4opu: " + str(task4getinfo2build)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; opu2build4xi-using-by-get2build4opu: " + str(opu2build4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE BUILD           
            # -------------------------------------------------------------------------------------           
            opu2build = {}
            message2print = "{(Step 1F/33) initialized" + "; opu2build-initialized-by-get2buildinfo4opu to: " + str(opu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2build is None:
                opu2build = opu2build4xi
                message2print = "{(Step 1G/33) set" + "; opu2build-set-by-get2buildinfo4opu to: " + str(opu2build)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2build.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2build4opu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        opu2build [key2task] = opu2build4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-opu2build -set-by-get2buildinfo4opu to: " + str(opu2build  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2build4opu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            opu2build = {}
            message2print = "{(Step 1Z3/70) yielded" + "; opu2build-yielded-by-get2build4opu: " + str(opu2build) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
    message2print = "{(Step 33/33) returning" + "; opu2build-returning-by-get2buildinfo4opu: " + str(opu2build) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # 
    
    return opu2build
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelworkgroupinfo4opu" usage = "
#     
#   print('(Step 2AB2/700) OF OPU2KERNEL4XI5TEST - TRYING TO GET KERNEL WORK GROUP INFORMATION ', time4xi())           
#   try:
#       response4link = get2kernelworkgroupinfo4opu()
#       print('(Step 2BB2/700) OF OPU2KERNEL4XI5TEST - GOT KERNEL WORK GROUP INFORMATION ', time4xi()) 
#   except:
#       print('(Step 2Z2/700) OF OPU2KERNEL4XI5TEST *** FAILED TO KERNEL WORK GROUP INFORMATION ', time4xi())                                                                     
#          
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelworkgroupinfo4opu(task4kernelworkgroupinfo2opu=None):

    '''
    gets kernel workgroup info of OPU
    '''
    global opu2kernel4xi                                                                                            # Kernel of OPU    
    global import2use4opu                                                                                           # Imports of OPU
    global target2function4opu                                                                                      # Target function of Process4Xi
    global folder2lib4opu  
            
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelworkgroupinfo4opu" 
    method2print = "get2kernelworkgroupinfo4opu"

    message2print = "{(Step 1A/70) started" + "; get2kernelworkgroupinfo4opu-started: " + str(get2kernelworkgroupinfo4opu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernelworkgroupinfo2opu-to-get2kernelworkgroupinfo4opu: " + str(task4kernelworkgroupinfo2opu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    process2kernelworkgroupinfo4opu = {}                                                                                       # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4kernelworkgroupinfo2opu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER
            # -----------------------------------------------------------------------------------------    
            pass                                                                       
        else:
            # -----------------------------------------------------------------------------------------
            # PARAMETERS GIVEN ARE OMITTED 
            # -----------------------------------------------------------------------------------------         
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4kernelworkgroupinfo2opu-yielded-by-get2kernelworkgroupinfo4opu: " + str(task4kernelworkgroupinfo2opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
       
        code2nack  = code2nack + '1Z1-' 

    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - LINK SOURCES INSIDE PROGRAM OBJECT FOR OPU ! 
    # ---------------------------------------------------------------------------------------------    
    process2kernelworkgroupinfo4opu = {}                                                                                                                                                                               
    message2print = "{(Step 20A/70) initialized" + "; process2kernelworkgroupinfo4opu-initialized-by-get2kernelworkgroupinfo4opu to: " + str(process2kernelworkgroupinfo4opu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}

    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) - SOURCE CODE WITHOUT EOL CHARACTERS                  
        # ---------------------------------------------------------------------------------------------             
        keys2code4opu = opu2kernel4xi['CODE4SOURCE'].keys()
        message2print = "{(Step 30A/70) using" + "; keys2code4opu-using-by-get2kernelworkgroupinfo4opu: " + str(keys2code4opu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # dict_keys([folder2lib4opu + 'opu2sampler4xi5test.py'])
        
        unit4processing = "opu"
        
        for key2code4opu in keys2code4opu:
            index2search=str.find(key2code4opu,unit4processing) 
            if index2search == -1:
                pass
            else:
                target2link = key2code4opu[index2search:]                                                          # opu2sampler4xi5test.py
                index2search=str.find(target2link,".py")
                if index2search == -1:
                    pass
                else:
                    target2link4opu = target2link[:index2search]                                                  
                    message2print = "{(Step 32A/70) set" + "; target2link4opu-set-by-get2kernelworkgroupinfo4opu to: " + str(target2link4opu)  + "; time: " + time4xi() + "}"  
                    print4xi(class2print, method2print, message2print)
                    # opu2sampler4xi5test

                    p2code4opu = None    
                    try:
                        # ---------------------------------------------------------------------------------------------    
                        # IMPORT TARGET FUNCTION FROM ITS MODULE AS TARGET2FUNCTION4OPU 
                        # ---------------------------------------------------------------------------------------------    
      
                        try:
                            import2use4opu.get(target2link4opu, handle2error4opu) ()
                            
                            message2print = "{(Step 32B/70) imported" + "; target2link4opu-imported-by-get2kernelworkgroupinfo4opu: " + str(target2link4opu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # opu2sampler4xi5test
                            code2ack  = code2ack + '32B-'
                        except:
                            message2print = "{(Step 32Z1/70) failed" + "; import2use4opu-failed-by-get2kernelworkgroupinfo4opu: " + str(import2use4opu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                            # 
                            message2print = "{(Step 32Z2/70) used" + "; target2link4opu-used-by-get2kernelworkgroupinfo4opu: " + str(target2link4opu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2nack  = code2nack + '32Z2-'
                                    
                        # ---------------------------------------------------------------------------------------------    
                        # CREATE PROCESS WITH TARGET2FUNCTION4OPU
                        # ---------------------------------------------------------------------------------------------                          
                        p2opu = Process4Xi(target=target2function4opu, args=())                                
                        message2print = "{(Step 33A/70) created" + "; p2opu-created-by-get2kernelworkgroupinfo4opu: " + str(p2opu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # <Process4Xi(Process4Xi-2, initial)>
                        
                        process2kernelworkgroupinfo4opu[key2code4opu] = p2opu
                        
                        code2ack  = code2ack + '33A-'
                        try:
                            # ---------------------------------------------------------------------------------------------    
                            # START PROCESS
                            # --------------------------------------------------------------------------------------------- 
                            p2opu.start()
                            message2print = "{(Step 34A/70) started" + "; p2opu-started-by-get2kernelworkgroupinfo4opu: " + str(p2opu.name) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # Process4Xi-2
                            
                            try:
                                # ---------------------------------------------------------------------------------------------    
                                # STATUS OF PROCESS
                                # ---------------------------------------------------------------------------------------------                             
                                status2process4opu = p2opu.is_alive()
                                message2print = "{(Step 35A/70) got" + "; status-got-by-get2kernelworkgroupinfo4opu: " + str(status2process4opu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # True
                                
                                try:
                                    # ---------------------------------------------------------------------------------------------    
                                    # RUN PROCESS
                                    # ---------------------------------------------------------------------------------------------                                  
                                    p2opu.run()
                                    message2print = "{(Step 36A/70) run" + "; p2opu-run-by-get2kernelworkgroupinfo4opu: " + str(p2opu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # <Process4Xi(Process4Xi-1, stopped[1])>
                                except:
                                    message2print = "{(Step 36Z/70) failed" + "; run-failed-by-get2kernelworkgroupinfo4opu: " + str(p2opu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)  
                                    code2nack  = code2nack + '36Z-'            
                                    # 
                            except:
                                message2print = "{(Step 35Z/70) failed" + "; status-failed-by-get2kernelworkgroupinfo4opu: " + str(p2opu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # 
                                code2nack  = code2nack + '35Z-'                                   
                                
                        except:
                            message2print = "{(Step 33Z/70) failed" + "; start-failed-by-get2kernelworkgroupinfo4opu: " + str(p2opu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)  
                            code2nack  = code2nack + '33Z-'     
                        
                    except:
                        message2print = "{(Step 32Z/70) failed" + "; p2code4opu-failed-by-get2kernelworkgroupinfo4opu: " + str(p2code4opu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        code2nack  = code2nack + '32Z-' 
                                                                                    

 
        message2print = "{(Step 38A/70) set" + "; process2kernelworkgroupinfo4opu-set-by-get2kernelworkgroupinfo4opu to: " + str(process2kernelworkgroupinfo4opu)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '38A-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; code-yielded-by-get2kernelworkgroupinfo4opu: " + str(opu2kernel4xi['CODE4SOURCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '30Z1-'     

                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    opu2kernel4xi ['ACK2RETURN']  = code2ack
    opu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; process2kernelworkgroupinfo4opu-returning-by-get2kernelworkgroupinfo4opu: " + str(process2kernelworkgroupinfo4opu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 
    return process2kernelworkgroupinfo4opu
            
#</function4xi> 
 
                                        
# =================================================================================================
#<class4xi class = "OPU2Kernel4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for OPU kernels" usage = "Kernel4Xi of OPU"
#>

# =================================================================================================
class OPU2Kernel4Xi(object): 
    ''' 
    OPU2Kernel4Xi offers  methods for OPU kernels
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2opu = cpu_corecount4xi()
    #"
    #/>
       
       
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
            'add2kernel',                      # ACK              

            'execute2kernel',                  # ACK 5.8    p169                                             
            'execute2task',                    # ACK 5.8    p172   
            'execute2nativekernel',            # ACK 5.8    p174     
            
            'create2kernel',                   # ACK 5.7.1  p157   
            'create2kernelsinprogram',         # ACK 5.7.1  p158  
                       
            'delete2kernel',                   # ACK

            'fetch2kernel',                    # ACK 
            
            'get2kernelinfo',                  # ACK 5.7.3  p162  
            'get2kernelworkgroupinfo',         # ACK 5.7.3  p164  
            'get2kernelarginfo',               # ACK 5.7.3  p166                                  
            
            'release2kernel',                  # ACK 5.7.1  p159                                         
            'retain2kernel',                   # ACK 5.7.1  p159   
 
            'set2kernel',                      # ACK 
            'set2kernelcallback',              # ACK 
            'set2kernelarg',                   # ACK 5.7.2  p160 
                                          
            'trace2kernel',                    # ACK 
            
            'sense',                           # ACK
            'reason',                          # ACK
            'ace')                             # ACK   
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-OPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 110A/700) OF OPU2KERNEL4XI5TEST - CREATING KERNEL OBJECT OF OPU ', time4xi())        
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # CREATE WITH OBJECT                  
    #       # ---------------------------------------------------------------------------------------------        
    #       kernelobject2opu = OPU2Kernel4Xi()
    #       print('(Step 110B/700) OF OPU2KERNEL4XI5TEST - CREATED KERNEL OBJECT OF OPU: ', kernelobject2opu)                                  
    #       # 
    #   except:
    #       print('(Step 110Z/700) OF OPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL OBJECT OF OPU') 
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4kernel2opu = None):
        '''
        _init__ method initializes OPU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "OPU2Kernel4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-OPU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 

        message2print = "{(Step 1B/33) borning" + "; opu2kernel2xi-of-OPU2Kernel4Xi-borning: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-opu2kernel2xi-of-OPU2Kernel4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'>
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2opu-sharing-by-opu2kernel2xi-of-OPU2Kernel4Xi: " + str(OPU2Kernel4Xi.classvariable2opu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 4        
                                
        message2print = "{(Step 1E/33) passed" + "; task4kernel2opu-passed-to-init-of-OPU2Kernel4Xi: " + str(task4kernel2opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None                      
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
    
        message2print = "{(Step 2A/33) passing" + "; task4kernel2opu-passing-to-create2kernel4opu-by-init-of-OPU2Kernel4Xi: " + str(task4kernel2opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None  
                
        opu2kernel2xi = create2kernel4opu(task4kernel2opu)
        
        message2print = "{(Step 2B/33) performed" + "; create2kernel4opu-performed-by-init-of-OPU2Kernel4Xi: " + str(create2kernel4opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <function create2kernel4opu at 0x00000000041E54C8>
       
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; opu2kernel2xi-of-OPU2Kernel4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-opu2kernel2xi-of-OPU2Kernel4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2opu-shared-by-opu2kernel2xi-of-OPU2Kernel4Xi: " + str(OPU2Kernel4Xi.classvariable2opu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #     
       
        message2print = "{(Step 3D/33) returning" + "; init-of-OPU2Kernel4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "add2kernel-of-OPU2Kernel4Xi" usage = "
    #  
    #   print('(Step 132A/700) OF OPU2KERNEL4XI5TEST - TRYING TO ADD KERNEL TO OPU  WITH METHOD', time4xi())         
    #   try:
    #       task4add2kernel ['CODE4KERNEL'] [folder2lib4opu + 'opu2dummy4xi.py'] = {}
    #       task4add2kernel ['CODE4KERNEL'] [folder2lib4opu + 'opu2dummy4xi.py'] [1] = '... profile = "11" />'
    #
    #       response4add2kernel = programobject2opu.add2kernel(task4add2kernel) 
    #       print('(Step 132B/700) OF OPU2KERNEL4XI5TEST - ADDED KERNEL TO OPU  WITH METHOD', time4xi())
    #   except:
    #       print('(Step 132Z1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO ADD KERNEL TO OPU WITH METHOD *** ', time4xi())
    #  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def add2kernel(self, task4add2kernel = None):
        '''
        adds kernel to OPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "OPU2Kernel4Xi"
        method2print = "add2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; add2kernel-of-OPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4add2kernel-passed-to-add2kernel-of-OPU2Kernel4Xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4add2kernel-passing-to-add2kernel4opu-by-add2kernel-of-OPU2Kernel4Xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        response4add2kernel = add2kernel4opu(task4add2kernel)

        message2print = "{(Step 2B/33) performed" + "; add2kernel4opu-performed-by-add2kernel-of-OPU2Kernel4Xi: " + str(add2kernel4opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4add2kernel-returning-by-add2kernel-of-OPU2Kernel4Xi: " + str(response4add2kernel) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return response4add2kernel
                                
                            
    #</methodize4xi>    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2task-of-OPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 240A/700) OF OPU2KERNEL4XI5TEST - TRYING TO EXECUTE TASK OF OPU WITH METHOD ', time4xi())    
    #   try:                               
    #       response4execute2task = programobject2opu.execute2task() 
    #       print('(Step 240B/700) OF OPU2KERNEL4XI5TEST - EXECUTED TASK OF OPU WITH METHOD ', time4xi())
    #   except:
    #       print('(Step 240Z1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO EXECUTE TASK OF OPU WITH METHOD ', time4xi())
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def execute2task(self, task4execute = None):
        '''
        executes task of kernel of OPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "OPU2Kernel4Xi"
        method2print = "execute2task"
                     
        message2print = "{(Step 1A/33) started" + "; execute2task-of-OPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4execute-passed-to-create-of-OPU2Kernel4Xi: " + str(task4execute) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute-passing-to-execute2task4opu-by-execute2task-of-OPU2Kernel4Xi: " + str(task4execute) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        opu2program2xi = execute2task4opu(task4execute)

        message2print = "{(Step 2B/33) performed" + "; execute2task4opu-performed-by-execute2task-of-OPU2Kernel4Xi: " + str(execute2task4opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; opu2program2xi-returning-by-execute2task-of-OPU2Kernel4Xi: " + str(opu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return opu2program2xi
                     
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2nativekernel-of-OPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 121A1/700) OF OPU2KERNEL4XI5TEST - TRYING TO EXECUTE KERNEL OF OPU ', time4xi())      
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # COMPILE                        
    #       # ---------------------------------------------------------------------------------------------        
    #       response4compile = executeobject2opu.execute2nativekernel()
    #       print('(Step 121A2/700) OF OPU2KERNEL4XI5TEST - EXECUTED KERNEL OF OPU', time4xi())                                   
    #   except:
    #       print('(Step 121AZ1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO EXECUTE KERNEL OF OPU', time4xi())   
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def execute2nativekernel(self, task4execute2kernel = None):
        '''
        executes native kernel of OPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "OPU2Kernel4Xi"
        method2print = "execute2nativekernel"
                     
        message2print = "{(Step 1A/33) started" + "; execute2nativekernel-of-OPU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2kernel-passed-to-create-of-OPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2kernel-passing-to-execute2nativekernel4opu-by-execute2nativekernel-of-OPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        opu2execute2xi = execute2nativekernel4opu(task4execute2kernel)

        message2print = "{(Step 2B/33) performed" + "; execute2nativekernel4opu-performed-by-execute2nativekernel-of-OPU2Kernel4Xi: " + str(execute2nativekernel4opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; opu2execute2xi-returning-by-execute2nativekernel-of-OPU2Kernel4Xi: " + str(opu2execute2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return opu2execute2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelworkgroupinfo-of-OPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 121C1/700) OF OPU2KERNEL4XI5TEST - TRYING TO GET WORK GROUP INFOR OF OPU WITH METHOD ', time4xi())      
    #   try:
    #      
    #       response4getworkgroupinfo = programobject2opu.get2kernelworkgroupinfo()
    #       print('(Step 121C2/700) OF OPU2KERNEL4XI5TEST - GOT WORK GROUP INFOR OF OPU WITH METHOD ', time4xi())                                   
    #   except:
    #       print('(Step 121CZ1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO GET WORK GROUP INFOR OF OPU WITH METHOD ', time4xi())  
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelworkgroupinfo(self, task4getworkgroupinfo = None):
        '''
        get kernel work group info OF OPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "OPU2Kernel4Xi"
        method2print = "get2kernelworkgroupinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelworkgroupinfo-of-OPU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4getworkgroupinfo-passed-to-create-of-OPU2Kernel4Xi: " + str(task4getworkgroupinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4getworkgroupinfo-passing-to-get2kernelworkgroupinfo4opu-by-get2kernelworkgroupinfo-of-OPU2Kernel4Xi: " + str(task4getworkgroupinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        opu2program2xi = get2kernelworkgroupinfo4opu(task4getworkgroupinfo)

        message2print = "{(Step 2B/33) performed" + "; get2kernelworkgroupinfo4opu-performed-by-get2kernelworkgroupinfo-of-OPU2Kernel4Xi: " + str(get2kernelworkgroupinfo4opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; opu2program2xi-returning-by-get2kernelworkgroupinfo-of-OPU2Kernel4Xi: " + str(opu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return opu2program2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2kernel-of-OPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 190A/700) OF OPU2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR OPU ', time4xi()) 
    #   try:
    #       kernelobject2opu = OPU2Kernel4Xi()                            
    #       response4create2kernel = kernelobject2opu.create2kernel()
    #       print('(Step 190B/700) OF OPU2KERNEL4XI5TEST - CREATED KERNEL FOR OPU ', time4xi())
    #   except:
    #       print('(Step 190Z1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR OPU ', time4xi())                                    
    #           
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2kernel(self, task4kernel2create = None):
        '''
        create2kernel method creates kernel objects of OPU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "OPU2Kernel4Xi"
        method2print = "create2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; create2kernel-of-OPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #  
            
        message2print = "{(Step 1B/33) passed" + "; task4kernel2create-passed-to-create-of-OPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4kernel2create-passing-to-create2kernel4opu-by-create2kernel-of-OPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #  
  
        opu2kernel2xi = create2kernel4opu(task4kernel2create)

        message2print = "{(Step 2B/33) performed" + "; create2kernel4opu-performed-by-create2kernel-of-OPU2Kernel4Xi: " + str(create2kernel4opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2kernel4opu at 0x0000000003B0C5C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        keys2response4create = opu2kernel2xi.keys() 
        message2print = "{(Step 33A/33) returning" + "; keys2response4create-returning-by-create2kernel-of-OPU2Kernel4Xi: " + str(keys2response4create) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                         
        # ['FUNCTION',
        #  'CODE2ERROR',
        #  'COUNT2REFERENCE',
        #  'DATA2CALLBACK',
        #  'BUFFER',
        #  'FUNCTION2CALLBACK',
        #  'ACK2RETURN',
        #  'QUEUE',
        #  'PLATFORM',
        #  'PROGRAM',
        #  'NACK2RETURN',
        #  'CONTEXT',
        #  'COMMANDQUEUE',
        #  'DEVICE',
        #  'EVENT',
        #  'PIPE']
        message2print = "{(Step 33B/33) returning" + "; function-returning-by-create2kernel-of-OPU2Kernel4Xi: " + str(opu2kernel2xi['FUNCTION']) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # opu2sampler4xi5test 
        
        return opu2kernel2xi
                                
    #                        
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2kernelsinprogram-of-OPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 130A/700) OF OPU2KERNEL4XI5TEST - CREATING KERNELS IN PROGRM FOR OPU ', time4xi())      
    #   try:
    #       response4create2kernelsinprogram = kernelobject2opu.create2kernelsinprogram()
    #       print('(Step 130A/700) OF OPU2KERNEL4XI5TEST - CREATED KERNELS IN PROGRM FOR OPU ', time4xi())
    #   except:
    #       print('(Step 130Z1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO KERNELS IN PROGRM FOR OPU', time4xi())
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2kernelsinprogram(self, task4kernel2create = None):
        '''
        creates kernels in program of OPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "OPU2Kernel4Xi"
        method2print = "create2kernelsinprogram"
                     
        message2print = "{(Step 1A/33) started" + "; create2kernelsinprogram-of-OPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4kernel2create-passed-to-create-of-OPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4kernel2create-passing-to-create2kernelsinprogram4opu-by-create2kernelsinprogram-of-OPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        opu2kernel2xi = create2kernelsinprogram4opu(task4kernel2create)

        message2print = "{(Step 2B/33) performed" + "; create2kernelsinprogram4opu-performed-by-create2kernelsinprogram-of-OPU2Kernel4Xi: " + str(create2kernelsinprogram4opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2kernelsinprogram4opu at 0x00000000040248C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; opu2kernel2xi-returning-by-create2kernelsinprogram-of-OPU2Kernel4Xi: " + str(opu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return opu2kernel2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "delete2kernel-of-OPU2Kernel4Xi" usage = "
    #  
    #   print('(Step 134A/700) OF OPU2KERNEL4XI5TEST - TRYING TO DELETE KERNEL IN PROGRAM OF OPU WITH METHOD ', time4xi())        
    #   try:
    #       task4delete2kernel = {}
    #       task4delete2kernel ['CODE4KERNEL'] = {}
    #       task4delete2kernel ['CODE4KERNEL'] [folder2lib4opu + 'dummy3image4xi..py'] = 'Yes'
    #       task4delete2kernel ['SIZE4KERNEL'] = {}
    #       task4delete2kernel ['SIZE4KERNEL'] [folder2lib4opu + 'dummy3image4xi..py'] = 'Yes'
    #       
    #       response4delete2kernel = programobject2opu.delete2kernel(task4delete2kernel)
    #       print('(Step 134B/700) OF OPU2KERNEL4XI5TEST - DELETED DELETE KERNEL IN PROGRAM of OPUWITH METHOD ', time4xi())                                                                  
    #   except:
    #       print('(Step 134Z1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO DELETE DELETE KERNEL IN PROGRAM OF OPU WITH METHOD *** ', time4xi())
    #                  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def delete2kernel(self, task4delete2kernel = None):
        '''
        deletes kernel in program of OPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "OPU2Kernel4Xi"
        method2print = "delete2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; delete2kernel-of-OPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4delete2kernel-passed-to-delete2kernel-of-OPU2Kernel4Xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4delete2kernel-passing-to-delete2kernel4opu-by-delete2kernel-of-OPU2Kernel4Xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        response4delete2kernel = delete2kernel4opu(task4delete2kernel)

        message2print = "{(Step 2B/33) performed" + "; delete2kernel4opu-performed-by-delete2kernel-of-OPU2Kernel4Xi: " + str(delete2kernel4opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4delete2kernel-returning-by-delete2kernel-of-OPU2Kernel4Xi: " + str(response4delete2kernel) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return response4delete2kernel
                                
                            
    #</methodize4xi>    


        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernel-of-OPU2Kernel4Xi" usage = "
    # 
    #   ... prepare task4set2kernel ...
    #   print('(Step 158A/700) OF OPU2KERNEL4XI5TEST - TRYING TO SET KERNEL OF OPU: ', time4xi()) 
    #   try: 
    #       response4set2kernel = kernelobject2opu.set2kernel(task4set2kernel)
    #       print('(Step 158B/700) OF OPU2KERNEL4XI5TEST - SET KERNEL OF OPU: ', time4xi())    
    #   except:
    #       print('(Step 158Z1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL OF OPU: ', time4xi())
    #       
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernel(self, task4set2kernel = None):
        '''
        sets kernel OPU objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "OPU2Kernel4Xi"
        method2print = "set2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernel-of-OPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernel-passed-to-set2kernel-of-OPU2Kernel4Xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernel-passing-to-set2kernel4opu-by-set2kernel-of-OPU2Kernel4Xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        opu2kernel2xi = set2kernel4opu(task4set2kernel)

        message2print = "{(Step 2B/33) performed" + "; set2kernel4opu-performed-by-set2kernel-of-OPU2Kernel4Xi: " + str(set2kernel4opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; opu2kernel2xi-returning-by-set2kernel-of-OPU2Kernel4Xi: " + str(opu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return opu2kernel2xi
                             
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernelarg-of-OPU2Kernel4Xi" usage = "
    # 
    #   ... prepare task4set2kernelarg ...
    #   print('(Step 158A/700) OF OPU2KERNEL4XI5TEST - TRYING TO SET KERNEL ARGUMENTS FOR OPU: ', time4xi())
    #   try: 
    #       response4set2kernelarg = programobject2opu.set2kernelarg(task4set2kernelarg)
    #       print('(Step 158B/700) OF OPU2KERNEL4XI5TEST - SET KERNEL ARGUMENTS FOR OPU ', time4xi())    
    #   except:
    #       print('(Step 158Z1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL ARGUMENTS FOR OPU ', time4xi())
    #       
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernelarg(self, task4set2kernelarg = None):
        '''
        sets kernel arguments for OPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "OPU2Kernel4Xi"
        method2print = "set2kernelarg"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernelarg-of-OPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernelarg-passed-to-set2kernelarg-of-OPU2Kernel4Xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernelarg-passing-to-set2kernelarg4opu-by-set2kernelarg-of-OPU2Kernel4Xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        opu2program2xi = set2kernelarg4opu(task4set2kernelarg)

        message2print = "{(Step 2B/33) performed" + "; set2kernelarg4opu-performed-by-set2kernelarg-of-OPU2Kernel4Xi: " + str(set2kernelarg4opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; opu2program2xi-returning-by-set2kernelarg-of-OPU2Kernel4Xi: " + str(opu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return opu2program2xi
                             
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelinfo-of-OPU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A/700) OF OPU2KERNEL4XI5TEST - TRYING TO GET KERNEL INFO ', time4xi())    
    #   try:                               
    #       response4get2kernelinfo = kernelobject2opu.get2kernelinfo()                                 
    #       print('(Step 106B/700) OF OPU2KERNEL4XI5TEST - GOT GET KERNEL INFO ', time4xi())                             
    #   except:
    #       print('(Step 106Z/700) OF OPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL INFO ', time4xi()) 
    #   
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelinfo(self, task4getinfo2kernel=None):
        '''
        gets kernel info of OPU 
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "OPU2Kernel4Xi"
        method2print = "get2kernelinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelinfo-of-OPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        opu2kernel2xi = get2kernelinfo4opu(task4getinfo2kernel)
        
        message2print = "{(Step 2A/33) returning" + "; opu2kernel2xi-returning-by-get2kernelinfo-of-OPU2Kernel4Xi: " + str(opu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 

        return opu2kernel2xi
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelarginfo-of-OPU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A/700) OF OPU2KERNEL4XI5TEST - TRYING TO GET KERNEL ARGUMENT INFO OF OPU ', time4xi())    
    #   try:                               
    #       response4get2kernelarginfo = kernelobject2opu.get2kernelarginfo()
    #       print('(Step 106B/700) OF OPU2KERNEL4XI5TEST - GOT KERNEL ARGUMENT INFO OF OPU ', time4xi())                                   
    #   except:
    #       print('(Step 106Z1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL ARGUMENT INFO OF OPU ', time4xi()) 
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelarginfo(self, task4getinfo2kernel=None):
        '''
        gets kernel argument info of OPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "OPU2Kernel4Xi"
        method2print = "get2kernelarginfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelarginfo-of-OPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 05:01:22 11/17/11 Pacific Standard Time

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        opu2kernel2xi = get2kernelarginfo4opu(task4getinfo2kernel)
        
        message2print = "{(Step 2A/33) returning" + "; opu2kernel2xi-returning-by-get2kernelarginfo-of-OPU2Kernel4Xi: " + str(opu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 

        return opu2kernel2xi
                            
    #</methodize4xi>
   
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2buildinfo-of-OPU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A1/700) OF OPU2BUILD4XI5TEST - TRYING TO GET BUILD INFO ', time4xi())    
    #   try:                               
    #                               
    #       response4get2buildinfo = programobject2opu.get2buildinfo()
    #       print('(Step 106A2/700) OF OPU2BUILD4XI5TEST - GOT BUILD INFO ', time4xi())    
    #   except:
    #       print('(Step 106Z1/700) OF OPU2BUILD4XI5TEST *** FAILED TO GET BUILD INFO ', time4xi()) 
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2buildinfo(self, task4getinfo2build=None):
        '''
        get2buildinfo method gets objects of OPU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "OPU2Kernel4Xi"
        method2print = "get2buildinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2buildinfo-of-OPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        opu2build2xi = get2buildinfo4opu(task4getinfo2build)
        
        message2print = "{(Step 2A/33) returning" + "; opu2build2xi-returning-by-get2buildinfo-of-OPU2Kernel4Xi: " + str(opu2build2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        return opu2build2xi
                            
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2kernel-of-OPU2Kernel4Xi" usage = "
    #
    #   print('(Step 170A/700) OF OPU2KERNEL4XI5TEST - RELEASING KERNEL ', time4xi())  
    #   task4release2kernel  = {}
    #   task4release2kernel  ['COUNT2REFERENCE'] = 1
    #   try:
    #       response4release2kernel = kernelobject2opu.release2kernel(task4release2kernel)
    #       print('(Step 170B/700) OF OPU2KERNEL4XI5TEST - RELEASED KERNEL ', time4xi())
    #   except:
    #       print('(Step 170Z1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL ', time4xi())                        
    #       keys2response = response4release2kernel.keys()
    #  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def release2kernel(self, task4release2kernel = None):
        '''
        releases OPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "OPU2Kernel4Xi"
        method2print = "release2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; release2kernel-of-OPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4release2kernel-passed-to-release2kernel-of-OPU2Kernel4Xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2kernel-passing-to-release2kernel4opu-by-release2kernel-of-OPU2Kernel4Xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        opu2kernel2xi = release2kernel4opu(task4release2kernel)

        message2print = "{(Step 2B/33) performed" + "; release2kernel4opu-performed-by-release2kernel-of-OPU2Kernel4Xi: " + str(release2kernel4opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; opu2kernel2xi-returning-by-release2kernel-of-OPU2Kernel4Xi: " + str(opu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #               
                
        return opu2kernel2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2kernel-of-OPU2Kernel4Xi" usage = "
    #
    #   print('(Step 180A/700) OF OPU2KERNEL4XI5TEST - RETAINING KERNEL ', time4xi())
    #   task4retain2kernel  = {}
    #   task4retain2kernel  ['COUNT2REFERENCE'] = 1
    #   try:
    #       response4retain2kernel = kernelobject2opu.retain2kernel(task4retain2kernel)
    #       print('(Step 180B/700) OF OPU2KERNEL4XI5TEST - RETAINED KERNEL ', time4xi())
    #   except:
    #       print('(Step 180Z1/700) OF OPU2KERNEL4XI5TEST *** FAILED TO RETAIN KERNEL ', time4xi())                    
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def retain2kernel(self, task4retain2kernel = None):
        '''
        retains OPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "OPU2Kernel4Xi"
        method2print = "retain2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; retain2kernel-of-OPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
            
        message2print = "{(Step 1B/33) passed" + "; task4retain-passed-to-retain2kernel-of-OPU2Kernel4Xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain-passing-to-retain2kernel4opu-by-retain-of-OPU2Kernel4Xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
  
        opu2kernel2xi = retain2kernel4opu(task4retain2kernel)

        message2print = "{(Step 2B/33) performed" + "; retain2kernel4opu-performed-by-retain2kernel-of-OPU2Kernel4Xi: " + str(retain2kernel4opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; opu2kernel2xi-returning-by-retain2kernel-of-OPU2Kernel4Xi: " + str(opu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
            
                
        return opu2kernel2xi
                                                           
    #</methodize4xi>   
    
 
                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "trace2kernel-of-OPU2Kernel4Xi" usage = "
    #     
    #   print('(Step 210A/25) OF OPU2KERNEL4XI5TEST - TRYING TO TRACE OPU: ', time4xi())      
    #   trace2opu = None
    #   try:
    #       trace2opu = programobject2opu.trace2kernel() 
    #               print('(Step 210B/25) OF OPU2KERNEL4XI5TEST - TRACE2OPU: ', trace2opu)  
    #       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4opu-failed {}; time: 04:40:24 11/16/11 Pacific Standard Time}', 'CLASS': 'trace2kernel4opu', 'METHOD': 'trace2kernel4opu'}
    #        except:
    #           print('(Step 210Z1/25) OF OPU2KERNEL4XI5TEST *** FAILED TO TRACE OPU: ', trace2opu) 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def trace2kernel(self, task4trace2kernel = None):
        '''
        traces OPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "OPU2Kernel4Xi"
        method2print = "trace2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; trace2kernel-of-OPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
         
            
        message2print = "{(Step 1B/33) passed" + "; task4trace2kernel-passed-to-trace-of-OPU2Kernel4Xi: " + str(task4trace2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
         
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4trace2kernel-passing-to-trace2kernel4opu-by-trace2kernel-of-OPU2Kernel4Xi: " + str(task4trace2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
         
  
        trace2xi = trace2kernel4opu(task4trace2kernel)

        message2print = "{(Step 2B/33) performed" + "; trace2kernel4opu-performed-by-trace2kernel-of-OPU2Kernel4Xi: " + str(trace2kernel4opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-trace2kernel-of-OPU2Kernel4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #       
                
        return trace2xi
                                                           
    #</methodize4xi>       

                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2kernel-of-OPU2Kernel4Xi" usage = "
    #        
    #   print('(Step 220A/25) OF OPU2KERNEL4XI5TEST - TRYING TO UNLOAD COMPILER OF OPU: ', time4xi())      
    #   try:
    #       response4execute2kernel = programobject2opu.execute2kernel() 
    #       print('(Step 220B/25) OF OPU2KERNEL4XI5TEST - UNLOADED COMPILER OF OPU: ', response4execute2kernel)  
    #       # 
    #   except:
    #       print('(Step 220Z1/25) OF OPU2KERNEL4XI5TEST *** FAILED TO TO UNLOAD COMPILER OF OPU: ', time4xi()) 
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def execute2kernel(self, task4execute2kernel = None):
        '''
        executes kernel
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "OPU2Kernel4Xi"
        method2print = "execute2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; execute2kernel-of-OPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
         
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2kernel-passed-to-trace-of-OPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
         
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2kernel-passing-to-execute2kernel4opu-by-execute2kernel-of-OPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
         
  
        trace2xi = execute2kernel4opu(task4execute2kernel)

        message2print = "{(Step 2B/33) performed" + "; execute2kernel4opu-performed-by-execute2kernel-of-OPU2Kernel4Xi: " + str(execute2kernel4opu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-execute2kernel-of-OPU2Kernel4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #       
                
        return trace2xi
                                                           
    #</methodize4xi>       

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernelcallback-of-OPU2Kernel4Xi" usage = "
    #
    #   print('(Step 200A/700) OF OPU2KERNEL4XI5TEST - TRYING TO SET KERNELCALLBACK WITH METHOD OF OBJECT XI2OPU: ', programobject2opu) 
    #   try:
    #       callback2opu = programobject2opu.set2kernelcallback()                                  
    #       print('(Step 200B/700) OF OPU2KERNEL4XI5TEST - SET KERNELWITH CALLBACK TO: ', callback2opu)
    #       # 
    #   except:
    #       print('(Step 200Z/700) OF OPU2KERNEL4XI5TEST *** FAILED TO SET KERNELCALLBACK WITH METHOD ***', time4xi())
    #
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernelcallback(self, task4set2kernelcallback = None): 
        '''
        set2kernelcallback of OPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "OPU2Kernel4Xi"
        method2print = "set2kernelcallback"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernelcallback-of-OPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernelcallback-passed-to-set2kernelcallback-of-OPU2Kernel4Xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None 
           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernelcallback-passing-to-set2kernelcallback-by-set2kernelcallback-of-OPU2Kernel4Xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        
        callback2opu4program = {} 
        try:
            callback2opu4program = set2kernelcallback4opu (task4set2kernelcallback)

            
        except:
            message2print = "{(Step 4A/33) failed" + "; callback2opu4program-failed-by-set2kernelcallback-of-OPU2Kernel4Xi: " + str(callback2opu4program) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                                            
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; callback2opu4program-returning-by-set2kernelcallback-of-OPU2Kernel4Xi: " + str(callback2opu4program) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # <function trace2kernel4opu at 0x00000000038CF5C8> 
        
                                             
        return callback2opu4program
                                                           
    #</methodize4xi>     
    
                                                              
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-OPU2Kernel4Xi" usage = "
    #
    #   print('(Step 310A/700) OF OPU2KERNEL4XI5TEST - SENSING ', time4xi())  
    #   try:
    #       print(programobject2opu.sense())
    #       print('(Step 310B/700) OF OPU2KERNEL4XI5TEST - SENSED ', time4xi()) 
    #       # 
    #   except:
    #       print('(Step 310Z/700) OF OPU2KERNEL4XI5TEST *** FAILED TO SENSE ', time4xi())     
    #
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses OPU2Kernel4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'OPU2Kernel4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-OPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; OPU2Kernel4Xi-sensing-by-sense-of-OPU2Kernel4Xi: " + str(OPU2Kernel4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # 
            
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-OPU2Kernel4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
         
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2opu-of-OPU2Kernel4Xi'] = OPU2Kernel4Xi.classvariable2opu
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-OPU2Kernel4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; OPU2Kernel4Xi-sensed-by-sense-of-OPU2Kernel4Xi: " + str(OPU2Kernel4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-OPU2Kernel4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
                   
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-OPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 320A/700) OF OPU2KERNEL4XI5TEST - REASONING ', time4xi())
    #   try:
    #       print(programobject2opu.reason())
    #       print('(Step 320B/700) OF OPU2KERNEL4XI5TEST - REASONED ', time4xi())
    #       # 
    #   except:
    #       print('(Step 320Z/700) OF OPU2KERNEL4XI5TEST *** FAILED TO REASON ', time4xi()) 
    #
    #">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons OPU2Kernel4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'OPU2Kernel4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-OPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; OPU2Kernel4Xi-reasoning-by-reason-of-OPU2Kernel4Xi: " + str(OPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-OPU2Kernel4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
             
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-OPU2Kernel4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-OPU2Kernel4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; OPU2Kernel4Xi-reasoned-by-reason-of-OPU2Kernel4Xi: " + str(OPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-OPU2Kernel4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #           
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-OPU2Kernel4Xi" usage = "
    #
    #   print('(Step 330A/700) OF OPU2KERNEL4XI5TEST - ACING ', time4xi())   
    #   try:
    #       print(programobject2opu.ace())
    #       print('(Step 330B/700) OF OPU2KERNEL4XI5TEST - ACED ', time4xi())                                                 
    #       # 
    #   except:
    #       print('(Step 330Z/700) OF OPU2KERNEL4XI5TEST *** FAILED TO ACE ', time4xi())                                 
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces OPU2Kernel4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'OPU2Kernel4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-OPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; OPU2Kernel4Xi-acing-by-ace-of-OPU2Kernel4Xi: " + str(OPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #      
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-OPU2Kernel4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-OPU2Kernel4Xi'] = OPU2Kernel4Xi.classvariable2opu
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-OPU2Kernel4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; OPU2Kernel4Xi-aced-by-ace-of-OPU2Kernel4Xi: " + str(OPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'opu2codeprogram4xi.OPU2Kernel4Xi'> 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-OPU2Kernel4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
#</class4xi>

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   opu2codeprogram4xi5test.txt
#   sense-opu2codeprogram4xi5test.xml
#   reason-opu2codeprogram4xi5test.xml
#   ace-opu2codeprogram4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>

# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of opu2kernel4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
